C
C Physical constants. This is the master set. All parameterizations set
C their local values from these values.
C
      common/comcon/cappa,cpvir ,cpwv  ,cpair ,epsilo,
     $              ez   ,gravit,latvap,latice,omega ,
     $              rair ,rearth,rh2o  ,rhoh2o,ra    ,
     $              rga  ,stebol,tmelt ,zvir  ,t0(plev)
C
      real cappa,      ! R/Cp
     $     cpvir,      ! cpwv/cpair - 1
     $     cpwv,       ! Specific heat of water vapor
     $     cpair,      ! Specific heat of dry air
     $     epsilo,     ! Ratio of h2o to dry air molecular weights 
     $     ez,         ! Coriolis expansion coeff -> omega/sqrt(0.375)
     $     gravit,     ! Gravitational acceleration
     $     latvap,     ! Latent heat of vaporization
     $     latice,     ! Latent heat of fusion
     $     omega,      ! Angular velocity of Earth-s rotation
     $     rair,       ! Gas constant for dry air
     $     rearth,     ! Radius of the earth
     $     rh2o,       ! Gas constant for water vapor
     $     rhoh2o,     ! Density of liquid water (STP)
     $     ra,         ! Reciprocal of earth radius
     $     rga,        ! Reciprocal of gravitational acceleration
     $     stebol,     ! Stefan-Boltzmann-s constant
     $     tmelt,      ! Freezing point of water
     $     zvir,       ! rh2o/rair - 1
     $     t0          ! Reference temperature for t-prime computations
C
