c
c compute the value of pspt (included from com/pspect.com)
c

c
c values in this file are based on the following table from
c the plx12 implementation of the parallel spectral ccm
c
c                     T21             T42           T85
c                 pspt   pgspt    pspt   pgspt  pspt   pgspt
c processors 1    253     253      946    946   3741   3741
c            2    132     253      484    946   1892   3741
c            4     72     253      253    946    968   3741
c            8     42     253      138    946    506   3741
c           16     28     253       81    946    276   3741
c           32     22*    253*      54    946    162   3741
c           64     22*    253*      43*   946*   108   3741
c
c added 4/2/93
c          128                      43*   946*    86   3741
c
c added 4/18/94
c                     T63             T170          T213
c                 pspt   pgspt    pspt   pgspt  pspt   pgspt
c processors 1    2080   2080     14706  14706  23005  23005
c            2    1056   2080      7396  14706  11556  23005
c            4     544   2080      3741  14706   5832  23005
c            8     288   2080      1914  14706   2970  23005
c           16     160   2080      1001  14706   1540  23005
c           32      96   2080       546  14706    826  23005
c           64      64   2080       321  14706    472  23005 
c          128      64   2080*      214  14706    300  23005 
c          256                      171  14706    214  23005
c
c * not possible with parallel fft, xpose fft will work
c  Eq. 16 of Walker, Worley, Drake
c   pspt = (R+1) ( M+1- Nx*R/2 ), R = [(M+1)/Nx]
c   where Nx is the number of processors (in longitude direction)
c   and M is the spectral trunctation number.
c

c PP_PTRM PP_PTRN PP_PTRK PP_NPROC_LN

#if   ( PP_PTRM == 21 && PP_PTRN == 21 && PP_PTRK == 21 )
#   ifndef PP_PCCM
#       define PP_PSPT 253
#   else
c    PP_PCCM defined
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT 253
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT 132
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT  72
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT  42
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT  28
#       endif
#       if ( PP_NPROC_LN == 64 )
#           define PP_PSPT  28
#       endif
#   endif
#else
#if   ( PP_PTRM == 42 && PP_PTRN == 42 && PP_PTRK == 42 )
#   ifndef PP_PCCM
#       define PP_PSPT 946
#   else
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT 946
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT 484
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT 253
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT 138
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT  81
#       endif
#       if ( PP_NPROC_LN == 32 )
#           define PP_PSPT  54
#       endif
#       if ( PP_NPROC_LN == 64 )
#           define PP_PSPT  43 
#       endif
#       if ( PP_NPROC_LN == 128 )
#           define PP_PSPT  43
#       endif
#   endif
#else
#if   ( PP_PTRM == 63 && PP_PTRN == 63 && PP_PTRK == 63 )
#   ifndef PP_PCCM
#       define PP_PSPT 2080
#   else
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT 2080
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT 1056
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT 544
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT 288
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT  160
#       endif
#       if ( PP_NPROC_LN == 32 )
#           define PP_PSPT  96
#       endif
#       if ( PP_NPROC_LN == 64 )
#           define PP_PSPT  64 
#       endif
#       if ( PP_NPROC_LN == 128 )
#           define PP_PSPT  64
#       endif
#   endif
#else
#if ( PP_PTRM == 85 && PP_PTRN == 85 && PP_PTRK == 85 )
#   ifndef PP_PCCM
#       define PP_PSPT  3741
#   else
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT  3741
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT  1892
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT   968
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT   506
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT   276
#       endif
#       if ( PP_NPROC_LN == 32 )
#           define PP_PSPT   162
#       endif
#   endif
#else
#if   ( PP_PTRM == 170 && PP_PTRN == 170 && PP_PTRK == 170 )
#   ifndef PP_PCCM
#       define PP_PSPT 14706
#   else
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT 14706
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT 7396
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT 3741
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT 1914
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT 1001
#       endif
#       if ( PP_NPROC_LN == 32 )
#           define PP_PSPT  546
#       endif
#       if ( PP_NPROC_LN == 64 )
#           define PP_PSPT  321
#       endif
#       if ( PP_NPROC_LN == 128 )
#           define PP_PSPT  214
#       endif
#   endif
#else
#if   ( PP_PTRM == 213 && PP_PTRN == 213 && PP_PTRK == 213 )
#   ifndef PP_PCCM
#       define PP_PSPT 23005
#   else
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT 23005
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT 11556
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT 5832
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT 2970
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT  1540
#       endif
#       if ( PP_NPROC_LN == 32 )
#           define PP_PSPT  826
#       endif
#       if ( PP_NPROC_LN == 64 )
#           define PP_PSPT  472
#       endif
#       if ( PP_NPROC_LN == 128 )
#           define PP_PSPT  300
#       endif
#   endif
#else
#if   ( PP_PTRM == 15 && PP_PTRN == 15 && PP_PTRK == 30)
#       if ( PP_NPROC_LN == 1 )
#           define PP_PSPT 256
#       endif
#       if ( PP_NPROC_LN == 2 )
#           define PP_PSPT 128
#       endif
#       if ( PP_NPROC_LN == 4 )
#           define PP_PSPT 64
#       endif
#       if ( PP_NPROC_LN == 8 )
#           define PP_PSPT 32
#       endif
#       if ( PP_NPROC_LN == 16 )
#           define PP_PSPT 16
#       endif
#else
^^^^^^^^^^^^^^^^^ improper decomposition specified ^^^^^^^^^^^^^^^^^^^^
#endif
#endif
#endif
#endif
#endif
#endif
#endif

