c
c     !   Basic grid point resolution parameters
c
#ifdef PP_PCCM
      integer plev,plon,plat,plonp2,plevp,pcnst,plevmx,plond,platd,plevd
      integer nxpt,jintmx,i1,j1,j1m

c parameters added to PCCM2 for mimd dist. mem. parallel implementation
      integer p_glon, p_glat, p_nproc_lt, p_nproc_ln, p_nproc
      integer p_lato2, p_log2plat


c parameters that are set by preprocessor defined constants

      parameter(p_nproc_lt=PP_NPROC_LT,    ! number of processors in lat
     $          p_nproc_ln=PP_NPROC_LN,    ! number of processors in lon
     $          plev=PP_PLEV,              ! number of vertical levels
     $          p_glat=PP_GLAT,            ! number of latitudes
     $          p_glon=PP_GLON )           ! number of longitudes

c parameters whose values are set or derived internally

      parameter(plevp=plev+1,              ! number of vertical interfaces
     $          plat=p_glat/p_nproc_lt,    ! number of local latitudes
     $          plon=p_glon/p_nproc_ln,    ! number of local longitudes
     $          p_lato2=plat/2,            ! 1/2 the number of local latitudes
     $          p_nproc=p_nproc_lt*p_nproc_ln,   ! total number of procs
     $          plonp2=plon+2,             ! length necessary for fft
     $          pcnst=1,                   ! number of constituents
     $          plevmx = 4,                !
#  if ( PP_TRIANG_TRUNC == 170)
     $          nxpt=60,                    !
#  else
     $          nxpt=18,                    !
#  endif
     $          jintmx=2-nxpt,                 !
#  ifdef EVENPADDING
     $          plond=plon + 2 + 2*nxpt, ! slt extended domain longitude
#  else
     $          plond=plon + 1 + 2*nxpt, ! slt extended domain longitude
#  endif
     $          platd=p_lato2 + 2*nxpt + 2*jintmx, ! slt extended domain lat.
     $          plevd=plev*(3+pcnst),      ! fold plev,pcnst indices into one
     $          i1=1+nxpt,               ! model starting longitude (3-d)
     $          j1=1+nxpt+jintmx,        ! model starting latitude (3-d)
     $          j1m=j1-1)                  ! model starting offset (3-d)
      parameter( p_log2plat = min( 1, plat/2 )  ! log base 2 of local lats
     $                      + min( 1, plat/4 )
     $                      + min( 1, plat/8 )
     $                      + min( 1, plat/16 )
     $                      + min( 1, plat/32 )
     $                      + min( 1, plat/64 )
     $                      + min( 1, plat/128 )
     $                      + min( 1, plat/256 )
     $                      + min( 1, plat/512 )
     $                      + min( 1, plat/1024 )
     $                      + min( 1, plat/2048 )
     $                      + min( 1, plat/4096 )
     $                      + min( 1, plat/8192 ))
#else
c
c     !   Basic grid point resolution parameters
c
      integer plev,plon,plat,plonp2,plevp,pcnst,plond,platd,plevd
      integer nxpt,jintmx,i1,j1,j1m
      parameter(plev=PLEV,        ! number of vertical levels
     $          plevp=plev+1,     ! number of vertical interfaces
     $          plon=PLON,        ! number of longitudes (T42)
     $          plat=PLAT,        ! number of latitudes (T42)
     $          plonp2=plon+2,    ! length necessary for fft
     $          pcnst=PCNST,      ! number of constituents
     $          nxpt=1,           !
     $          jintmx=1,         !
     $          plond=plon + 1 + 2*nxpt, ! slt extended domain longitude
     $          platd=plat + 2*nxpt + 2*jintmx, ! slt extended domain lat.
     $          plevd=plev*(3+pcnst), ! fold plev,pcnst indices into one
     $          i1=1+nxpt,        ! model starting longitude (3-d)
     $          j1=1+nxpt+jintmx, ! model starting latitude (3-d)
     $          j1m=j1-1)         ! model starting offset (3-d)
#endif

