C
C Radiation resolution and I/O parameters
C
#ifdef PP_PCCM
      integer plev,plon,plat,plonp2,plevp,pcnst,plond,platd,plevd
      integer nxpt,jintmx,i1,j1,j1m,plevmx

c parameters added to PCCM2 for mimd dist. mem. parallel implementation
      integer p_glon, p_glat, p_nproc_lt, p_nproc_ln, p_nproc
      integer p_lato2
      integer
     $     plngbuf  ! length of absorptivity/emissivity record


c parameters that are set by preprocessor defined constants

      parameter(p_nproc_lt=PP_NPROC_LT,    ! number of processors in lat
     $          p_nproc_ln=PP_NPROC_LN,    ! number of processors in lon
     $          plev=PP_PLEV,              ! number of vertical levels
     $          p_glat=PP_GLAT,            ! number of latitudes
     $          p_glon=PP_GLON )           ! number of longitudes

c parameters whose values are set or derived internally

      parameter(plevp=plev+1,              ! number of vertical interfaces
     $          plat=p_glat/p_nproc_lt,    ! number of local latitudes
     $          plon=p_glon/p_nproc_ln,    ! number of local longitudes
     $          p_lato2=plat/2,            ! 1/2 the number of local latitudes
     $          p_nproc=p_nproc_lt*p_nproc_ln,   ! total number of procs
     $          plonp2=plon+2,             ! length necessary for fft
     $          pcnst=1,                   ! number of constituents
     $          plevmx=4,
#  if ( PP_TRIANG_TRUNC == 170)
     $          nxpt=60,                    !
#  else
     $          nxpt=18,                    !
#  endif
     $          jintmx=2-nxpt,                 !
#  ifdef EVENPADDING
     $          plond=plon + 2 + 2*nxpt, ! slt extended domain longitude
#  else
     $          plond=plon + 1 + 2*nxpt, ! slt extended domain longitude
#  endif
     $          platd=p_lato2 + 2*nxpt + 2*jintmx, ! slt extended domain lat.
     $          plevd=plev*(3+pcnst))      ! fold plev,pcnst indices into one
      parameter(plngbuf = 512*((plond*plevp*plevp + plond*plev*4 +
     $                          plond*plevp)/512 + 1))
#else
      integer
     $     plon,    ! number of longitudes
     $     plev,    ! number of vertical levels
     $     plat,    ! number of latitudes
     $     pcnst,   ! number of constituents (including water vapor)
     $     plevmx,  ! number of subsurface levels
     $     plevp,   ! plev + 1
     $     nxpt,    ! no.of points outside active domain for interpolant
     $     jintmx,  ! number of extra latitudes in polar region
     $     plond,   ! slt extended domain longitude
     $     platd,   ! slt extended domain lat.
     $     plevd    ! fold plev,pcnst indices into one
      integer
     $     plngbuf  ! length of absorptivity/emissivity record
C
      parameter(plon    = PLON,
     $          plev    = PLEVR,
     $          plat    = PLAT,
     $          pcnst   = PCNST,
     $          plevmx  = 4,
     $          plevp   = plev + 1,
     $          nxpt    = 1,
     $          jintmx  = 1,
     $          plond   = plon + 1 + 2*nxpt,
     $          platd   = plat + 2*nxpt + 2*jintmx,
     $          plevd   = plev*(3 + pcnst))
      parameter(plngbuf = 512*((plond*plevp*plevp + plond*plev*4 +
     $                          plond*plevp)/512 + 1))
C
#endif
