C
C Common block for moist convective mass flux procedure
C
      common/comcmf/cp      ,hlat    ,grav    ,c0      ,betamn  ,
     $              rhlat   ,rcp     ,rgrav   ,cmftau  ,wssat   ,
     $              rhoh2o  ,tmelt   ,rgas    ,dzmin   ,limcnv  ,
     $              iloc    ,jloc    ,nsloc   ,tiny    ,eps     ,
     $              tpmax   ,shpmax,rlxclm
C
      real cp,         ! specific heat of dry air
     $     hlat,       ! latent heat of vaporization
     $     grav,       ! gravitational constant       
     $     c0,         ! rain water autoconversion coefficient
     $     betamn,     ! minimum overshoot parameter
     $     rhlat,      ! reciprocal of hlat
     $     rcp,        ! reciprocal of cp
     $     rgrav,      ! reciprocal of grav
     $     cmftau,     ! characteristic adjustment time scale
     $     wssat,      ! soil moisture capacity
     $     rhoh2o,     ! density of liquid water (STP)
     $     tmelt,      ! freezing point of water(req-d for rain vs snow)
     $     rgas,       ! gas constant for dry air
     $     dzmin       ! minimum convective depth for precipitation
      real tiny,       ! arbitrary small num used in transport estimates
     $     eps,        ! convergence criteria (machine dependent)
     $     tpmax,      ! maximum acceptable t perturbation (degrees C)
     $     shpmax      ! maximum acceptable q perturbation (g/g)           
C
      integer
     $     iloc,       ! longitude location for diagnostics
     $     jloc,       ! latitude  location for diagnostics
     $     nsloc,      ! nstep for which to produce diagnostics
     $     limcnv      ! top interface level limit for convection
C
      logical rlxclm      ! logical to relax column versus cloud triplet
C
