C
C Pointers into model buffers
C First: pointers to start of buffers
C
      common/comgrd/nprgm1  ,nprg    ,nprgtl
C
C nprgtl
C
      common/comgrd/nztl    ,ndtl    ,noro    ,nts     ,nphis   ,
     $              nws     ,nsn     ,nrnfp1  ,nqminus ,npsm2   ,
     $              num2    ,nvm2    ,ntm2    ,nqm2    ,npblht  ,
     $              nqpert  ,ntpert  ,nflwds  ,nfsns   ,nqrs    ,
     $              nqrl    ,ntssub  ,nplol   ,nplos
C
C nprgm1
C
      common/comgrd/npsm1   ,nzm1    ,ndm1    ,nduhm1  ,ndvhm1  ,
     $              ndthm1  ,ndpslm1 ,ndpsmm1 ,ndpsm1  ,ndqhm1
C
C nprg
C
      common/comgrd/npsp1   ,nzp1    ,ndp1    ,nduhp1  ,ndvhp1  ,
     $              ndthp1  ,ndpslp1 ,ndpsmp1 ,ndpsp1  ,ndqhp1
      integer
     $     nprgm1,   ! start of time n-1 prognostics
     $     nprg,     ! start of time n prognostics
     $     nprgtl,   ! start of half time-filtered data
     $     nztl,     ! half time-filtered vorticity
     $     ndtl,     ! half time-filtered divergence
     $     noro,     ! land/ocean/sea ice flag
     $     nts,      ! surface temperature
     $     nphis,    ! surface geopotential
     $     nws,      ! surface wetness
     $     nsn,      ! snow: water equivalent depth
     $     nrnfp1,   ! runoff
     $     nqminus,  ! constituents passed into slt advection
     $     npsm2,    ! surface pressure at time n-2
     $     num2,     ! u-wind at time n-2
     $     nvm2,     ! v-wind at time n-2
     $     ntm2,     ! temperature at time n-2
     $     nqm2,     ! specific humidity at time n-2
     $     npblht    ! pbl height
      integer 
     $     nqpert,   ! thermal humidity excess
     $     ntpert,   ! thermal temperature excess
     $     nflwds,   ! flux longwave down surface
     $     nfsns,    ! Surface absorbed solar flux
     $     nqrs,     ! shortwave heating rate
     $     nqrl,     ! longwave heating rate
     $     ntssub,   ! sub-surface temperatures
     $     nplol,    ! Ozone pressure weighted path length (cm)
     $     nplos,    ! Ozone path length (cm)
     $     npsm1,    ! surface pressure at time n-1
     $     nzm1,     ! vorticity at time n-1
     $     ndm1,     ! divergence at time n-1
     $     nduhm1,   ! horizontal diffusion of u-momentum at time n-1
     $     ndvhm1,   ! horizontal diffusion of v-momentum at time n-1
     $     ndthm1,   ! horizontal diffusion of temperature at time n-1
     $     ndpslm1,  ! longitudinal derivative of ps at time n-1
     $     ndpsmm1,  ! meridional derivative of ps at time n-1
     $     ndpsm1,   ! derivative of ps at time n-1
     $     ndqhm1    ! horiz diffusion of specific humidity at time n-1
C
C Suffix p1 implies time n+1 when step completed in SPEGRD
C and n when read back in LINDRV after nstep incremented
C
      integer
     $     npsp1,    ! surface pressure
     $     nzp1,     ! vorticity
     $     ndp1,     ! divergence
     $     nduhp1,   ! horizontal diffusion of u-momentum
     $     ndvhp1,   ! horizontal diffusion of v-momentum
     $     ndthp1,   ! horizontal diffusion of temperature
     $     ndpslp1,  ! longitudinal derivative of ps
     $     ndpsmp1,  ! meridional derivative of ps
     $     ndpsp1,   ! derivative of ps
     $     ndqhp1    ! horizontal diffusion of specific humidity
C
