C
C History tape header:
C   Record number 1 (integer values) provides description for history
C   tape output.  See the CCM2 User-s Guide for description of each
C   of the individual header variables.
C
      common /comhdi/ 
     $     lenhdi_a  ,mftyp   ,mfilh    ,mfilth  ,nrbd    ,
     $     maxsiz    ,ndavu   ,mxxx     ,mlon    ,nlonw   ,
     $     morec     ,mlev    ,mtrm     ,mtrn    ,mtrk    ,
     $     nfldh     ,nsteph  ,nstprh   ,nitslf  ,ndbase  ,
     $     nsbase    ,ndcur   ,nscur    ,nbdate  ,nbsec   ,
     $     ncdate    ,ncsec   ,mdt      ,mhisf   ,mfstrt  ,
     $     lenhdc    ,lenhdr  ,mpsig    ,mplat   ,mpwts   ,
     $     mpflds    ,mpcfld  ,mflds(3,pflds)
C
      integer lenhdi(40), ! Length of header record 1
     $        mftyp,      ! Format code
     $        mfilh,      ! Logical file number
     $        mfilth,     ! Max number of files on history tape
     $        nrbd,       ! Number of records before data records
     $        maxsiz,     ! Length of data record for this volume
     $        ndavu,      ! Length of the data record after unpacking
     $        mxxx,       ! Horizontal domain flag
     $        mlon,       ! Number of longitude points per latitude line
     $        nlonw,      ! Number of longitude data values written
     $        morec,      ! Number of latitude lines or data records
     $        mlev,       ! Number of vertical levels
     $        mtrm,       ! M spectral truncation parameter
     $        mtrn,       ! N spectral truncation parameter
     $        mtrk        ! K spectral truncation parameter
      integer nfldh,      ! Number of fields on the header
     $        nsteph,     ! Iteration number
     $        nstprh,     ! Iteration number for the start of this run
     $        nitslf,     ! Iterations since last file was written
     $        ndbase,     ! Base day number for this case
     $        nsbase,     ! Base number of seconds for this case
     $        ndcur,      ! Current day corresponding to  NSTEPH
     $        nscur,      ! Current seconds corresponding to NSTEPH
     $        nbdate,     ! Base date (yr mo day) as 6-digit integer
     $        nbsec,      ! Seconds to complete  NODT date
     $        ncdate,     ! Current date (yymmdd)
     $        ncsec,      ! Current seconds for date
     $        mdt,        ! Model timestep in seconds
     $        mhisf,      ! Frequency that history files are written
     $        mfstrt      ! Flag to indicate type of start
      integer lenhdc,     ! Length of header record 2
     $        lenhdr,     ! Length of header record 3
     $        mpsig,      ! Pointer to first word of sigma value list
     $        mplat,      ! Pointer to list of latitude lines
     $        mpwts,      ! Pointer to list of Gaussian weights
     $        mpflds,     ! Pointer to header field info integer list
     $        mpcfld,     ! Pointer to field info chararacter list
     $        mflds       ! Array of integer field list information
      integer lenhdi_a
      equivalence (lenhdi(1),lenhdi_a)	! quiet range checking
C     

C
C History tape header, record number 2 (character values)
C
      common /comhdc/
     $     mcase      ,mcstit     ,    
     $     lnhstc     ,ldhstc     ,lthstc    ,lshstc    ,
     $     lnhstf     ,ldhstf     ,lthstf    ,lshstf    ,
     $     lnhsti     ,ldhsti     ,lthsti    ,lshsti    ,
     $     lnhstt     ,ldhstt     ,lthstt    ,lshstt    ,
     $     lnhstvs    ,ldhstvs    ,lthstvs   ,lshstvs   ,
     $     lnhstvo    ,ldhstvo    ,lthstvo   ,lshstvo   ,
     $     mcflds(2,pflds)
C
      character*8   mcase   ,                   ! Case identifier
     $              ldhstc  ,lthstc  ,lshstc  , ! Current hist tape info
     $              ldhstf  ,lthstf  ,lshstf  , ! First hist tape info
     $              ldhsti  ,lthsti  ,lshsti  , ! Initial hist tape info
     $              ldhstt  ,lthstt  ,lshstt  , ! Boundary hist tape
C                                               !  information
     $              ldhstvs ,lthstvs ,lshstvs , ! SST hist tape info
     $              ldhstvo ,lthstvo ,lshstvo , ! Ozone hist tape info
     $              mcflds                      ! Array of character
C                                               !  field list info
      character*80  mcstit,                     ! Case title
C                                               !     MSS names:
     $              lnhstc,                     ! Current history tape
     $              lnhstf,                     ! First history tape 
     $              lnhsti,                     ! Initial history tape 
     $              lnhstt,                     ! Boundary history tape
     $              lnhstvs,                    ! SST history tape 
     $              lnhstvo                     ! Ozone history tape 
C
C History tape header, record number 3 (real values)
C
C Real header record contains sigma,latitude and gaussian weights
C
      common /comhdr/ 
     $     sigapb(2*plev+1) ,siga(2*plev+1) ,sigb(2*plev+1) ,
#ifdef PP_PCCM
     $     hdlat(p_glat)   , hdwt(p_glat)
#else
     $     hdlat(plat)      ,hdwt(plat)
#endif
C
      real sigapb,     ! Hybrid A + B coefficients
     $     siga,       ! Hybrid A (pressure) coefficients
     $     sigb,       ! Hybrid B (sigma) coefficients
     $     hdlat,      ! Latitude list (South to North)
     $     hdwt        ! Gaussian weight list.
C
