c
c $Id: mgw.com,v 1.1.1.1 2002/03/20 22:16:30 jacob Exp $
c $Author: jacob $
c
c These constants are documented in the gravity wave section of NCAR
c TN-420 "Description of the NCAR Community Climate Model (CCM3)",
c  Kiehl et al. (1996)
c
c
#ifndef GWPARMS_SET
#define GWPARMS_SET
#define PGWV	0
#define KBOT	PLEV
#define TAULDV  0.0
#define TAUSCAL	.001
#define TAUNOR	0.75
#define TAUSOU	1.2
#define TAUEQ	1.
#define TAUEQW	10.
#define OROFC2	.5
#define OROE	.125
#define MXRANGE	.001
#define MXASYM	.1
#endif
c
c common variables for multiple gravity wave parameterization
c
      integer pgwv 
      integer kbot
      parameter (pgwv = PGWV)   ! number of waves allowed
      parameter (kbot = KBOT)   ! index of bottom source interface

      real alpha(0:plev)        ! newtonian cooling coefficients
      real c(-pgwv:pgwv)        ! list of wave phase speeds
      real cp                   ! specific heat of dry air (constant p)
      real cpvir                ! specific humidity factor for specific heat
      real dback                ! background diffusivity
      real efcncy               ! "efficiency" factor
      real efkw                 ! efcncy * kwv
      real g                    ! acceleration of gravity
      real kwv                  ! effective horizontal wave number
      real mxasym               ! max asymmetry between tau(c) and tau(-c)
      real mxrange              ! max range of tau for all c
      real n2min                ! min value of bouyancy frequency
      real orofc2               ! critical froude number
      real oroeko2              ! e*k/2  tunable parameter
      real orohmin              ! min sdv of height for orographic waves
      real orovmin              ! min wind speed for orographic waves
      real r                    ! gas constant for dry air
      real rog                  ! r / g
      real taueq, taueqw        ! equatorial amplitude and width (degrees)
      real taumin               ! minimum (nonzero) stress
      real taunor,tausou        ! northern and southern hemisphere amplitudes
      real tauscal              ! scale factor for background stress source
      real tndmax               ! maximum wind tendency
      real ubmc2mn              ! min (u-c)**2

      common /mgwdcom/
     $     alpha, 
     $     c, cp, cpvir,
     $     dback,
     $     efcncy, efkw,
     $     g,
     $     kwv,
     $     mxasym, mxrange,
     $     n2min,     
     $     oroeko2, orofc2, orohmin, orovmin,
     $     r,
     $     rog,
     $     taueq, taueqw, taumin, taunor, tausou, tauscal,
     $     tndmax,
     $     ubmc2mn
 
