C     ******************************************************************
C     timers.com
C  
C     This file contains the necessary common block declarations and 
C     constants to use the interval timer routines.  It should be 
C     included at the beginning of each routine which uses the interval
C     timers
C     ******************************************************************

      integer TIMER_START, TIMER_STOP, TIMER_SYNC, TIMER_NOSYNC
      parameter (TIMER_START = 1,
     &           TIMER_STOP = 0,
     &           TIMER_SYNC = 1,
     &           TIMER_NOSYNC = 0)

      integer NUM_TIMERS
      integer
     &           TIMER_Main,
     &           TIMER_Physics,
     &           TIMER_XFORMDRV,
     &           TIMER_Scan1a,
     &		 TIMER_SLTINI,
     &		 TIMER_SLT,
     &           TIMER_DYNDRV,
     &		 TIMER_SCAN2,
     &           TIMER_Dyncolsum,
     &           TIMER_FwdFFT,
     &           TIMER_BwdFFT,
     &           TIMER_spg_a,
     &           TIMER_spg_c,
     &           TIMER_History_out,
     &           TIMER_Restart_out,
     &           TIMER_Scan1,
     &           TIMER_colsum,
     &           TIMER_rowsum,
     &           TIMER_rowmax,
     &           TIMER_gmax,
     &           TIMER_All

      parameter (NUM_TIMERS = 21)
      parameter (
     &           TIMER_Main      = 1,
     &           TIMER_Physics   = 2,
     &           TIMER_XFORMDRV  = 3,
     &           TIMER_Scan1a    = 4,
     &		 TIMER_SLTINI    = 5,
     &		 TIMER_SLT       = 6,
     &           TIMER_DYNDRV    = 7,
     &		 TIMER_SCAN2     = 8,
     &           TIMER_Dyncolsum = 9,
     &           TIMER_FwdFFT    = 10,
     &           TIMER_BwdFFT    = 11,
     &           TIMER_spg_a	 = 12,
     &           TIMER_spg_c 	 = 13,
     &           TIMER_History_out = 14,
     &           TIMER_Restart_out = 15,
     &           TIMER_Scan1     = 16,
     &           TIMER_colsum    = 17,
     &           TIMER_rowsum    = 18,
     &           TIMER_rowmax    = 19,
     &           TIMER_gmax      = 20,
     &           TIMER_All       = 21)

      character*15 timer_names(NUM_TIMERS)
      data timer_names / 'Main','Physics','XFORMDRV',
     &                   'Scan1a','SLTINI',
     &                   'SLT','DYNDRV','SCAN2',
     &                   'Dyncolsum', 'FwdFFT','BwdFFT',
     &			 'Spg_a','Spg_c',
     &                   'History_out','Restart_out',
     &                   'Scan1', 'colsum', 'rowsum',
     &                   'rowmax', 'gmax', 'All'/

      common /timers/ timer_begin, timer_total, 
     &                tstype, timer_started
      double precision timer_begin(NUM_TIMERS)    !timer value at start
      double precision timer_total(NUM_TIMERS)    !total time accumulated
      integer tstype
      logical timer_started(NUM_TIMERS)  !flag indicating if timer is on
