#include "params.h"
/* abort.c SCCS(1.2 92/10/06 10:26:06) */

/* emulate fortran abort */

/* revised 3/5/92, to output string to standard out and to issue
   a killproc() to zap the entire cube (Gamma) or partition (Delta).
   Note, however, that killproc() is not implemented yet on the Delta.
   The behavior there is the program will output a message to the
   screen that killproc isn't implemented (shrug; makes sense).

   Note: if abort is called without arguments, then heaven help us, since
   there is no way to tell what will be in str or n.  Put in a couple of
   safeguards just to make sure it doesn't fry the terminal printing 
   2 Gbytes of non-printables.

   Note also, the C-Fortran interface assumed here is MACHINE DEPENDENT.
   The 860 fortran compilers put the length of a string constant on the
   stack, immediately after a pointer to the string.
*/

#include <stdio.h>
#include <signal.h>

#define IS_ASCII( c )  (((c)>=' '&&(c)<='~')?1:0)

#ifdef RS6000
void abort_c( me , str, n )
#else
# ifdef T3E
void ABORT_C( me , str, n )
# else
void abort_c_( me , str, n )
# endif
#endif
char * str ;	/* FORTRAN string */
int n ;		/* length of string -- this is automatically there
		   note that it is pass by value!!! */
int *me;
{
    int i ;
    char *p ;

/* safety */
    printf("abort node %d:",*me) ;
    if ( n >= 0 && n <= 132 ) 
    {

/* output the message in string  to standard out */
        for ( i = 0 ,p = str ; i < n ; i++, p++ )
        {
	    if ( IS_ASCII( *p ) )
	    {
		putchar( *p ) ;
	    }
	    else
	    {
		putchar( '_' ) ;
	    }
        }

    }
    putchar( '\n' ) ;

    if ( str[0] == '#' ) return ;   /* print message but don't abort */

/* call killproc to terminate all nodes in job */

#ifndef RS6000
/*    killproc( -1, 0 ) ; */
    kill( 0, SIGKILL ) ;
#endif
#ifdef PP_MPI
    MPI_Finalize() ;
#endif

    abort() ;
}

