#include "params.h"
      subroutine advnce (tdt)
C-----------------------------------------------------------------------
C
C Advance time information (does not include nstep)
C
C---------------------------Code history--------------------------------
C
C Original version:  B. Boville
C Modified:          J. Rosinski, July 1991 for .not.anncyc => current
C                      date = base date
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Output arguments
C
      real tdt              ! two delta t (unless nstep<2)
C
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C-----------------------------------------------------------------------
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C------------------------------Commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C------------------------------Externals--------------------------------
C
      external settau,
     $         caldyi,      ! Calendar day calculation
     $         oznint,      ! Read new ozone data if required
     $         sstint       ! Read new sst data if required
C
C-----------------------------------------------------------------------
C
      tdt = twodt
      if (nstep.le.1) tdt = .5*tdt
C
C Set matrices dependent on T0 associated with semi-implicit timestep.
C
      if (nstep.eq.1) then
         call settau(0.5*twodt)
      end if
C
C Determine whether it is time for a shortwave or longwave radiation 
C calculation
C
      dosw = nstep.eq.0 .or. iradsw.eq.1 .or.
     $       (mod(nstep-1,iradsw).eq.0 .and. nstep.ne.1)
      dolw = nstep.eq.0 .or. iradlw.eq.1 .or.
     $       (mod(nstep-1,iradlw).eq.0 .and. nstep.ne.1)
C
C Determine whether it is time for an absorptivity/emissivity calculation
C
      doabsems = nstep.eq.0 .or. iradae.eq.1 .or.
     $           (mod(nstep-1,iradae).eq.0 .and. nstep.ne.1)
C
C Advance model time variables. Time interpolate ozone and sst data
C
      if (anncyc) then
         call caldyi(nstep   ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,mdcur   ,mscur   ,mcdate  ,mcsec   ,
     $               calday  )
C
C Update ozone data on shortwave or longwave time step.
c Note that the ozone data is not needed on a longwave time step unless the
c absorptivities are being updated ("doabsems").
C
	 if (dosw .or. dolw) then
            call oznint(nozone)
         end if
#ifndef COUPLED
         call sstint(nsst)
#endif
      else
C
C Perpetual: Current date,day = base date,day
C
         call caldyi(0       ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,mdcur   ,mscur   ,mcdate  ,mcsec   ,
     $               calday  )
         if (nstep.eq.nrstrt) then
            call oznint(nozone)
#ifndef COUPLED
            call sstint(nsst)
#endif
         end if
      end if
      return
      end
