#include "params.h"
#ifdef COUPLED
      subroutine data(time_inv,tilen)
#else
      subroutine data
#endif
C-----------------------------------------------------------------------
C     
C Read data to define the run
C Important Note for running on SUN systems: "implicit automatic (a-z)"
C will not work because namelist data must be static
C     
C---------------------------Codehistory--------------------------------
C     
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C     
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C------------------------------Commons----------------------------------
#include "comadj.com"
C----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhd.com"
C----------------------------------------------------------------------
#include "comhst.com"
C----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comtfc.com"
C----------------------------------------------------------------------
#include "comtim.com"
C----------------------------------------------------------------------
#include "comvmr.com"
C----------------------------------------------------------------------
#include "comsol.com"
C---------------------------Localvariables-----------------------------
C 
      character nrevsn*72       ! Dataset to regenerate from, in namelist
      character*8 auxf(pflds*(ptapes-1)) ! Input auxiliary tapes specs
      integer jsav(ptapes)      ! Index used in processing auxiliary tapes
      logical warned            ! a flag
      character*256 time_inv
      integer tilen
C 
C-----------------------------------------------------------------------
C 
C namelist ccmexp
C 
C variable name                   purpose
C -------------                   -------
C 
C ctitle               Case title for header.
C 
C ncdata               Pathname of initial condition dataset.
C 
C nsvsn                Restart dataset name
C 
C nswrps               Write password for model output files.
C 
C nsrest               Code for type of start, initial,restart,
C                      regen or branch
C 
C irt                  Mass Store retention time for output tapes.
C 
C nsmvn                Virtual volume name for output history tapes.
C 
C nrmvn                Virtual volume name for regeneration datasets.
C 
C bndti                MSS pathname of time-invariant boundary dataset.
C 
C bndtvs               MSS pathname of time-variant boundary dataset for
C                      sst s.
C 
C bndtvo               MSS pathname of time-variant boundary dataset for
C                      ozone
C 
C nrevsn               Filename of dataset to regenerate from if
C                      runtyp = 'regenerate'. Full pathname of dataset
C                      to start a branch run
C 
C ndens = n,n,n..      packing density for each history tape (1-4).
C                      defaults to 1 (no packing)
C 
C nhtfrq = nn,nn,nn,.. frequency of history tape writes for each
C                      history tape requested.
C                      If nhtfrq.eq.0, tape will not be written.
C                      If .gt.0 : write up every nhtfrq time steps.
C                      If .lt.0 : write up every -nhtfrq hours.
C 
C nrefrq = nn,         frequency of regeneration dataset writes, in
C                      terms of the number of history tapes disposed.
C                      Defaults to 5 (in parallel code), i.e., regeneration
C                      data is written and disposed for every dispose of
C                      a history tape.
C 
C mfilt = nn,nn,nn     array of max number of history files per volume.
C                      Defaults to 1 (in parallel code).
C 
C ninavg = 'A','A',..  Field averaging for each history tape. Possible
C                      values are 'A' - averaged, 'I' - instantaneous,
C                      'M' - point minimum, 'X' - point maximum. Default
C                      for primary tape is 'A'; ORO and PHIS are never
C                      averaged.
C 
C nlfilt = .true.,     if true, write 1 extra file to next primary
C                      or .false., history tape to be disposed. 
C                      Defaults to .f.
C 
C stfnum = nnn,        Starting number for history tape and
C                      regeneration dataset naming. Defaults to 1.
C 
C exclude = 'field1',.. List of field names to exclude from default
C                      primary history tape field list
C 
C primary = 'field1',.. List of field names to include in primary tape
C                      which would not by default be on it.  These
C                      fields must be in the master fields list.
C 
C auxf =  tapeno,field1,...   List of field names to include in first
C                      auxiliary history tape. Must have at least 2
C                      values for nhtfrq, ninavg and ndens if this
C                      parameter is used.
C 
C nndbas = nnn,        optional input base day for run, defaults
C                      to value of ndcur from initial dataset.
C                      nndbas used to set model variable mdbase.
C 
C nnsbas = nnn,        optional base seconds of the day, defaults
C                      to value of nscur from initial dataset.
C                      nnsbas used to set model variable msbase.
C 
C nnbdat = yymmdd,     optional base date for run, defaults to
C                      value of nbdate from initial dataset.
C                      nnbdat used to set model variable mbdate.
C 
C nnbsec = nnn,        optional base seconds of the date, defaults
C                      to value of ncsec from initial dataset.
C                      nnbsec used to set model variable mcsec.
C 
C dtime = nnnn,        model time step in seconds. Defaults to 1200.
C 
C nestep = nnnn,       ending model time for this run.
C                      .ge.0 : number of last step
C                      .lt.0 : number of last day
C                      Preset to -999999999. If not input, nelapse
C                      must be input.
C 
C nelapse = nnn,       elapsed model time for this run, may be used in
C                      place of nestep.  Preset to -999999999.
C 
C eps = nnn.n,         time filter coefficient. Defaults to 0.06.
C 
C dif2 = nnn.n,        del2 horizontal diffusion coeff. Defaults
C                      to 2.5e5.
C 
C dif4 = nnn.n,        del4 horizontal diffusion coeff. Defaults
C                      to 1.e16.
C 
C 
C kmxhdc = nn          number of levels (starting from model top) to
C                      apply Courant limiter.  Defaults to 1.
C 
C iradsw = nnn,        frequency of shortwave radiation calc in time steps
C                      (positive) or hours (negative).
C 
C iradlw = nnn,        frequency of longwave radiation calc in time steps
C                      (positive) or hours (negative).
C 
C iradae = nnn,        frequency of absorp/emis calc in time steps
C                      (positive) or hours (negative).
C 
C itsst = nnn,         frequency of SST update
C 
C nlvdry = nn,         Number of layers over which to do dry
C                      adjustment. Defaults to 3.
C 
C sstcyc = .T.,        If false, do not cycle sst dataset(assume
C                      multiyear)
C 
C ozncyc = .T.,        If false, do not cycle ozone dataset(assume
C                      multiyear)
C 
C async = .T.,         If true, put mswrite commands in background
C 
C mxszrg = nnn         Maximum size of restart/regeneration files
C                      in megabytes if mxszrg < 10^6, otherwise in bytes
C 
C ldebug = .F.,        Debug mode means link output files to /usr/tmp
C                      before mswriting, and remove files from /usr/tmp
C                      if not the last file.
C 
C dodiavg = .F.,       Diurnal averaging flag: affects coszrs
C
C cpuchek = .F.,       Check remaining cpu time for run to stop model
C 
C accrst = .F.,        Accumulate restart files or toggle between two
C
C parhist = .F.        If true, write out one file per row of processors
C
      namelist /ccmexp/ ctitle  ,ncdata  ,bndti   ,bndtvs  ,bndtvo  ,
     $     nsvsn   ,nswrps  ,nsrest  ,irt     ,nsmvn   ,
     $     nrmvn   ,nrevsn  ,ndens   ,nhtfrq  ,nrefrq  ,
     $     mfilt   ,ninavg  ,nlfilt  ,stfnum  ,rirt    ,
     $     exclude ,primary ,auxf    ,nndbas  ,nnsbas  ,
     $     nnbdat  ,nnbsec  ,dtime   ,nelapse ,nestep  ,
     $     eps     ,dif2    ,dif4    ,kmxhdc  ,iradsw  ,
     $     iradlw  ,iradae  ,itsst   ,nlvdry  ,sstcyc  ,
     $     ozncyc  ,async   ,mxszrg  ,ldebug  ,dodiavg ,
     $     cpuchek ,mresfq  ,
     $     accrst  ,parhist
#ifdef PP_PCCM
     $     , rpath, hpath
#endif

C 
C---------------------------Localvariables-----------------------------
C 
      character
     $     tempc*16,            ! Temporary character variable
     $     ctemp*8,             ! Temporary character strings
     $     atemp*1,             ! Temporary character strings
     $     chcase*16,           ! Temporary character string for case env. var.
     $     itf*5,               ! Temporary for tape number
     $     chtem1*20,           ! Character temporary
     $     chtem2*20            ! Character temporary
      integer
     $     kclen,               ! Length of case identifier
     $     ntspdy,              ! number of timesteps per day
     $     len,                 ! Character variable lengths
     $     i,j,k,ix,m,          ! Indices
     $     mdtapes,             ! Number of declared tapes
     $     kyear,            ! Temp year var
     $     kmth              ! Temp mnth var
C 
C------------------------------Externals--------------------------------
C 
      integer lenchr
      character*8 upcase
      external upcase           ! Uppercase 8-character variable
      external lenchr           ! Return actual length of character string
      external endrun           ! Abnormal termination
      external ljust            ! Left-justify character string
C 
C-----------------------------------------------------------------------
C 
C Preset local variables
C 
      do i=1,pflds * (ptapes-1)
         auxf(i) = '        '
      end do
      do i=1,72
         nrevsn(i:i) = ' '
      end do
C 
C Set anncyc true, no longer in namelist
C 
      anncyc = .true.
      nhpthl = lenchr(nhpath)
      nrpthl = lenchr(nrpath)
C
C read namelist ccmexp
C
      call rdbcst("ccmexp",auxf,nrevsn)

#ifdef COUPLED
C set the four initial data sets to the time invariant directory.
      ncdata=time_inv(1:tilen) // '/' // ncdata
      bndti =time_inv(1:tilen) // '/' // bndti
      bndtvs =time_inv(1:tilen) // '/' // bndtvs
      bndtvo =time_inv(1:tilen) // '/' // bndtvo
#endif

C 
C Set continuation run flags
C 
      if (nsrest.gt.0) nlres  = .true.
      if (nsrest.ge.2) nlhst  = .true.
      if (nsrest.eq.3) lbrnch = .true.

      if ( nsrest .eq. 2 ) then
	write(6,*)
     $'NSREST .eq. 2: regeneration runs not supported in parallel code.'
	call endrun
      endif
C 
C Iteration length and ending iter
C 
      twodt = 2.0*dtime
C 
      if (nestep.gt.-999999999) then
         if (nestep.lt.0) nestep = nint((-nestep*86400.)/dtime)
C    
C    nestep overrides nelapse if both are input
C    
         nelapse = 0
      elseif (nelapse.gt.-999999999) then
         if (nelapse.lt.0) nelapse = nint((-nelapse*86400.)/dtime)
C    
C    nestep will be overwritten if a restart run -- see resume
C    
         nestep = nelapse
      else
         write(6,*)'DATA:Must input either nestep or nelapse'
         call endrun
      end if
      nstop = nestep + 1
C
C 
C Auxiliary history tapes:
C Store input auxf values in array aux (comhst). Compute mdtapes.
C 
      j = 1
      do i=1,pflds*(ptapes-1)
         call ljust(auxf(i) ,ctemp)
         write (atemp,'(i1)') j
         if (ctemp(1:1).eq.atemp) then
            jsav(j) = i
            j = j + 1
         elseif (auxf(i).eq.'        ') then
            jsav(j) = i
            go to 100
         end if
      end do
  100 continue
      mdtapes = j
      if (mdtapes.gt.ptapes) then
         write(6,*)'DATA: Too many auxiliary tapes declared.'
         call endrun
      end if
      do i=1,mdtapes-1
         m = 1
         do k = jsav(i)+1,jsav(i+1)-1
            call ljust(auxf(k) ,aux(m,i))
            m = m + 1
         end do
      end do
C 
C History tape write up times
C 
      if (ninavg(1).eq.'Q') nhtfrq(1) = 1   ! Force non-zero for mon avg
      do i=1,mdtapes
         if (nhtfrq(i).eq.0) then
            write(6,*)'DATA: Must specify non-zero nhtfrq'
            call endrun
         else if (nhtfrq(i).lt.0) then
            nhtfrq(i) = nint((-nhtfrq(i)*3600.)/dtime)
         end if
      end do
C
C Check nstep times for proper restart
C
      if (mod(nestep,nhtfrq(1)).ne.0.and.ninavg(1).ne.'Q') then
      write(6,*)'DATA: The model must end on a history tape ', 
     $        'write time inorder to restart correctly.'
      write(6,*)'      Please make mod(nestep,nhtfrq(1)) = 0'
      end if
C 
C Make sure auxiliary nhtfrq evenly divides the primary one to make
C restart possible.  If this is a monthly average then restarts are 
C provided for auxilaries that don t evenly divide the primary tape.
C 
      do i=2,mdtapes
         if ((ninavg(1).ne.'Q').and.
     $        (mod(nhtfrq(1),nhtfrq(i)).ne.0)) then
            write(6,*)'DATA: Auxiliary write times must evenly divide ',
     $                'primary write time.'
            write(6,*)'      Primary frequency=',nhtfrq(1),
     $                '    Auxiliary frequency=',nhtfrq(i)
            call endrun
         end if
      end do
C 
C Convert iradsw and iradlw to iterations if necessary
C 
      if (iradsw.lt.0) iradsw = nint((-iradsw*3600.)/dtime)
      if (iradlw.lt.0) iradlw = nint((-iradlw*3600.)/dtime)
C 
C Convert iradae to iterations if necessary
C 
      if (iradae.lt.0) iradae = nint((-iradae*3600.)/dtime)
C 
C iradae must be an even multiple of iradlw
C 
      if (mod(iradae,iradlw).ne.0) then
         write(6,*)'DATA:iradae must be an even multiple of iradlw.'
         write(6,*)'     iradae = ',iradae,', iradlw = ',iradlw
         call endrun
      end if
C 
C Do absorptivities/emissivities have to go on a restart dataset?
C 
      aeres = .FALSE.
      if (ninavg(1).ne.'Q') then
         if (mod(nhtfrq(1),iradae).ne.0) then
            aeres = .TRUE.
            write(6,*)'DATA: *** NOTE: Extra overhead invoked putting',
     $           ' a/e numbers on restart dataset. ***   ',
     $           ' To avoid, make mod(nhtfrq,iradae) = 0'
         end if
      else
         ntspdy = nint(86400./dtime)
         if ((mod(ntspdy,iradae).ne.0).or.(iradae.gt.ntspdy)) then
            aeres = .TRUE.
            write(6,*)'DATA: *** NOTE: Extra overhead invoked putting',
     $           ' a/e numbers on restart dataset. ***   '
            write(6,*)' To avoid, make mod(timesteps per day,iradae)',
     $                '= 0'
         end if
      end if
C     
C Number of levels to apply Courant limiter
C 
      if (kmxhdc.ge.plev .or. kmxhdc.lt.0) then
         write(6,*)'DATA: KMXHDC must be between 0 and plev-1'
         call endrun
      end if
C 
C Regeneration tape labels
C 
      if (stfnum.gt.9999) then
         write(6,*)'DATA: Starting tape number (stfnum) too large.',
     $        '     Max = 9999.   Stfnum = ',stfnum
         call endrun
      end if
      write (itf,'(i5)') stfnum + 9999          !10000 
      nrfil = 'r'//itf(2:5)
      if (ninavg(1).eq.'Q') then
         kyear = nnbdat/10000
         kmth = mod(nnbdat/100,100)
         write (chtem1,'(i2)') kyear 
         write (chtem2,'(i2)') kmth
         if (kyear.lt.10) chtem1(1:1) = '0'
         if (kmth.lt.10) chtem2(1:1) = '0'
         nrfil = 'r'//chtem2(1:2)//'-'//chtem1(1:2)
      end if
C 
C Ensure valid packing density, check for extra file on
C first tape
C 
      do i=1,mdtapes
         if (ndens(i).gt.4.or.ndens(i).lt.1) then
            write(6,*)'DATA: Invalid packing density ',ndens(i)
            call endrun
         end if
      end do

      if(parhist) then
#ifdef PP_INTEL_PFS
       if (nlfilt.and.nsrest.eq.0) then
          mfilt(1) = mfilt(1) + 1
       else
          nlfilt = .false.
       end if
#else
C Modification for parallel code: because of the need to reassemble 
C history tapes that may have been written in distributed fashion, there
C can only ever be one history file per volume.  I.e., MFILT must always
C be 1.  Also, because of this, NLFILT becomes meaningless. 
       if (nlfilt) then
	write(6,*)
     $ 'WARNING: parallel code with distributed history ignores nlfilt.'
       endif
       warned=.false.
       do i=1,ptapes
	if ( mfilt(i) .ne. 1 ) then
	  if ( .not. warned ) then
	    write(6,*)
     $ 'WARNING: mfilt must always be 1 for parallel code.'
	  endif
	  write(6,*)
     $ '         Setting of ',mfilt(i),'for tape ',i,' is ignored.'
	  warned=.true.
          mfilt(i) = 1
	  nlfilt = .false.
	endif
       enddo
#endif
      else
       if (nlfilt.and.nsrest.eq.0) then
          mfilt(1) = mfilt(1) + 1
       else
          nlfilt = .false.
       end if
      endif


C 
C Convert mxszrg to bytes if input was in megabytes
C 
      if (mxszrg .lt. 1000000) mxszrg = mxszrg * 1000000

      rgpath = nrevsn

#ifdef PP_PCCM
      write(6,*)' This is a parallel PCCM3-UW run.  '
      write(6,*)' Processors in the longitude direction ',p_nproc_ln
      write(6,*)' Processors in the latitude direction  ',p_nproc_lt
#endif
      write(6,*)' ------------------------------------------'
      write(6,*)'     *** INPUT PARAMETERS (CCMEXP) ***'
      write(6,*)' ------------------------------------------'
C 
C Print ccmexp input parameters
C 
      if (nlres) then
         write(6,*) '  Continuation of an earlier run'
      else
         write(6,*) '         Initial run'
      end if
c     write(6,9000) caseid(1:lenchr(caseid))
c9000 format(' ********** THIS IS CASE ',a,'**********')
      write(6,'(1x,a80)') ctitle
c     write(6,*) 'User name to build pathnames = ',
c    $     njusn(1:lenchr(njusn))
      if (lenchr(ncdata).gt.0) then
         write(6,*) 'Initial dataset is: ',ncdata(1:lenchr(ncdata))
      end if
      write(6,*) 'Time-invariant boundary dataset is: ',
     $     bndti(1:lenchr(bndti))
      write(6,*) 'Time-variant boundary dataset (sst) is: ',
     $     bndtvs(1:lenchr(bndtvs))
      write(6,*) 'Time-variant boundary dataset (ozone) is: ',
     $     bndtvo(1:lenchr(bndtvo))
      write(6,*) ' '
      write(6,*) '         Atmosphere Constants'
      write(6,9205) co2vmr
 9205 format('CO2 volume mixing ratio is: ',E13.6)
      write(6,9206) ch4vmr
 9206 format('CH4 volume mixing ratio is: ',E13.6)
      write(6,9207) n2ovmr
 9207 format('N2O volume mixing ratio is: ',E13.6)
      write(6,9208) f11vmr
 9208 format('F11 volume mixing ratio is: ',E13.6)
      write(6,9209) f12vmr
 9209 format('F12 volume mixing ratio is: ',E13.6)
      write(6,*) ' '
      write(6,9210) tauvis
 9210 format('Visible optical depth is: ',F8.6)
      write(6,9211) scon
 9211 format('Solar Constant is: ',F13.3)
      write(6,*) ' '
      if (nsvsn.ne.'        ') then
         write(6,*) 'Restart dataset is: ',nsvsn(1:lenchr(nsvsn))
         write(6,*) 'Maximum size of regeneration files is: ',
     $        mxszrg, ' bytes'
      else
         write(6,*) 'NO RESTART DATASET will be written'
      end if
      if (nswrps.ne.'        ')
     $     write(6,*) 'Write password for output files (NSWRPS) is ',
     $     nswrps
      write(6,*)'Restart flag (NSREST) 0=no,1=yes,2=regen   ',nsrest
C 
C Retention period for mass store volumes
C 
#ifdef CRAY
      if (irt.gt.0) then
         if (irt.eq.99999) then
            if (nsmvn.eq.'CTPUBLIC') then
               irt = 365
            else
               irt = 4095
            end if
         else
            if (nsmvn.eq.'CTPUBLIC') then
               irt = min0(irt,1825)
            else
               irt = min0(irt,4095)
            end if
         end if
         write(6,9010) irt
 9010    format(' Retention time for History Volumes = ',I5,' Days')
C    
C    print virtual volume name
C    
         write(6,9020) nsmvn
 9020    format(' Virtual MS volume for History Tape (NSMVN) ',a8)
      else
         write(6,*)' History volumes will NOT be disposed to Mass Store'
      end if
      if (rirt.gt.0) then
         if (rirt.eq.99999) then
            if (nsmvn.eq.nrmvn) then
               rirt = irt
            else
               if (nrmvn.eq.'CTPUBLIC') then
                  rirt = 365
               else
                  rirt = 4095
               end if
            end if
         else
            if (nrmvn.eq.'CTPUBLIC') then
               rirt = min0(rirt,1825)
            else
               rirt = min0(rirt,4095)
            end if
         end if
         write(6,9015) rirt
 9015    format(' Retention time for Restart Volumes = ',I5,' Days')
C    
C    Print virtual volume name
C    
         write(6,9030) nrmvn
 9030    format(' Virtual MS volume for Regeneration data (NRMVN) ',a8)
      else
         write(6,*) 'Regen volumes will NOT be disposed to Mass Store'
      end if
#endif
C 
      if (nsrest.ge.2) then
         if (nrevsn(1:1).ne.' ') then
            write(6,*) ' Regeneration dataset to use         '
            write(6,*)rgpath
         end if
      end if
      do i=1,mdtapes
         if (ndens(i).gt.1) then
            write(6,9040)i,ndens(i)
 9040       format(' History tape ',i3,' will be packed ',i2,' to 1')
         else
            write(6,9050)i
 9050       format(' History tape ',i3,' will not be packed')
         end if
      end do
C 
      do i = 1,mdtapes
        if (ninavg(1).ne.'Q'.or.i.gt.1) then
            write(6,*)'History Tape ',i,' write frequency (NHTFRQ) ',
     $        nhtfrq(i)
        else
            write(6,*)'History Tape ',i,' write frequency (NHTFRQ) ',
     $        'MONTHLY'
        end if
      end do
C 
C Only one time slice allowed per monthly average tape
C 
      if (ninavg(1).eq.'Q' .and. mfilt(1).ne.1) then
         write(6,*)'The number of files for a monthly average tape',
     $        'must be 1'
         write(6,*)'DATA is resetting mfilt(1) to 1 and continuing.'
         mfilt(1) = 1
      end if
      do i=1,mdtapes
         write(6,*)'Number of files per tape (MFILT) ',mfilt(i)
      end do
      if (nlfilt) write(6,*)
     $     ' Write one extra file to first volumes (NLFILT=.t.)'
C 
C stfnum only applies to non-monthly averaged tapes. Monthly averages
C have a standard mm-yy convention.
C 
      if (stfnum.gt.1 .and. ninavg(1).ne.'Q') then
         write(6,9070) stfnum
 9070    format(5x,'STARTING FILE NUMBER FOR HISTORY TAPES WILL BE ',i3)
      end if
      nexcl = 0
      if (exclude(1).ne.'        ') then
         write(6,*) 'The following fields will be excluded from the ',
     $        'primary history tape:'
         do i=1,100
            if (exclude(i).ne.'        ') then
               nexcl = i
               write(6,*)exclude(i)
            else
               go to 200
            end if
         end do
      end if
  200 continue
      nincl = 0
      if (primary(1).ne.'        ') then
         write(6,*) 'The following fields will be included on the ',
     $        'primary history tape:'
         do i=1,100
            if (primary(i).ne.'        ') then
               nincl = i
               write(6,*)primary(i)
            else
               go to 300
            end if
         end do
      end if
  300 continue
      do i=1,mdtapes-1
         if (aux(1,i).ne.'        ') then
            write(6,*) 'Auxiliary tape ',i,
     $           ' will contain the following fields:'
            do ix=1,pflds
               if (aux(ix,i).ne.'        ') then
                  write(6,*)aux(ix,i)
               else
                  go to 400
               end if
            end do
         end if
  400    continue
      end do
      do i=1,mdtapes
         if (ninavg(i).eq.'A') then
            write(6,*)'Fields on history tape ',i,' will be averaged.'
         elseif (ninavg(i).eq.'I') then
            write(6,*)'Fields on history tape ',i,
     $           ' will be instantaneous.'
         elseif (ninavg(i).eq.'M') then
            write(6,*)'Fields on history tape ',i,' will be minima.'
         elseif (ninavg(i).eq.'X') then
            write(6,*)'Fields on history tape ',i,' will be maxima'
         elseif (ninavg(i).eq.'Q') then
            if (i.eq.1) then
               write(6,*)'Fields on history tape ',i,' will be a',
     $              ' monthly average.'
            else
               write(6,*)
     $              'DATA: Invalid averaging flag input for tape ',i
               write(6,*)'Flag = ',ninavg(i)
               write(6,*)
     $              'Monthly averages only to be specified for tape 1'
               call endrun
            end if
         else
            write(6,*)
     $           'DATA: Invalid averaging flag input for tape ',i
            write(6,*)'Flag = ',ninavg(i)
            call endrun
         end if
      end do  
      if (ninavg(1).ne.'Q') then
         if (nrefrq.eq.1) then
            write(6,*) 
     $      'Regen data will be written for every history tape'
         else
            write(6,*) 'Regeneration data will be written for every ',
     $              nrefrq,' history tapes'
         end if
      else
         if (nrefrq.ne.1) then
            write(6,*) '****************    Warning     **************'
            write(6,*) 'Namelist variable NREFRQ is invalid for',
     $         ' monthly '
            write(6,*) 'averaging. Use MRESFQ to adjust restart',
     $         ' frequency.' 
         end if
         if (mresfq.eq.999) then
            write(6,*) 'Regeneration data once per month (default)'
         else
            write(6,*) 'Warning: Regeneration data can only be written', 
     $          'at months end.  Was every ',mresfq,', now monthly'
            mresfq = 999
         end if
      end if 
      if (nndbas.ne.-9999)
     $     write(6,9080)nndbas,nnsbas
 9080 format(' Base day,seconds of day =          ',2i5)
      if (nnbdat.ne.-9999)
     $     write(6,9090)nnbdat,nnbsec
 9090 format(' Base date,seconds of date =        ',2i6)
      if (nelapse.ne.0) then
         write(6,9100) nelapse
 9100    format(' Elapsed time to end run (NELAPSE) ',i8)
      else
         write(6,9105) nestep
 9105    format(' Time step to end run (NESTEP)  ',i8)
      end if
      write(6,9108) dtime,eps,dif2,dif4,kmxhdc,nlvdry
 9108 format(' Time step in seconds (DTIME)       ',f5.0,/,
     $     ' Time filter coefficient (EPS)      ',f10.3,/,
     $     ' DEL2 Horizontal diffusion coefficient (DIF2) ',e10.3/,
     $     ' DEL4 Horizontal diffusion coefficient (DIF4) ',e10.3/,
     $     ' Number of levels Courant limiter applied     ',i10/,
     $     ' Lowest level for dry adiabatic adjust (NLVDRY)',i10)
      write(6,9110) iradsw,iradlw,iradae,itsst
 9110 format(' Frequency of Shortwave Radiation (IRADSW)    ',i5/,
     $     ' Frequency of Longwave Radiation (IRADLW)     ',i5/,
     $     ' Frequency of Absorptivity/Emissivity (IRADAE)',i5/,
     $     ' Frequency of SST Initialization (ITSST)      ',i5/)
      write(6,*)'Transport will be by SEMI-LAGRANGIAN Method'
      if (sstcyc) then
         write(6,*)
     $        'SST boundary dataset will be reused for each model year'
      else
         write(6,*)
     $        'SST boundary dataset will not be cycled'
      end if
      if (ozncyc) then
         write(6,*)
     $        'OZONE boundary dataset will be reused for each model',
     $        ' year'
      else
         write(6,*)
     $        'OZONE boundary dataset will not be cycled'
      end if
      if (async) then
         write (6,*)'Output files will be disposed ASYNCHRONOUSLY'
      else
         write (6,*)'Output files will be disposed IN FOREGROUND'
      end if
      if (ldebug) then
         write(6,*) 'Running in DEBUG mode -- ',
     $        'output files will be linked into /usr/tmp'
      else
         write(6,*)'Running in PRODUCTION mode -- ',
     $        'output files will not be linked to /usr/tmp'
      end if
      if (dodiavg) then
         write(6,*) 'Diurnal averaging will be done'
      else
         write(6,*) 'Diurnal averaging will not be done'
      end if
      if (cpuchek) then
         write(6,*) 'CPU time will be checked at each h-tape write'
      end if
      if (accrst) then
         write(6,*) 'Restart tapes will accumulate.'
      else
         write(6,*) 'Restart tapes will toggle between two files.'
      endif
      write(6,*)' ------------------------------------------'
C 
      return
      end
