#include "params.h"
      subroutine hordif(k,ztdt)
c-----------------------------------------------------------------------
c
c Horizontal diffusion of z,d,t,q
c 1. implicit del**2 form above level kmnhd4
c 2. implicit del**4 form at level kmnhd4 and below
c 3. courant number based truncation at level kmxhdc and above
c 4. increased del**2 coefficient at level kmxhd2 and above
c
c-----------------------------parameters--------------------------------
c
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
c-----------------------------commons-----------------------------------
#include "comhd.com"
c-----------------------------------------------------------------------
#include "comspe.com"
c-----------------------------------------------------------------------
#include "comtim.com"
c-----------------------------------------------------------------------
#ifdef PP_PCCM
#include "comparll.com"
c-----------------------------------------------------------------------
#endif
      integer k            ! level index
      real ztdt            ! 2 times time step unless nstep=0 (time step)
      real arrout(psp)
c declarations inserted by implnone
      real dfac,tqfac,zdfac
c declarations inserted by implnone
      integer ii,ir,m,mc,mck,mr,n
#ifdef PP_PCCM
      integer mm
#endif
c----------------------------Action--------------------------------------
c
c Del^4 diffusion factors
c
      if (k .ge. kmnhd4) then
         do n=1,pnmax
            hdiftq(n,k) = hdfst4(n)
            hdifzd(n,k) = hdfsd4(n)
         end do
c
c Spectrally truncate selected levels (if courant number too large)
c
         if ((k.le. kmxhdc).and.(nindex(k).le.pnmax)) then
            dfac = 1000.
            do n=nindex(k),pnmax
               hdiftq(n,k) = dfac*hdfst4(n)
               hdifzd(n,k) = dfac*hdfsd4(n)
            end do
         endif
c
c Del^2 diffusion factors
c
      else
         if (k.le.kmxhd2) then
            dfac = 2.**(float(kmxhd2-k+1))
         else
            dfac = 1.0
         endif
         do n=1,pnmax
            hdiftq(n,k) = dfac*hdfst2(n)
            hdifzd(n,k) = dfac*hdfsd2(n)
         end do
c
c Spectrally truncate selected levels (if courant number too large)
c
         if ((k.le.kmxhdc).and.(nindex(k).le.pnmax)) then
            dfac = 1000.
            do n=nindex(k),pnmax
               hdiftq(n,k) = dfac*hdfst2(n)
               hdifzd(n,k) = dfac*hdfsd2(n)
            end do
         endif
      endif
c
c Apply the horizontal diffusion for this level
c
#ifdef PP_PCCM
      do mm = m_fwavbeg, m_fwavend
	 m = m_mtrue(mm) + 1
         mr = m_offalp(mm)
         mc = 2*mr
         mck = (k-1)*m_nspect2 + mc
         do n=1,m_lenalp(mm)
#else
      do m=1,pmmax
         mr = nstart(m)
         mc = 2*mr
         mck = (k-1)*psp + mc
         do n=1,nlen(m)
#endif
            ir = mck + 2*n - 1
            ii = ir + 1
c
c time-split implicit factors
c
            tqfac = 1./(1. + ztdt*hdiftq(n+m-1,k))
            zdfac = 1./(1. + ztdt*hdifzd(n+m-1,k))
c
            t(ir) = t(ir)*tqfac
            t(ii) = t(ii)*tqfac
c
            q(ir) = q(ir)*tqfac
            q(ii) = q(ii)*tqfac
c
            d(ir) = d(ir)*zdfac
            d(ii) = d(ii)*zdfac
c
            vz(ir) = vz(ir)*zdfac
            vz(ii) = vz(ii)*zdfac
         end do
      end do
      return
      end
