#include "params.h"
c#define USE_DATA_GAUAW
c#define READ_ALP_FROM_FILE
      subroutine initcom
C-----------------------------------------------------------------------
C
C Initialize Model commons, including COMCON, COMHYB, COMMAP, COMSPE,
C COMTIM and COMTRCNM
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C------------------------------Commons----------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comfft.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhyb.com"
C-----------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "comqmin.com"
C-----------------------------------------------------------------------
#include "comspe.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "comtrcnm.com"
C-----------------------------------------------------------------------
#ifdef PP_PCCM
#include "comparll.com"
#include "comglb.com"
#endif
C---------------------------Local variables-----------------------------
C
#ifdef WORD4
      real*8 zsi(plat),zw(plat)
#else
      real zsi(plat),zw(plat)
#endif

      real zra2           ! ra squared
#ifdef PP_PCCM
#  ifdef WORD4
      double precision zalp(2*p_gspt),zdalp(2*p_gspt),zsit
#  else
      real zalp(2*p_gspt),zdalp(2*p_gspt),zsit
#  endif
#else
#  ifdef WORD4
      double precision zalp(2*pspt),zdalp(2*pspt),zsit
#  else
      real zalp(2*pspt),zdalp(2*pspt),zsit
#  endif
#endif
      integer j,          ! Latitude index
     $        k,          ! Level index
     $        kk,         ! Level index
     $        kkk,        ! Level index
     $        m,          ! Index for legendre array
     $        inrc,       ! Plat/2
     $        nkk,        ! Print control variables
     $        ik1,        ! Print index temporary variable
     $        ik2         ! Print index temporary variable
      integer irow        ! Just for old times sake
      integer
     $        itmp        ! Dimension of polynomial arrays temporary.
      real    zdt,        ! Time step for settau
     $        zsq2        ! Sqrt(2)
      logical lprint      ! Debug print flag
      character*3 trnum   ! Advected species number (Character)
#ifdef READ_ALP_FROM_FILE
      integer polydata, navu, j, jskip, i
      external navu
#endif

C
C------------------------------Externals--------------------------------
C
      external hycoef,    ! Set hybrid coordinate control variables
     $         gauaw,     ! Compute gaussian weights
     $         trunc,     ! Set truncation control variables
     $         points,    ! Initialize buffer pointers
     $         settau,    ! Semi-implicit timestep
     $         resetr,    ! Reset real array
     $         phcs,      ! Compute associated Legendre polynomials
     $         reordp,    ! Reorder polynomials
     $         set99      ! System routine to initialize fft
C
C-----------------------------------------------------------------------
C
      lprint = .FALSE.
C
C Initialize COMCON
C
      cpair  = 1004.64
C
      epsilo = 0.622
      gravit = 9.80616
      latvap = 2.5104e06
      latice = 3.336e5
C
      omega  = 7.292e-5
      rair   = 287.04
      rearth = 6.37122e+6
      rh2o   = 4.61e2
      rhoh2o = 1.e3
C
      stebol = 5.67e-8
      tmelt  = 273.16
C
      cappa  = rair/cpair
      ez     = omega/sqrt(0.375)
      ra     = 1./rearth
      rga    = 1./gravit
C
      zvir   = rh2o/rair -1.
      cpwv   = 1.81e3
      cpvir  = cpwv/cpair - 1.
C
C Initialize commap.  Set hybrid level dependent arrays
C
      call hycoef(siga    ,sigb)
C
C NMAX dependent arrays
C
#ifdef PP_PCCM
      if (pmmax.gt.p_glon/2) then
#else
      if (pmmax.gt.plon/2) then
#endif
         write(6,*)'INITCOM:mmax=ptrm+1 .gt. plon/2'
         call endrun
      end if
      zra2 = ra*ra
      do j=2,pnmax
         sq(j)  = j*(j-1)*zra2
         rsq(j) = 1./sq(j)
      end do
      sq(1)  = 0.
      rsq(1) = 0.
C
C mmax dependent arrays
C
      do j=1,pmmax
         xm(j) = j-1
      end do
C
C Gaussian latitude dependent arrays
C
#ifdef PP_PCCM
      inrc = plat/2

#ifdef USE_DATA_GAUAW
      call gauaw_data(g_zsi,g_zw,p_glat)
#else
      call gauaw(g_zsi,g_zw,p_glat)
#endif

      do 140 j=1,inrc
         zsi(j) = g_zsi( j + m_pin_lt * plat/2 )
         sit(j) = zsi(j)
         sit_dbl(j) = zsi(j)
         zw(j) = g_zw( j + m_pin_lt * plat/2 )
         w(j) = zw(j)
         cs(j) = 1. - zsi(j)*zsi(j)
  140 continue
      do j=inrc+1,plat
         zsi(j) = g_zsi( j + (p_nproc_lt-m_pin_lt-1)*plat/2 )
         zw(j)  = g_zw(  j + (p_nproc_lt-m_pin_lt-1)*plat/2 )
      enddo
#else
      inrc = plat/2
      call gauaw(zsi     ,zw      ,plat    )
      do j=1,inrc
         sit(j) = zsi(j)
         w(j)   = zw(j)
         cs(j)  = 1. - zsi(j)*zsi(j)
      end do
#endif
      do j=1,plat
         hdwt(j) = zw(j)
      end do
C
C Integration matrices of hydrostatic equation(href) and conversion
C term(a).  href computed as in ccm0 but isothermal bottom ecref
C calculated to conserve energy
C
      do k=1,plev
         do kk=1,plev
            href(kk,k) = 0.
            ecref(kk,k) = 0.
         end do
      end do
C
C Mean atmosphere energy conversion term is energy conserving
C
      do k=1,plev
         ecref(k,k) = 0.5/hypm(k) * hypd(k)
         do kk=1,k-1
            ecref(kk,k) = 1./hypm(k) * hypd(kk)
         end do
      end do

C
C reference hydrostatic integration matrix matching ccm1
C
      do k = 1,plev
         do kk = k,plev
            href(kk,k) = ecref(k,kk)*hypd(kk)/hypd(k)
         end do
      end do

C
C print statements
C
      if (lprint) then
         nkk = plev/13
         if (mod(plev,13).ne.0) nkk = nkk + 1
         write(6,*)' '
         write(6,*)'INITCOM: Hydrostatic matrix href'
         do kk=1,nkk
            ik1 = 1 + (kk-1)*13
            ik2 = min0( ik1+12, plev )
            write(6,9920) (k,k=ik1,ik2)
            do kkk=1,plev
               write(6,9910) kkk,(href(kkk,k),k=ik1,ik2)
            end do
         end do
         write(6,*)' '
         write(6,*)'INITCOM: Thermodynamic matrix ecref'
         do kk=1,nkk
            ik1 = 1 + (kk-1)*13
            ik2 = min0( ik1+12, plev )
            write(6,9920) (k,k=ik1,ik2)
            do kkk=1,plev
               write(6,9910) kkk,(ecref(kkk,k),k=ik1,ik2)
            end do
         end do
      end if
C
C Multiply href by r
C
      do k=1,plev
         do kk=1,plev
            href(kk,k) = href(kk,k)*rair
         end do
      end do
C
C COMTIM variables
C
      dtime = .5*twodt
      nstep  = 0
C
C Compute truncation parameters
C
      write(6,9950) ptrm,ptrn,ptrk
#ifdef PP_PCCM
c
c SET UP ARRAYS FOR PARALLEL LONGITUDINAL DECOMPOSITION
c
      call decompose( m_pin_ln )
#endif
C
      call trunc
C
C Compute semi-implicit timestep constants (COMSPE)
C
      zdt = 0.5*twodt
      if (.not.nlres) zdt = 0.5*zdt
      call settau(zdt)
C
C Set names of advected species and consequent diagnostics
C
      do m=1,pcnst
         write(unit=trnum,fmt='(i3)') m+100
         hadvnam(m)  = 'HA'//trnum(2:3)
         vadvnam(m)  = 'VA'//trnum(2:3)
         vdiffnam(m) = 'VD'//trnum(2:3)
         dcconnam(m) = 'DC'//trnum(2:3)
         fixcnam(m)  = 'DF'//trnum(2:3)
         tendnam(m)  = 'TE'//trnum(2:3)
         tottnam(m)  = 'TA'//trnum(2:3)
#ifdef WORD4
         qmin(m)     =  1.e-10              ! Minimum mixing ratio
#else
         qmin(m)     =  1.e-12              ! Minimum mixing ratio
#endif
      end do
C
C Set the minimum mixing ratio for the counter-gradient term.  Normally this
C should be the same as qmin, but in order to match control case 414 use
C zero for water vapor.
C
      qmincg(1) = 0.
      do m=2,pcnst
         qmincg(m) = qmin(m)
      end do
C
C Water only
C
      tracnam(1)  = 'Q       '
C
C Non-water constituents only
C
      do m=2,pcnst
         write(unit=trnum,fmt='(i3)') m+100
         tracnam(m) = 'TR'//trnum(2:3)
         sflxnam(m) = 'SF'//trnum(2:3)
         srcnam(m)  = 'SS'//trnum(2:3)
      end do
C
C Sub-surface temperatures
C
      do k=1,plevmx
         if (k.lt.10) then
            write(unit=tsnam(k),fmt='(''TS'',i1,''     '')') k
         else
            write(unit=tsnam(k),fmt='(''TS'',i2,''    '')') k
         end if
      end do
C
C Compute constants related to Legendre transforms
C Compute and reorder ALP and DALP
C
      call resetr(alp     ,pspt*(plat/2) ,0.)
      call resetr(dalp    ,pspt*(plat/2) ,0.)
#ifdef READ_ALP_FROM_FILE

      polydata = navu()
      open ( polydata, file='poly.data',
     +       status='old', form='formatted' )

      itmp = 2*p_gspt-1
      jskip = m_pin_lt * plat / 2

      do  irow = 1, jskip
          read( polydata, 900 ) (zalp(i),i=1,itmp)
          read( polydata, 900 ) (zdalp(i),i=1,itmp)
      enddo

      do  irow = 1, plat/2
          read( polydata, 900 ) (zalp(i),i=1,itmp)
          read( polydata, 900 ) (zdalp(i),i=1,itmp)
          call reordp(irow,zalp,zdalp,pspt,itmp)
      enddo

      close( polydata )
  900 format(1p,6d22.14)
#else
      do 550 irow=1,plat/2
#ifdef PP_PCCM
         zsit = sit_dbl(irow)
c        write(0,123)m_pin_lt*plat/2+irow,zsit
c 123              format(1x,'SIT',I4,2X,D23.15)
         itmp = 2*p_gspt
#else
         zsit = sit(irow)
         itmp = 2*pspt-1
#endif
         call phcs  (zalp    ,zdalp   ,itmp    ,zsit    )
         call reordp(irow,zalp,zdalp,pspt,itmp)
C
C Multiply ALP and DALP by SQRT(2.) in order to get proper
C normalization. DALP is multiplied by -1 to correct for - sign
C in Copenhagen definition.
C
c this section out for pccm, and added the
c code to reordp instead so that sqrt(2) normalization can be
c done in double precision.
#ifndef PP_PCCM
         zsq2 = sqrt(2.)
         do 531 m=1,pspt
            alp(m,irow) = alp(m,irow)*zsq2
            dalp(m,irow) = -dalp(m,irow)*zsq2
  531    continue
#endif
  550 continue
#endif ! READ_ALP_FROM_FILE
C
C Set up trigonometric tables for fft
C
#ifdef PP_PCCM
#  ifndef PP_FFTX
      call rft_235i(p_glon, p_nproc_ln, m_pin_ln, mxtrigs, trig )
#  else
      call rft_235i(p_glon, 1, 0, mxtrigs, trig )
#  endif
#else
      call set99(trig    ,ifax    ,plon    )
#endif
      return
C
 9910 format( 1x,i3,13f9.5)
 9920 format(/,      13i9)
 9950 format(/,'     Truncation Parameters',/,'     NTRM = ',i4,/,
     $      '     NTRN = ',i4,/,'     NTRK = ',i4,/)
      end
