#include "params.h"
      subroutine intht(nlres,lbrnch,exist,lhbuf,parhist)
C-----------------------------------------------------------------------
C
C Initialize history tape handler for initial or continuation run.
C For example, on an initial run, this routine initializes "mtapes"
C history tapes.  On a restart run, this routine only initializes history
C tapes declared beyond what existed on the previous run.  Tapes which
C already existed on the previous run have already been initialized (i.e. 
C named and opened) in RESTRT.
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath 
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "ptrrgrid.com"
C-----------------------------------------------------------------------
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "pspect.com"
#include "comparll.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      logical nlres,       !  If true, continuation run
     $        lbrnch       !  If true, branch run
      logical exist        !  If true a regeneration hbuf file exists 
      logical parhist      !  If true, parallel history output
C
C Input/output arguments
C
      integer lhbuf        !  Length needed for history tape buffer,
C                          !   determined in fldlst.
C---------------------------Local variables-----------------------------
C
#if ( defined CRAY )
      integer
     $     iwsiz,          ! Expected total size of file in Cray words
     $     bsiz            ! Fortran I/O buffer length (real)
      character
     $     icsiz*4,        ! Buffer length (integer)
     $     text*152        ! Text for assign statement
#endif
      integer  itape,      ! Index through history tapes
     $         i,j,it,nf,  ! Indices
     $         ierr,       ! Return code from the OPEN statement.
     $         kflds,      ! field index
     $         totlen,     ! Total SSD usage
     $         lat         ! Latitude index
      character itf*5,     ! Temporary for starting file number
     $          fname*80,  ! File name
     $          uniqend*3, ! File name
     $          rgdir*120, ! Regeneration directory
     $          bbd*5      ! Processor row number
      character rfil*80    ! regeneration file name
      character tmp*80     ! Just a temporary string
      integer lenc         ! Length of pathname string
      integer navu, lenchr
#ifndef PP_PCCM           
      pointer (phbuf,buf1(lhbuf))  ! history buffer: dynamically allocated
      real buf1
#endif
#ifdef PP_INTEL_PFS
#include <fnx.h>
      integer fd,gopen
      external gopen
#endif
C
C------------------------------Externals--------------------------------
C
      external getmem,     ! interface to dynamically allocate memory
     $         freemem     ! interface to free dynam. allocated memory
      external navu,       ! Find next available Fortran unit number.
     $         lenchr,     ! Position of right-most non-blank character
     $         fldlst,     ! Generate field list information for all h-tapes
     $         ljust,  
     $         endrun, 
     $         bldfld, 
     $         assign, 
     $         inthed 
C
C-----------------------------------------------------------------------
C
C Build the master field list
C
      call bldfld
C
C Initialize only newly declared tapes if continuation run
C If initial run, mtapes is number of tapes requested.
C If continuation run, mtapes is the number of tapes from previous run.
C
      it = 1
c Modification for parallel code: regardless of the type of run, 
c we (re)initialize the history from the namelist.  JM 95/02/22.
c      if (nlres.and..not.lbrnch) it = mtapes + 1
      do itape=it,ptapes
         if (itape.eq.1) then
            hbufpt(itape) = 1
         else
            hbufpt(itape) = hbufpt(itape-1)
         end if
         nfils(itape) = 0
         write (itf,'(i5)') stfnum+10000
C
C Initialize history tape names.  If monthly averaged tape, use month-year
C format.  Bldfln will recognize a dash character in the third or fourth
C position as a monthly average history or restart tape and build a tape
C name using the current month and date
C
C Modification for the parallel code: 
C If PARHIST is true, the model writes one history
C file per east-west row of processors; if false, it writes one history
C file, period.  The intel PFS option for parallel writes to one file
C has been added under the PARHIST = .TRUE. branch.  For PFS there is
C only one filename and so no appendage is required.
C
         if ( .not. parhist ) then
           if ( .not.nlres .or. lbrnch ) then
             if (itape.eq.1) then
              nhfil(itape) = 'h'//itf(2:5)
              if (ninavg(1).eq.'Q') then
                 nhfil(itape) = '00-00'
                 call bldfln(nhfil(itape))
              end if
             else
C
C Make auxiliary tape names starting with 'a'.  ex: aux. tape 1 = ha0001,
C aux. tape 2 = hb0001.
C
              nhfil(itape) = 'h'//char(itape+95)//itf(2:5)
             end if
           else
             call bldfln(nhfil(itape))
           endif
         else
#ifdef PP_INTEL_PFS
           write (bbd,'(i5)') 10000
#else
           write (bbd,'(i5)') m_pin_lt+10000                      
#endif
           if ( .not.nlres .or. lbrnch ) then
             if (itape.eq.1) then                                
               if(ninavg(1).eq.'Q') then                        
                 nhfil(itape) = '00-00.'//bbd(2:5)            
                 call bldfln_a(nhfil(itape),m_pin_lt)        
               else                                         
                 nhfil(itape) = 'h'//itf(2:5)//'.'//bbd(2:5) 
               endif
             else
               
               nhfil(itape) = 
     $          'h'//char(itape+95)//itf(2:5)//'.'//bbd(2:5)
             endif                                          
           else
	     tmp = nhfil(itape)
	     if ( tmp(1:1) .eq. 'h' ) then    ! eliminate uninited tapes from
					      ! previous run
               if (itape.eq.1) then                        
                 if(ninavg(1).eq.'Q') then                
                   nhfil(itape) = '00-00.'//bbd(2:5)     
                   call bldfln_a(nhfil(itape),m_pin_lt) 
                 else                                  
                   tmp = nhfil(itape)
                   nhfil(itape) = tmp(1:5)//'.'//bbd(2:5)            
                   call bldfln_a(nhfil(itape),m_pin_lt)              
                 endif
               else
                 tmp = nhfil(itape)
                 nhfil(itape) =  tmp(1:6)//'.'//bbd(2:5)
                 call bldfln_a(nhfil(itape),m_pin_lt)               
               endif                                               
	     endif
           endif
         endif
      end do
C
C Define field list information for all tapes.  Update mtapes to reflect
C *current* number of tapes.
C
      call fldlst(lhbuf)
      if (mtapes.gt.ptapes) then
         write(6,*)
     $       'INTHT: Too many history tapes declared, max=',ptapes
         write(6,*)'To increase, change parameter ptapes.'
         call endrun
      end if
C
C If restart run, itape=1,it-1 tapes have already been initialized in restrt
C Do the rest here.
C
      ierr =0
      if (it.le.mtapes) then
         do 10 itape=it,mtapes
C
C Find available unit number for disk file
C
            hunit(itape) = navu()
	   if(parhist) then
#ifdef PP_INTEL_PFS
	    fd = gopen( hunit(itape), nhfil(itape), M_LOG )
	    ierr = 0
#else
#ifdef SIMPLE_OUTPUT
            open(unit=hunit(itape),
     $       file='history/atmos/'//nhfil(itape),
     $           form='UNFORMATTED',
     $           status='UNKNOWN',iostat=ierr)
#else
            open(unit=hunit(itape),file=nhfil(itape),form='UNFORMATTED',
     $           status='UNKNOWN',iostat=ierr)
#endif
#endif
	   else
	    if(m_pin .eq. mapmesh(0,0)) then
#ifdef SIMPLE_OUTPUT
            open(unit=hunit(itape),file=
     $           'history/atmos/'//nhfil(itape),
     $           form='UNFORMATTED',
     $           status='UNKNOWN',iostat=ierr)
#else
            open(unit=hunit(itape),file=nhfil(itape),form='UNFORMATTED',
     $           status='UNKNOWN',iostat=ierr)
#endif
            endif
	   endif
            if(ierr.ne.0) then
               write(6,*)'INTHT: Failed to open file ',nhfil(itape),
     $              ' ierr=',ierr
               call endrun
            end if
            write(6,*)'INTHT: Successfully opened file ',nhfil(itape),
     $           ' on hunit(itape)= ',hunit(itape)
C
C Save pathnames for header
C
            nfpath(itape) = nhpath(1:nhpthl)//nhfil(itape)
            cpath(itape) = nfpath(itape)
            ppath(itape) = '        '
   10    continue
      end if
C
C No history regeneration available: accumulators need to be zero
C NNRG3 defines the number of regeneration units for a particular
C tape.  If nnrg3 is 0 then a history regeneration buffer does not
C exist and the appropriate section of the accumulation array is set
C to zero
C
      kflds=1
      do itape=1,mtapes
         if (nnrg3(itape).eq.0) then 
            do j=1,plat
               do i=kflds,kflds+nflds(itape)-1
                  nacs(i,j) = 0
               end do
            end do
         end if
         kflds=kflds+nflds(itape)
      end do
C
C Call inthed to set header variables which are common to all tapes
C
      call inthed(mtapes  ,caseid,  ctitle  )
C
C Assign and open regeneration files.  If this is a restart run then unit
C numbers and extentions have already been assigned in restrt.
C
      if (ninavg(1).eq.'Q'.and..not.nlres) then
C
C The primary history regeneration file will begin with the extention h0
C (  Ex. h0001 will have a restart of rxx-xx.h0.x
         do nf = 1, pnrg3
            nrg3(nf,1) = navu()
            rg3ext(nf,1) = '.h0'//'.'//char(48+nf)  
         end do
C
C Auxiliary tape extentions will match the history tape name with which they
C are associated. 
C (  Ex. ha0001 will have a restart of rxx-xx.ha.x
C        hb0001 will have a restart of rxx-xx.hb.x   )
C
         do itape=1,mtapes-1
            do nf = 1, pnrg3
               nrg3(nf,itape+1) = navu()
               rg3ext(nf,itape+1) = '.h'//char(96+itape)//
     $              '.'//char(48+nf)  
            end do
         end do
      end if
C
C Attach regeneration units to history tape regeneration files
C
      exist=.false.
      do itape=1,mtapes
         if (.not.lbrnch .and. rgnht(itape)) then
            lenc   = lenchr(rgpath)
            if (rgpath(lenc-5:lenc-5).eq.'-') then
               rfil  = rgpath(lenc-8:lenc-3)
               rgdir  = rgpath(1:lenc-9)
               uniqend= rgpath(lenc-2:lenc)
            else if (rgpath(lenc-2:lenc-2).eq.'-') then
               rfil  = rgpath(lenc-5:lenc)
               rgdir  = rgpath(1:lenc-6)
               uniqend= ' '//' '//' '         
            else
               rfil  = rgpath(lenc-4:lenc)
               rgdir  = rgpath(1:lenc-5)
               uniqend= ' '//' '//' '         
            end if
            do nf = 1, nnrg3(itape)
               fname = rfil(1:lenchr(rfil)) // rg3ext(nf,itape)//uniqend
               call attach(nrg3(nf,itape) ,rgdir(1:lenchr(rgdir))//fname
     $              ,fname   ,rg3buf(itape)/512+1  ,'U'     ,
     $              .true.   )
               exist=.true.
            end do
         end if
      end do
C     

ccc  moved into ccm2.F
ccc
cccC Read the history buffer regeneration files 
cccC The logical open will be true if history buffer regeneration files
cccC exist     
ccc      if (exist) call splitg(hbuf, lhbuf)
cccC

C Print summary of unit assignments
C
      write(6,9000)
 9000 format(6x,'**** Summary of Logical Unit assignments ****'/)
      write(6,9010) ninit
 9010 format('   Initial dataset unit (ninit)       = ',i3)
      write(6,9020) nbndti,nozone,nsst
 9020 format('   Time-inv boundary dataset (nbndti) = ',i3/
     $       '   Ozone dataset unit (nozone)        = ',i3/
     $       '   SST dataset unit (nsst)            = ',i3)
      write(6,9030) nra1,nrb1,sunit,nabem
 9030 format('   SDS save file A (nra1)             = ',i3/
     $       '   SDS save file B (nrb1)             = ',i3/
     $       '   History tape buffer (sunit)        = ',i3/
     $       '   SDS abs/ems save file (nabem)      = ',i3)
      do i=1,mtapes
         write(6,9040)i,hunit(i)
      end do
 9040 format('   History tape number ',i2,'             = ',i3)
      write(6,9050) nsds
 9050 format('   Restart dataset unit (nsds)        = ',i3)
      write(6,9060) nrg
 9060 format('   Master regeneration unit (nrg)     = ',i3)
      write(6,9070) nrg1
 9070 format('   Regeneration dataset units (nrg1)  = ',20(i3,1x))
      write(6,9080) nrg2
 9080 format('   Abs/ems unit for restart (nrg2)    = ',20(i3,1x))
      if (ninavg(1).eq.'Q') then 
         write(6,9090) (nrg3(i,1),i=1,pnrg3)
         do i=2,mtapes
            write(6,9095)i,nrg3(1,i),nrg3(2,i),nrg3(3,i),
     $           nrg3(4,i),nrg3(5,i)
         end do
      end if
 9090 format('   Regeneration units for hist tape 1 = ',
     $     20(i3,1x))
 9095 format('   Regeneration units for hist tape ',i1,' = ',
     $     20(i3,1x))
      return
C
   20 write(6,*)'INTHT: Unable to open file sunit: ios=',ierr
      call endrun
      end

