#include "params.h"
#ifdef COUPLED
      subroutine preset(rsfrq,hsfrq,rnlng)
#else
      subroutine preset
#endif
C-----------------------------------------------------------------------
C
C Preset $CCMEXP input parameters and variables set directly
C from input parameters to default values
C
C------------------------------Code history-----------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif

#ifdef COUPLED
      integer rsfrq,hsfrq,rnlng
#endif

C-----------------------------Parameters--------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C------------------------------Commons----------------------------------
#include "comadj.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhd.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comtfc.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "comvmr.com"
#include "comsol.com"
C-----------------------------------------------------------------------
C----------------------------Local varables-----------------------------
C
      integer i,j          ! Indices
C
C-----------------------------------------------------------------------
C
C Set flag for end-of-run
C
      nlend = .false.
      nlres = .false.
      nlhst = .false.
      lbrnch = .false.
C
C Output tape default values
C
      nsrest = 0
      nswrps = '        '
      nsmvn  = 'CTPUBLIC'
      nrmvn  = 'CTPUBLIC'
      nsvsn  = '        '
      do i=1,80
         ctitle(i:i) = ' '
         ncdata(i:i) = ' '
         bndti(i:i)  = ' '
         bndtvs(i:i) = ' '
         bndtvo(i:i) = ' '
      end do
      irt    = 99999
cbds  rirt   = 99999
      stfnum = 1
      nlfilt = .false.
      ldebug = .false.
      do i=1,ptapes
         ndens(i)  =  1
         mfilt(i)  =  5 
         ninavg(i) = 'A'
C
C Preset variables for monthly average case
C
         rgnht(i)=.false.
         nnrg3(i)=0
         rg3buf(i)=0
      end do
      rg3num=0
      async = .true.
      do i=1,pflds
         exclude(i) = '        '
         primary(i) = '        '
         do j=1,ptapes-1
            aux(i,j) = '        '
         end do
      end do
C
C Output time defaults
C
#ifdef COUPLED
      nhtfrq(1) = hsfrq * TSPDAY
      nelapse = rnlng * TSPDAY
      nestep  = -999999999
      nrefrq = rsfrq/hsfrq
#else
      nhtfrq(1) = -24
      do i=2,ptapes
         nhtfrq(i) = 0
      end do

C
C Set ending time step and elapsed time to very large number of days
C to allow user to input 0 values (run "0" time steps)
C
      nestep  = -999999999
      nelapse = -999999999
      nrefrq = 1
#endif
      mresfq = 999
C
C Cycle flags
C
      sstcyc = .true.
      ozncyc = .true.

C
C Model time defaults
C
      nndbas = -9999
      nnsbas = -9999
      nnbdat = -9999
      nnbsec = -9999
C
      dtime = 1200.
C
C Frequency in iterations of absorptivity/emissivity calc (negative
C values in model hours)
C
      iradae = -12
C
C Frequency of annual cycle sst update
C
      itsst  =  1
C
C Default frequency of shortwave and longwave radiation computations: 
C once per hour
C
      iradsw = -1
      iradlw = -1
C
C Numerical scheme default values
C
      eps    = 0.06
      dif2   = 2.5e5
      dif4   = 1.e16
      kmxhdc = 1
      nlvdry = 3

C
C Initialize volume mixing ratios
C

C  Modern (circa 1990)  values
c     co2vmr  =  3.55e-4
c      n2ovmr  =  0.311e-6
c      ch4vmr  =  1.714e-6
c      f11vmr  =  0.280e-9
c      f12vmr  =  0.503e-9

c 1975 values
      co2vmr  =  3.35e-4
      n2ovmr  =  0.302e-6
      ch4vmr  =  1.500e-6
      f11vmr  =  0.130e-9
      f12vmr  =  0.30e-9

      scon = 1.367e6
      tauvis = .14

C  pre-industrial values
c     co2vmr  =  2.80e-4
c     n2ovmr  =  0.275e-6
c     ch4vmr  =  0.700e-6
c     f11vmr  =  0.0
c     f12vmr  =  0.0


c Pre-industrial values used in PaleoCSM
c listed here for reference
c     scon = 1.365e6
c     tauvis = .11


      

C
C SLT transport by default
C
      doslt = .true.
C
C No diurnal averaging is default
C
      dodiavg = .false.
C
C Maximum size of regeneration files (megabytes)
C
      mxszrg = 150
C
C Whether or not to check remaining CPU time to stop model gracefully
C
      cpuchek = .false.
C
C Accumulate restart files or toggle between two files?
C
      accrst = .false.
C
C Write history tape in parallel (1 file per row of procs) or single file.
C
      parhist = .false.
C
      return
      end
