#include "params.h"
      subroutine scan1a(pmap    ,wfld    ,psslt   ,kdpmpf  ,kdpmph  ,
     $                  lam     ,phi     ,dphi    ,gw      ,sinlam  ,
     $                  coslam  ,lbasdy  ,lbasdz  ,lbassd  ,lbasiy  ,
     $                  detam   ,detai   ,dlam    ,cwava   ,etamid  ,
     $                  etaint)
C-----------------------------------------------------------------------
C
C     !  SLT SCAN
C
C-----------------------------------------------------------------------
      implicit none
#include "pmgrid.com"
C-----------------------------------------------------------------------
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C-----------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "com3d.com"
C-----------------------------------------------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#ifdef PP_PCCM
#include "comparll.com"
#include "sltovr.com"
#endif
#ifdef INTERVAL_TIMER
#include "timers.com"
#endif
c
c     !  Input arguments
c
      integer pmap
      real wfld(plon,plevp,plat),   ! Vertical motion (slt)
     $     psslt(plond,plat)
      integer
     $     kdpmpf(pmap),
     $     kdpmph(pmap)
      real lam(plond),
     $     gw(plat),
     $     sinlam(plon),
     $     coslam(plon),
     $     lbasdz(4,2,plev),
     $     lbassd(4,2,plevp),
#ifdef PP_PCCM
     $     phi(platd,2),
     $     dphi(platd,2),
     $     lbasdy(4,2,platd,2),
     $     lbasiy(4,2,platd,2),
#else
     $     phi(platd),
     $     dphi(platd),
     $     lbasdy(4,2,platd),
     $     lbasiy(4,2,platd),
#endif
     $     detam(plev),
     $     detai(plevp),
     $     dlam,
     $     cwava,
     $     etamid(plev),
     $     etaint(plevp)
c
c     !  Local workspace
c
      integer itermx,itermn
      parameter(itermx=4,itermn=1)
#ifdef PP_PCCM
      integer ih
      real f_locsum
      real hw1_hemi(pcnst,2)
      real hw1lat_tmp(plat,pcnst)
      real uxl(plond,plev,2,platd,2),uxr(plond,plev,2,platd,2),
     $     qxl(plond,plev,pcnst,platd,2),qxr(plond,plev,pcnst,platd,2)
#else
      real uxl(plond,plev,2,platd),uxr(plond,plev,2,platd),
     $     qxl(plond,plev,pcnst,platd),qxr(plond,plev,pcnst,platd)
#endif
      real pmid(plond,plev),
     $     pint(plond,plevp),
     $     pdel(plond,plev)
      real hw1lat(pcnst,plat)
c
C     !  Set time increment.
c
      real ztodt
      integer irow,iter,jcen,lat,m
      ztodt = twodt
      if(nstep.eq.0) ztodt = .5*twodt
c
C     !  Initialize extended arrays
c
#ifdef PP_PCCM
#   ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_SLTINI, 0 )
#   endif
      call sltini(dlam,sinlam,coslam,u3(1,1,1,1,n3),v3(1,1,1,1,n3),
     $            q3(1,1,1,1,1,n3m1),uxl,uxr,qxl,qxr,nxpt_a)
#   ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_SLTINI, 0 )
#   endif
c
c     !  Reset the message type counter since sltini uses explicit types
c
      m_type = 10000
#else
      call sltini(dlam,sinlam,coslam,u3(1,1,1,n3),v3(1,1,1,n3),
     $            q3(1,1,1,1,n3m1),uxl,uxr,qxl,qxr)
#endif
      if(nstep .le. 1) then
         iter = itermx
      else
         iter = itermn
      endif
c
C     !  Initialize moisture mass integrals.
c
      do 138 m=1,pcnst
         do 137 lat=1,plat
            hw1lat(m,lat) = 0.0
  137    continue
  138 continue
C
C     !  Change multitasking directive to make pdel,pint,pmid private
C
CMIC$ DO ALL SHARED(CWAVA, N3M1, PMAP, ZTODT, ITER, N3, PSSLT,
CMIC$1   W, Q3, HW1LAT, U3, UXL, UXR, V3, WFLD, QXL, QXR, LAM, PHI
CMIC$2   , DPHI, ETAMID, ETAINT, DETAM, DETAI, LBASDY, LBASDZ, LBASSD,
CMIC$3   LBASIY, KDPMPF, KDPMPH, LAMMP, PHIMP, SIGMP, QFCST, HQFCST)
CMIC$4   PRIVATE(LAT, IROW,JCEN,PINT,PMID,PDEL)
#ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_SLT, 0 )
#endif
      do 180 lat=1,plat
#ifdef PP_PCCM
         if(lat.le.plat/2) then
            irow = lat
	    ih = 1
	    jcen = j1m + lat
         else
            irow = plat + 1 - lat
	    ih = 2
	    jcen = j1m + lat - p_lato2
         end if
         call plevs0(psslt(1,lat),pint,pmid,pdel)
c
C     !  Calculate mass of moisture in field being advected by slt.
c
         call qmassa(cwava,w(irow),q3(i1,1,1,jcen,ih,n3m1),pdel,
     $               hw1lat(1,lat))
c
C     !  Call slt interface routine.
c
         call sltb1(pmap,jcen,lat,ztodt,ra,iter,u3(1,1,1,ih,n3),
     $              uxl(1,1,1,1,ih),uxr(1,1,1,1,ih),
     $              v3(1,1,1,ih,n3),
     *              wfld(1,1,lat),q3(1,1,1,1,ih,n3m1),
     $              qxl(1,1,1,1,ih),qxr(1,1,1,1,ih),
     *              lam,phi(1,ih),dphi(1,ih),etamid,etaint,detam,detai,
     $              lbasdy(1,1,1,ih),lbasdz,lbassd,lbasiy(1,1,1,ih),
     $              kdpmpf,kdpmph,
     $              lammp(1,1,lat),phimp(1,1,lat),
     *              sigmp(1,1,lat),qfcst(1,1,1,1,ih),hqfcst,
     $              nxpt_a(1,jcen,ih))
#else
         if(lat.le.plat/2) then
            irow = lat
         else
            irow = plat + 1 - lat
         end if
         jcen = j1m + lat
         call plevs0(psslt(1,lat),pint,pmid,pdel)
c
C     !  Calculate mass of moisture in field being advected by slt.
c
         call qmassa(cwava,w(irow),q3(i1,1,1,jcen,n3m1),pdel,
     $               hw1lat(1,lat))
c
C     !  Call slt interface routine.
c
         call sltb1(pmap,jcen,lat,ztodt,ra,iter,u3(1,1,1,n3),uxl,uxr,
     $              v3(1,1,1,n3),
     *              wfld(1,1,lat),q3(1,1,1,1,n3m1),qxl,qxr,
     *              lam,phi,dphi,etamid,etaint,detam,detai,
     $              lbasdy,lbasdz,lbassd,lbasiy,kdpmpf,kdpmph,
     $              lammp(1,1,lat),phimp(1,1,lat),
     *              sigmp(1,1,lat),qfcst,hqfcst)
#endif
  180 continue
#ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_SLT, 0 )
#endif
#ifdef PP_PCCM
c
c    Accumulate hw1lat() over the processor row
c
      call rowsum0(hw1lat,r_tmp,plat*pcnst,m_type)
      m_type = m_type + 2*p_nproc
c      
      do m=1,pcnst
	  do lat = 1,plat
	     hw1lat_tmp(lat,m) = hw1lat(m,lat)
	  enddo
          hw1_hemi(m,1) = 
     $           f_locsum( hw1lat_tmp(1,m),plat/2,r_tmp )
          hw1_hemi(m,2) = 
     $           f_locsum( hw1lat_tmp(plat/2+1,m),plat/2,r_tmp )
      enddo
c
      call colsum0(hw1_hemi,r_tmp,pcnst*2,m_type)
      m_type = m_type + 2*p_nproc

      do m=1,pcnst
          hw1(m) = hw1_hemi(m,1) + hw1_hemi(m,2)
      enddo
#else
      do 200 m=1,pcnst
         hw1(m) = 0.
  200 continue
      do 220 m=1,pcnst
         do 210 lat=1,plat
            hw1(m) = hw1(m) + hw1lat(m,lat)
  210    continue
  220 continue
#endif
c
C     !  Diagnostic write after latitude loop finished.
c
#ifdef PP_ERROR
         write(0,*)' ***scan1a: hw1 = ',hw1
#endif
      return
      end
