#include "params.h"
      subroutine sstint(iunit)
C---------------------------------------------------------------------
C
C     !  Time interpolate sea surface temps. to current time, reading
C     !  in new monthly data if necessary
C
C---------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------commons--------------------------------
#include "comctl.com"
C---------------------------------------------------------------------
#include "comsst.com"
C---------------------------------------------------------------------
#include "comtim.com"
C----------------------------local workspace--------------------------
#ifdef PP_PCCM
#include "pspect.com"
#include "comparll.com"
#endif
      real fldsin(ptvsfld*plon),
     $     hdr(plenhr)             ! Array for real header record
#ifdef PP_PCCM
      character*8 hdc(plenhc)       ! Array for character header record
      integer hdi(plenhi),          ! Array for integer header record
     $        mtvfl(3,ptvsfld)      ! mflds for boundary dataset header
#else
      character*8 hdc(89)          ! Array for character header record
      integer hdi(37),             ! Array for integer header record
     $        mtvfl(3,ptvsfld)      ! mflds for boundary dataset header
#endif
      integer readl,
     $        nlonwl,             ! Local copies of header variables
     $        nfldhl,
     $        ncdatel,
     $        ncsecl
      integer n
      real flat,
     $     flon
      character*8 mctvfl(2,ptvsfld) ! mcflds for boundary dataset header
C------------------------------externals----------------------------------
      external rdharr, prnthd, bnddyi, rdhdr
C
      real cday,fact
      integer i,ier,iunit,j,lat,lyr
      cday = calday
      if (.not.sstcyc) cday = float(mcdate/10000)*
     $    real(YEAR_LENGTH) + cday
C
C Check to see if we need to read another month-s data
C
      if (ldoy.gt.ndoy) ndoy = ndoy + real(YEAR_LENGTH)
      if (cday.lt.ldoy) cday = cday + real(YEAR_LENGTH)
      if (cday.gt.ndoy) then
         ldoy = ndoy
         if (sstcyc) then
            ldoy = amod(ldoy,real(YEAR_LENGTH))
            cday = amod(cday,real(YEAR_LENGTH))
         endif
         lyr = nyr
         do 10 j=1,plat
            do 5 i=1,plon
               sstm(i,j,1) = sstm(i,j,2)
    5       continue
   10    continue
   15    continue
        call rdhdr(iunit   ,ptvsleni,ptslenis,ptvslenc,ptslencs,
     $              plenhr  ,hdi     ,hdc     ,hdr     ,mtvfl   ,
     $              mctvfl  ,ier     )
         if (ier.ne.0) then
            if (sstcyc) then
#ifdef PP_PCCM
               if ( m_pin .eq. mapmesh(0,0) ) then
#endif
               write(6,*)'SSTINT:Rewinding file'
               rewind iunit
#ifdef PP_PCCM
               endif
#endif
               go to 15
            else
               write(6,*)'SSTINT:Multiyear file assumed. EOF read.'
               call prnthd(0,hdi(1),hdi(31),hdi(32),hdi,hdc,hdr,
     $                     mtvfl,mctvfl,.true.)
               call endrun
            endif
         endif
         ncdatel = hdi(26)
         write(6,*)'SSTINT:Read sst data for date (yymmdd) ',ncdatel
         ncsecl = hdi(27)
         nyr = ncdatel/10000
         call bnddyi(ncdatel  ,ncsecl  ,ndoy)
         if (.not.sstcyc) then
            ndoy = float(nyr)*real(YEAR_LENGTH) + ndoy
         else if (ndoy.lt.ldoy) then
            ndoy  = ndoy + real(YEAR_LENGTH)
         endif
C
C Test to see if consecutive time slices are too far apart, fatal error
C
         if (ndoy.gt.ldoy+45.) then
            write(6,*)'SSTINT:Error>>>>>Two consecutive time slices'
            write(6,*)'on sst dataset are more than 45 days apart'
            call prnthd(0,hdi(1),hdi(31),hdi(32),hdi,hdc,hdr,
     $                  mtvfl,mctvfl,.true.)
            call endrun
         endif
         readl = hdi(6) - 2
         nlonwl = hdi(10)
         nfldhl = hdi(16)
         do 45 n=1,plat
#ifdef PP_PCCM
            call rdharr(iunit,ptvsfld*plon,flat,flon,fldsin,n,plat)
#else
            call rdharr(iunit   ,readl  ,flat    ,flon    ,fldsin)
#endif
            lat = nint(flat)               ! at this point lat is global
#ifdef PP_PCCM
            if ( lat .gt. p_glat/2 ) then  ! north
               lat = plat/2 + mod(lat-1,plat/2) + 1
            else                           ! south
               lat = mod(lat-1,plat/2) + 1
            endif
#endif
            call mkslic('SST     ',sstm(1,lat,2),1       ,
     $               mtvfl     ,mctvfl        ,nfldhl  ,
     $               fldsin    ,ptvsfld*plon  ,plon    ,
     $               nlonwl    ,plond         ,plev)
   45    continue
      endif
C
C Linear time interpolation of sst-s
C
C      write(6,*)'ldoy,cday,ndoy=',ldoy,cday,ndoy
      fact = (cday - ldoy)/(ndoy - ldoy)
      do 50 j=1,plat
         do 47 i=1,plon
            sst(i,j) = sstm(i,j,1) + fact*
     $                (sstm(i,j,2) - sstm(i,j,1))
   47    continue
   50 continue
      return
      end
