#include "params.h"
#ifdef PP_PCCM
      subroutine tstep(mm,zdt,ztdtsq)
#else
      subroutine tstep(m,zdt,ztdtsq)
#endif
C-----------------------------------------------------------------------
C
C     !  SOLUTION OF HELMHOLTZ EQUATION AND COMPLETION OF
C     !  TIMESTEP BY ADDING SEMI-IMPLICIT PART
C
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C-----------------------------------------------------------------------
#include "comhyb.com"
C-----------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "comspe.com"
      real bm1eq(plev,plev,pnmax)
      equivalence (bm1eq,bm1)
C-----------------------------------------------------------------------
#ifdef PP_PCCM
#include "comparll.com"
C-----------------------------------------------------------------------
      integer mm
#endif
      integer m
      real z(2*pnmax,plev),
     $     zdt,
     $     ztdtsq(2*pnmax)    ! zdt*sq
      real arrout(psp)
c declarations inserted by implnone
      real hbps,hxg,ztemp
c declarations inserted by implnone
      integer ii,iia,iikk,ir,ira,irkk,j,k,kk,mc,mck,mckk,mr,n
C
#ifdef PP_PCCM
      mr = m_offalp(mm)
      m = m_mtrue(mm) + 1
#else
      mr = nstart(m)
#endif
      mc = 2*mr
      do k=1,plev
C
C diagonal terms
C
         hxg = 0.5*href(k,k)
cplx17         hxg = 0.5*xg(k,k)
         hbps = 0.5*bps(k)
C
C add d(t-1), first setting pointers for each m
C
#ifdef PP_PCCM
         mck = (k-1)*m_nspect2 + mc
         do n=1,m_lenalp(mm)
#else
         mck = (k-1)*psp + mc
         do n=1,nlen(m)
#endif
            ira = mc + 2*n - 1
            iia = ira + 1
c
            ir = mck + 2*n - 1
            ii = ir + 1
            d(ir) = d(ir) +
     $          ztdtsq(n+m-1)*(hxg*t(ir) + hbps*alps(ira))
            d(ii) = d(ii) +
     $          ztdtsq(n+m-1)*(hxg*t(ii) + hbps*alps(iia))
         end do
         if (k.lt.plev) then
            do kk=k+1,plev
#ifdef PP_PCCM
               mckk = (kk-1)*m_nspect2 + mc
C
C triangular terms of g
C
               hxg = 0.5*href(kk,k)
cplx17               hxg = 0.5*xg(kk,k)
               do n=1,m_lenalp(mm)
#else
               mckk = (kk-1)*psp + mc
C
C triangular terms of g
C
               hxg = 0.5*href(kk,k)
cplx17               hxg = 0.5*xg(kk,k)
               do n=1,nlen(m)
#endif
                  irkk = mckk + 2*n - 1
                  iikk = irkk + 1
c
                  ir = mck + 2*n - 1
                  ii = ir + 1
                  d(ir) = d(ir) + ztdtsq(n+m-1)*hxg*t(irkk)
                  d(ii) = d(ii) + ztdtsq(n+m-1)*hxg*t(iikk)
               end do
            end do
         end if
      end do
C
C solution of helmholtz equation
C First: initialize hulp fields
C
      do k=1,plev
         do j=1,2*pnmax
            z(j,k) = 0.
         end do
      end do
C
C set pointers for each n; start outer loop over levels
C
      do k=1,plev
C
C set pointers for each level in outer loop
C start inner loop over levels
C
#ifdef PP_PCCM
         do kk=1,plev
            mck = (kk-1)*m_nspect2 + mc
C
C solve helmholtz eq. in loop over m
C
CDIR$ IVDEP
            do n=1,m_lenalp(mm)
#else
         do kk=1,plev
            mck = (kk-1)*psp + mc
C
C solve helmholtz eq. in loop over m
C
CDIR$ IVDEP
            do n=1,nlen(m)
#endif
               ir = mck + 2*n - 1
               ii = ir + 1
               z(2*n-1,k) = z(2*n-1,k) + bm1eq(kk,k,m+n-1)*d(ir)
               z(2*n  ,k) = z(2*n  ,k) + bm1eq(kk,k,m+n-1)*d(ii)
            end do
         end do
      end do
C
C store solution in field rh
C
      do k=1,plev
#ifdef PP_PCCM
         mck = (k-1)*m_nspect2 + mc
         do n=1,m_lenalp(mm)
#else
         mck = (k-1)*psp + mc
         do n=1,nlen(m)
#endif
            ir = mck + 2*n - 1
            ii = ir + 1
            d(ir) = z(2*n-1,k)
            d(ii) = z(2*n  ,k)
         end do
      end do
C
C add semi-implicit part to prognostic variables
C ln(pstar) and t
C add semi-implicit part to surface pressure;one level only
C
      do k=1,plev
#ifdef PP_PCCM
         mck = (k-1)*m_nspect2 + mc
         ztemp = zdt*hypd(k)/hypi(plevp)
         do n=1,m_lenalp(mm)
#else
         mck = (k-1)*psp + mc
         ztemp = zdt*hypd(k)/hypi(plevp)
         do n=1,nlen(m)
#endif
            ira = mc + 2*n - 1
            iia = ira + 1
c
            ir = mck + 2*n - 1
            ii = ir + 1
            alps(ira) = alps(ira) - ztemp*d(ir)
            alps(iia) = alps(iia) - ztemp*d(ii)
         end do
      end do
C
C add semi-implicit part to temperature
C
      do k=1,plev
#ifdef PP_PCCM
         mck = (k-1)*m_nspect2 + mc
#else
         mck = (k-1)*psp + mc
#endif
         do kk=1,plev
#ifdef PP_PCCM
            mckk = (kk-1)*m_nspect2 + mc
            ztemp = zdt*tau(kk,k)
cplx17         ztemp = zdt*xtau(kk,k)
            do n=1,m_lenalp(mm)
#else
            mckk = (kk-1)*psp + mc
            ztemp = zdt*tau(kk,k)
cplx17         ztemp = zdt*xtau(kk,k)
            do n=1,nlen(m)
#endif
               irkk = mckk + 2*n - 1
               iikk = irkk + 1
c
               ir = mck + 2*n - 1
               ii = ir + 1
               t(ir) = t(ir) - ztemp*d(irkk)
               t(ii) = t(ii) - ztemp*d(iikk)
            end do
         end do
      end do
      return
      end
