#include "params.h"
      subroutine atchbnd(iunit   ,mspath  ,bsiz    ,form)
C----------------------------------------------------------------------
C
C Attach boundary dataset to job
C
C----------------------------------------------------------------------
      implicit none
C----------------------------arguments---------------------------------
      integer iunit          ! Logical unit number
      character mspath*(*)   ! full mass store path name
      integer bsiz           ! buffer size in blocks
      character*1 form       ! U=unformatted, F=formatted
C--------------------------local variables-----------------------------
      logical lexist         ! Check for file existence
      character itmp*2,
     $          iuch*2,      ! Character unit number
     $          text*130     ! String for assign
      integer lenloc,        ! Length of local dataset name
     $        klen,          ! Length of mass store pathname
     $        i
      character idnloc*14,
     $          tdn*14
      integer ierr
#ifdef PP_PCCM
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"
#  ifndef PP_PCCM
      data m_pin /0/
#  endif
      character errmess*256
#endif
C----------------------------externals---------------------------------
      integer lenchr
      external attach,  lenchr,  ljust
C
C Build local dataset name
C
#ifdef PP_PCCM
      if ( m_pin .eq. mapmesh(0,0) ) then
         open(unit = iunit, file = mspath, form='UNFORMATTED', 
     $        status = 'OLD', 
     $        err = 3001 )
      else
	 return		! data will come in from node 0
      endif
      goto 3002
 3001 continue
      write(errmess,*)'atchbnd.F: error opening input data set ', mspath
      call abortf(errmess)
      stop ! shouldn t get here
 3002 continue
#else
      klen = lenchr(mspath)
      idnloc = '                '
      do 20 i=klen,1,-1
         if (mspath(i:i).ne.'/') then
            tdn = mspath(i:i)//idnloc(1:14)
            idnloc = tdn
         else
            go to 25
         endif
   20 continue
   25 continue
      lenloc = lenchr(idnloc)
C
C First check if file is in current directory
C
      inquire(file=idnloc(1:lenloc),exist=lexist)
      if (lexist) then
         write(itmp,'(i2)') iunit
         call ljust(itmp,iuch)
#ifdef CRAY
         text = 'assign -a '//idnloc(1:lenloc)//
     $          ' -b 96 fort.'//iuch
         write(6,800) text
         call assign(text)
         go to 50
#else
         open(unit=iunit,file=idnloc,form='UNFORMATTED',status='OLD',
     $        iostat=ierr)
         if(ierr.ne.0) then
            write(6,*)'Failed to open file ',idnloc,' ierr=',ierr
            call endrun
         end if
         write(6,*)'Successfully opened file ',idnloc,' on unit ',iunit
      else
         write(6,*)'Initial dataset not found',idnloc(1:lenloc)
         call endrun
#endif
      endif
C
C Check for file on permanent ccm2 disk
C
      inquire(file='/u0/ccm2/#HRES/'//idnloc(1:lenloc),
     $           exist=lexist)
      if (lexist) then
         write(itmp,'(i2)') iunit
         call ljust(itmp,iuch)
         text = 'assign -a /u0/ccm2/#HRES/'//idnloc(1:lenloc)
     $          //' -b 96 fort.'//iuch
         write(6,800) text
         call assign(text)
         go to 50
      endif
      call attach(iunit   ,mspath  ,idnloc,
     $            bsiz    ,form    ,.true.)
   50 continue
      return
  800 format(' from atchbnd sending the following to assign:',a130)
#endif
      end
