#include "params.h"
      subroutine lunits
C--------------------------------------------------------------------------
C
C Routine to set logical unit numbers, open work files
C
C--------------------------------------------------------------------------
      implicit none
C---------------------------parameters-------------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C---------------------------commons----------------------------------------
#include "abemub.com"
C--------------------------------------------------------------------------
#include "comlun.com"
C--------------------------local variables---------------------------------
      integer ierr
      integer 
     $     nf,
     $     totlen
#ifndef PP_PCCM
      integer p_nproc
      parameter ( p_nproc = 1 )
#endif
C-------------------------- externals -------------------------------------
      integer navu
      external navu
C
C Hardwire SDS units
C
      nra1 = 11
      lutag(11) = .true.
      nrb1 = 21
      lutag(21) = .true.
      nabem = 60
      lutag(60) = .true.
C
C Hardwire standard I/O units
C
      lutag(5) = .true.
      nout = 6
      lutag(6) = .true.
C
C Call navu to find unused unit numbers for all other datasets
C
      nbndti = navu()
      nozone = navu()
      nsst = navu()
      ninit = navu()
      nsds = navu()
c
c Assign units for regeneration files and set the file extensions
c
      nrg = navu()
      do nf = 1, pnrg1
         nrg1(nf) = navu()
         rg1ext(nf) = '.' // char (64 + nf)  ! "A" is char (65)
      end do
      do nf = 1, pnrg2
         nrg2(nf) = navu()
         rg2ext(nf) = '.' // char (97 + nf)  ! "a" is char (97)
      end do
C
C Print summary of unit assignments    MOVE TO INTHT???
C (after history tape units are declared)
C
      write(nout,1000)
 1000 format(6x,'**** Summary of Logical Unit assignments ****'/)
      write(nout,1010) ninit
 1010 format('   Initial dataset unit (ninit)       = ',i3)
      write(nout,1020) nbndti,nozone,nsst
 1020 format('   Time-inv boundary dataset (nbndti) = ',i3/
     $       '   Ozone dataset unit (nozone)        = ',i3/
     $       '   SST dataset unit (nsst)            = ',i3)
      write(nout,1060) nra1,nrb1,nabem
 1060 format('   SDS save file A (nra1)             = ',i3/
     $       '   SDS save file B (nrb1)             = ',i3/
     $       '   SDS abs/ems save file (nabem)      = ',i3)
      write(nout,1090) nsds
 1090 format('   Restart dataset unit (nsds)        = ',i3)
      write(nout,1091) nrg
 1091 format('   Master regeneration unit (nrg)     = ',i3)
      write(nout,1092) nrg1
 1092 format('   Regeneration dataset units (nrg1)  = ',20(i3,1x))
      write(nout,1093) nrg2
 1093 format('   Abs/ems unit for restart (nrg2)    = ',20(i3,1x))
C
C Open save files nra1,nrb1,nabem for direct access I/O
C
#ifdef PP_PCCM
      write(nout,*)
     $     'Save file A will be stored INCORE.'
      write(nout,*)
     $     'Save file B will be stored INCORE.'
#else
      open(unit=nra1,status='SCRATCH',iostat=ierr,err=901,
     $     form='UNFORMATTED',access='DIRECT',recl=pflena*8)
      write(nout,*) 
     $     'Opened save file A as direct access unit, size:  ',
     $     pflena*plat, ' words'
      open(unit=nrb1,status='SCRATCH',iostat=ierr,err=902,
     $     form='UNFORMATTED',access='DIRECT',recl=pflenb*8)
      write(nout,*) 
     $     'Opened save file B as direct access unit, size:  ',
     $     pflenb*plat, ' words'
      open(unit=nabem,status='SCRATCH',iostat=ierr,err=903,
     $     form='UNFORMATTED',access='DIRECT',recl=plngbuf*8)
#endif
      totlen = pflena*plat + pflenb*plat + plngbuf*plat
      write(nout,*)
     $     'Total size of files normally assigned to SDS: ',
     $     totlen, ' words ', totlen/1000000 + 1, ' Megawords '
      return
  901 write(6,*)'Unable to open file nra1: ios=',ierr
      call endrun
      return
  902 write(6,*)'Unable to open file nrb1: ios=',ierr
      call endrun
      return
  903 write(6,*)'Unable to open file nabem: ios=',ierr
      call endrun
      return
      end
