#include "params.h"
      subroutine prealc(fname   ,nwords  )
C-----------------------------------------------------------------------
C
C Routine to preallocate ksiz words (converted to blocks and
C rounded up) for file fname.  Called by CCM2 for history tape
C and regeneration datasets.
C
C----------------------------Code history-------------------------------
C
C Original version using system routine fall:  L. Bath, May 1993
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      character*(*) fname   ! Character variable containing local
C                           !  pathname of file to preallocate
      integer nwords        ! Expected total file size in Cray words
#if ( defined CRAY )
C
C---------------------------Local variables-----------------------------
C
      integer nbyt,         ! File size (bytes)
     $        istat         ! Status return from ishell
      character*130 cmd     ! String to build setf command
      character*10 cbyt,    ! Character form of nbyt
     $             cbytlj   ! Left-justified cbyt
C
C------------------------------Externals--------------------------------
C
      integer lenchr, ishell
      external lenchr,      ! Actual size of character string
     $         ishell       ! System routine, execute shell command
C
C-----------------------------------------------------------------------
C
      nbyt  = nwords*8
      write(cbyt,'(i10)') nbyt
      call ljust(cbyt    ,cbytlj  )
C
      cmd =
     $    'setf -n '//cbytlj(1:lenchr(cbytlj))//' '//
     $    fname(1:lenchr(fname))
      print *,' sending string to ishell from prealc:'
      print *,cmd
      istat = ishell(cmd)
      if (istat.ne.0) then
         print *,' in prealc: cannot allocate ',nbyt,' bytes for file'
         print *,fname,', status word = ',istat
      endif
#else
      write(6,*)'PREALC: Dummy routine for this machine architecture'
#endif
C
      return
      end

