#include "params.h"
      subroutine rdrs1_a( id )
C-----------------------------------------------------------------------
C
C Restore nra1,nra2 and nsre from restart dataset
c The number passed into id was returned by restart_ropen
c
c  single reader  (processor 0)
C
C -----------------------------parameters-------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C-------------------------------commons---------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comqfl.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C-----------------------------------------------------------------------
#include "comtfc.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "com3d.com"
C-----------------------------------------------------------------------
#include "crdalb.com"
C-----------------------------------------------------------------------
#include "comparll.com"
#include "abemub.com"
#include "incore.com"
#include "restart_fil.com"
#include "restart_buf.com"
      integer who_gets, who_gets_lt, who_gets_ln

C------------------------------Local workspace--------------------------
      integer id, icnt, loclat, loclon, field, b1, b2, b3, lath
      integer i,j,lngth,m
      integer jj,ih,jc,nread
      real    dr(4), handshake
      integer d(4)
      integer wordsz
#ifdef WORD4
      parameter ( wordsz = 4 ) 
#else
      parameter ( wordsz = 8 ) 
#endif
      integer d_sn, d_nwords, d_glat, d_glon, lb, ub
      parameter (d_sn=1,d_nwords=2,d_glat=3,d_glon=4)
      real column( rstrt_words )
      real col_buf( rstrt_words + 4 )
C use these equivalence arrays to avoid out-of-bounds errors
C RLJ 7/6/01
      real x2(plond*plev*(3+pcnst),platd,2,2)
      real lammp2(plon*plev,plat)
      real phimp2(plon*plev,plat)
      real sigmp2(plon*plev,plat)


      equivalence ( dr(1),     col_buf(1))
      equivalence ( column(1), col_buf(1+wordsz))
      equivalence ( x2, x(1,1,1,1,1,1))
      equivalence ( lammp2, lammp(1,1,1))
      equivalence ( phimp2, phimp(1,1,1))
      equivalence ( sigmp2, sigmp(1,1,1))


#ifdef PP_NORESTART
#ifdef PP_ERROR
      write(0,*)'RESTARTS DISABLED'
#endif
      return
#endif

      m_type = m_type + 1

 100  continue   ! main loop
		 ! get descriptor
cccccc
c Note: This code uses synchronous swaps to send data from processor 0 to 
c the other processors, to guarantee that the order is preserved.
cccccc
      if ( m_pin .eq. mapmesh(0,0) ) then
         call read_column( id, dr, wordsz*4, nread )
         do i = 1, 4
	     d(i) = dr(i)
         enddo
c
         if ( nread .le. 0 )  then	! no more
           dr(d_nwords) = -1		! signal end to other procs 
	   do i = 0, p_nproc_ln-1
	     do j = 0, p_nproc_lt-1
               if (i.ne.0 .or. j.ne.0)  !avoid swap with self
     &           call swap(1, 6, 0, m_pin, m_type, mapmesh(i,j), 
     &                     wordsz*4, dr, wordsz, handshake)
	     enddo
	   enddo
	   goto 200 ! end of file
	 endif
c
         call read_column( id, column, wordsz*d(d_nwords), nread)
c
	 if ( d(d_glat) .le. p_glat/2 ) then
	     who_gets_lt = (d(d_glat)-1) / (plat/2)
	 else
	     who_gets_lt = (p_glat - d(d_glat)) / ( plat/2 )
	 endif
	 who_gets_ln = (d(d_glon)-1) / plon
c
	 who_gets = mapmesh(who_gets_ln,who_gets_lt)
c
	 if ( who_gets .ne. m_pin ) then
           call swap(1, 6, 0, m_pin, m_type, who_gets,
c Make symettrical with receiving side.  This fixed a bug that prevented
c restarting from single restart files (collapsed in bandij after a time
c step or two.)  With this fix, restarts are now bit for bit. JM 5/13/96 
c     &     wordsz*(d(d_nwords)+4), col_buf, wordsz, handshake)

     &      wordsz*(rstrt_words+4), col_buf, wordsz, handshake)
	   goto 100 ! continue by reading the next column
	 endif
c
      else  ! all other processors
c
         call swap(1, 6, 1, m_pin, m_type, mapmesh(0,0), wordsz, 
     &             handshake, wordsz*(rstrt_words + 4), col_buf)
c
         do i = 1, 4
	     d(i) = dr(i)
         enddo
c
         if ( d(d_nwords) .eq. -1 ) then
	     goto 200 				! got end from proc 0
	 endif
c
      endif

c code for all nodes -- at this point, the column we have is
c one of ours, either because we read it or because it was
c passed to us from the 0th node.

      lath = mod( d(d_glat)-1, plat/2 ) + 1
      jc = j1m+lath
      if ( d(d_glat) .gt. p_glat/2 ) then
          ih = 2
          loclat = plat/2 + lath
      else
          ih = 1
          loclat = lath
      endif
      loclon = d(d_glon) - m_pin_ln * plon

      if      ( d(d_sn) .eq. 1 ) then  !
	  icnt = 1
	  b1 = incore_b+(loclat-1)*pflenb - 1
	  do field = 0, (pbflnb+pbflna)/plond - 1
	      y(b1+field*plond+loclon) = column( icnt )
	      icnt = icnt + 1
	  enddo
	  b2 = incore_a+(loclat-1)*pflena - 1
	  do field = 0, pbflna/plond - 1
	      y(b2+field*plond+loclon) = column( icnt )
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev*(3+pcnst) - 1
	      x2(i1-1+loclon+field*plond,jc,ih,n3) = 
     $            column(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev*(3+pcnst) - 1
	      x2(i1-1+loclon+field*plond,jc,ih,n3m1) =
     $            column(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev - 1
	      lammp2(field*plon+loclon,loclat) = column(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev - 1
	      phimp2(field*plon+loclon,loclat) = column(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev - 1
	      sigmp2(field*plon+loclon,loclat) = column(icnt)
	      icnt = icnt + 1
	  enddo
	  do m = 1, pcnst
	      do field = 1, plev
		  hqfcst(loclon,field,m,loclat) = column(icnt)
	          icnt = icnt + 1
	      enddo
	      do field = 1, plev
		  qfcst(i1-1+loclon,field,m,jc,ih) =
     $              column(icnt)
	          icnt = icnt + 1
	      enddo
	  enddo
	  ps(loclon,loclat,n3) = column(icnt)
	  icnt = icnt + 1
	  ps(loclon,loclat,n3m1) = column(icnt)
	  icnt = icnt + 1
      else if ( d(d_sn) .eq. 2 ) then
	  icnt = 1
	  do m = 1, pcnst
	      hw1(m) = column(icnt)
	      icnt = icnt + 1
	      hw2(m) = column(icnt)
	      icnt = icnt + 1
	      hw3(m) = column(icnt)
	      icnt = icnt + 1
	      alpha(m) = column(icnt)
	      icnt = icnt + 1
	  enddo
      else if ( d(d_sn) .eq. 3 ) then
	  icnt = 1
	  b3 = incore_ems+(loclat-1)*plngbuf
	  do field = 0, plngbuf/plond - 1
	      y(b3-1+field*plond+loclon) = column( icnt )
	      icnt = icnt + 1
	  enddo
      endif

      goto 100

 200  continue   ! end of main loop

      m_type = m_type + p_nproc

#ifdef PP_ERROR
      write(0,*)'finished with restart data'
#endif

      return
      end
