#include "params.h"
      subroutine restrt( lhbuf )
C-----------------------------------------------------------------------
C
C Acquire and position datasets for continuation run
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "abemub.com"
C-------------------------------commons---------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
#include "pspect.com"
#include "comparll.com"
C-----------------------------------------------------------------------
      integer lhbuf
C-----------------------------Local workspace---------------------------
      integer lenc,
     $        iwsiz,
     $        ibsiz,
     $        kt,
     $        kfld,
     $        iread,
     $        i,j,k,kk,
     $        ierr
      character ctem*80,
     $          c1tem*80,
     $          text*260,
     $          iuch*2,
     $          itmp*2,
     $          itf*5,
     $          tcase*8         ! Return former case name from readrg
      integer
     $     lenrgd,              ! length of rg directory name
     $     nf                   ! file number
      character
     $     fname*80,            ! file name
     $     rgdir*120            ! regeneration directory
C----------------------------externals----------------------------------
      integer lenchr
      external attach,   ! attach dataset to job, msread if necessary
     $         endrun,   ! abort
     $         rdhdr,    ! read history tape header
     $         splitf,   ! split out regeneration dataset
     $         assign,   ! transmit assign command
     $         lenchr    ! Actual length of character string

      logical multi
      integer id
      integer rglen
      character*120 errmess
C
C Blank out temporary character variables
C
      do 10 i=1,80
         ctem(i:i) = ' '
         c1tem(i:i) = ' '
  10  continue
C
C Acquire and read restart data from regeneration datasets
C
      do 20 i=1,80
         ctem(i:i) = ' '
         c1tem(i:i) = ' '
  20  continue

C Modification for parallel code: if the regeneration path has a star
C at the end this designates that we are reading from multiple files,
C one per processor.  Without the star, we assume the regen
C rgpath.A files have been concatentated together.

      rglen = lenchr( rgpath )
      if ( rgpath(rglen:rglen) .eq. '*' ) then
	  ctem = rgpath(1:rglen-1)
	  rgpath = ctem
	  multi = .true.
	  do i = 1,80
             ctem(i:i) = ' '
	  enddo
      else
	  multi = .false.
      endif

      if ( m_pin .eq. mapmesh(0,0) ) then
        write(nout,*)'Opening Master restart data set: ',rgpath,'.'
        open( nrg, file=rgpath, form="unformatted")
        call readrg( lhbuf )
        close (nrg)
      else
        call readrg( lhbuf )
      endif

      if  ( nnrg1 .gt. 1 ) then
#ifdef PP_ERROR
	 write(0,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         write(0,*)'PCCM currently does not support restart data'
	 write(0,*)'file that have been broken into pieces to'
	 write(0,*)'limit their maximum size.   Aborting.'
	 write(0,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
#endif
	 call abortf('resrt')
      endif


      fname = rgpath(1:lenchr(rgpath)) // '.A'


      if ( .not. multi ) then
	  if ( m_pin .eq. mapmesh(0,0) ) then
              call restart_ropen(-1,fname,lenchr(fname),id)
	  endif
          call rdrs1_a(id)   ! single file version
	  if ( m_pin .eq. mapmesh(0,0) ) then
              call restart_rclose()
	  endif
      else
          call restart_ropen(m_pin,fname,lenchr(fname),id)
          call rdrs1(id)
          call restart_rclose()
      endif

      if ( m_pin .eq. mapmesh(0,0) ) then

C
C If not a branch run, acquire history tape(s) from previous run
C
        if (.not.lbrnch) then
          write(6,*)
     $ 'WARNING: RESTRT: Aquisition of previous history tapes disabled'
          write(6,*)
     $ '         in the parallel code.  All history configuration must'
          write(6,*)
     $ '         be through settings in the namelist file.'
        else
C
C Branch run, set some header variables
C
          ncdate = nbdate
          ncsec = nbsec
          ndcur = ndbase
          nscur = nsbase
        endif
      endif		! end code on processor 0 only

C
C Assign new restart datasets for all continuation runs. Start naming with
C stfnum for branch run, unless the case is the same as before.
C
      if (lbrnch) then
         write (itf,'(i5)') stfnum + 9999
         nrfil = 'r'//itf(2:5)
      elseif (nlhst) then
         call bldfln(nrfil)
         call rgnfls
      else
C Modification for parallel code.  On a regular restart (nsrest .eq. 1)
C there is no need to increment the restart number in nrfil (as would
C happen if bldfln is called).  This is because wrtrs1 will bump this
C up by one.  JM 95/02/20.
         if (nfils(1).ge.mfilt(1)) then
c            call bldfln(nrfil)
            call rgnfls
         endif
      endif

c I am commenting out this line. It was only used in NCAR's Mass Store
c implementation, and it creates that annoying fort.7 file. Chad Schafer-5/6/96
c     rewind nsds
      return
C
C FORMATS
C
9010  format(' READING HISTORY TAPE ',i3,',FILE NUMBER ', I5,
     $        ' NSBASE = ', I5,
     $        ' NSCUR = ',I5,' NDBASE = ',I5,' NDCUR = ',I5)
      end

