#include "params.h"
      subroutine savdis(lun     ,ldn     ,kfil    ,kivol   ,pass    ,
     $                  mvn     ,krt     ,icomnt  ,lln     ,lremov  ,
     $                  async)
C-----------------------------------------------------------------------
C
C Dispose model output volume kivol to mass store
C
C------------------------input arguments--------------------------------
C
c inserted by implnone
      implicit none
      integer      lun   !  Logical unit number
      character*(*) ldn  !  /usr/tmp path, used only for link
      character*(*) kfil !  Local filename (in TMPDIR)
      character kivol*80 !  mass store full pathname
      character pass*8 !  write password
      character mvn*8    !  mass store cartridge name
      integer krt        !  mass store retention time
      character icomnt*80!  mass store comment field
      logical lln        !  If true, ln to /usr/tmp before close
      logical lremov     !  If true, rm local file after dispose
      logical async      !  If true, use "NOWAIT" option
C------------------------local workspace--------------------------------
      character opts*256,       !  Options for mswrite
     $          optem*256,
     $          cmd*256,        !  Command string
     $          cmdtem*256,     !  Temporary for command string
     $          tmpfil*8,       !  Filename for $TMPDIR link
     $          tvv*8,
     $          ltemp*90,
     $          irt*4           !  Character retention period
      integer   kkrt            !  Temporary for retention period
C
C Dispose dataset to mass store only if krt.gt.0
C
c declarations inserted by implnone
      integer i,ier,ishell,lenchr
      if (krt.ne.0) then
         kkrt = krt
         if (krt.gt.4095) then
            if (mvn.eq.'CTPUBLIC') then
               kkrt = 365
            else
               kkrt = 4095
            endif
         endif
         write (irt,'(i4)') kkrt
C
C Build full local pathname
C
         if (icomnt(1:1).ne.' ') then
            opts = 'CMNT='//icomnt(1:lenchr(icomnt))//
     $          ',FORMAT=TR,MVN='//mvn(1:lenchr(mvn))//',NOMAIL'
         else
            opts = 'FORMAT=TR,MVN='//mvn(1:lenchr(mvn))//',NOMAIL'
         endif
         if (async) then
            optem = opts(1:lenchr(opts))//',NOWAIT'
            opts = optem(1:lenchr(optem))
         endif
C
C Test for link to /usr/tmp
C
         if (lln) then
c
c            call ljust(kfil,ltemp)
            do 200 i = 1, 256
               cmd(i:i) = ' '
200         continue
            cmd = 'rm '//ldn(1:lenchr(ldn))//kfil(1:lenchr(kfil))//
     $            ' ; ln '//kfil(1:lenchr(kfil))
     $            //' '//ldn(1:lenchr(ldn))//kfil(1:lenchr(kfil))
            write(6,*)'SAVDIS:Calling ishell with string:'
            write(6,*)cmd
            ier = ishell(cmd(1:lenchr(cmd)))
            if (ier.ne.0) then
               write(6,*)'SAVDIS:Error in ishell call,ier= ',ier
               call endrun
            endif
         endif
         close(lun)
         cmdtem = 'mswrite -f TR'
         if (async) then
            cmd = cmdtem(1:lenchr(cmdtem))//' -nomail -nowait'
         else
            cmd = cmdtem(1:lenchr(cmdtem))
         endif
         cmdtem =  cmd(1:lenchr(cmd))//' -t '//irt//
     $            ' -v '//mvn
         if (icomnt(1:1).ne.' ') then
            cmd = cmdtem(1:lenchr(cmdtem))//' -c "'//
     $            icomnt(1:lenchr(icomnt))//'"'
            cmdtem = cmd(1:lenchr(cmd))
         endif
         if (pass.ne.'        ') then
            cmd = cmdtem(1:lenchr(cmdtem))//' -w '//pass(1:lenchr(pass))
     $            //' '//kfil(1:lenchr(kfil))
     $            //' '//kivol(1:lenchr(kivol))
         else
            cmd = cmdtem(1:lenchr(cmdtem))//' '//kfil(1:lenchr(kfil))
     $            //' '//kivol(1:lenchr(kivol))
         endif
         write(6,*)'SAVDIS:calling mswrite as follows:'
         write(6,*)cmd
         ier = ishell(cmd(1:lenchr(cmd)))
         ltemp = ','//pass(1:lenchr(pass))
#ifdef CRAY
         call mswrite(ier,      kfil,    kivol,   ltemp,
     $                kkrt,     opts)
#endif
         if (ier.ne.0) then
            write(6,*)'SAVDIS:Error return from mswrite,ier= ',ier
            call endrun
         endif
C
C Remove disk copy if requested
C
         if (lremov) then
            cmd = 'rm '//kfil(1:lenchr(kfil))
            write(6,*)'SAVDIS: calling ishell with string:'
            write(6,*)cmd
            ier = ishell(cmd(1:lenchr(cmd)))
            if (ier.ne.0) then
               write(6,*)'SAVDIS:Error in ishell call,ier= ',ier
               call endrun
            endif
         endif
C
C Remove link to /usr/tmp if it was made
C
         if (lremov.and.lln) then
            cmd = 'rm '//ldn(1:lenchr(ldn))//kfil(1:lenchr(kfil))
            write(6,*)'SAVDIS:Calling ishell with string:'
            write(6,*)cmd
            ier = ishell(cmd(1:lenchr(cmd)))
            if (ier.ne.0) then
               write(6,*)'SAVDIS:Error in ishell call,ier= ',ier
               call endrun
            endif
         endif
c
         write(6,*)'---------------------------------------'
         write(6,*)'SAVDIS: Disposing Mass Store Volume',
     $        kivol(1:lenchr(kivol))
         if (pass.ne.'        ')
     $        write(6,*)'   Write password  = ',
     $                     pass(1:lenchr(pass))
         write(6,*)'   Retention Time = ',kkrt,' DAYS'
         write(6,*)'   Cartridge      = ',mvn
         if (icomnt(1:1).ne.' ') then
            write(6,*)'   Comment Field  = '
            write(6,*)'   ',icomnt(1:lenchr(icomnt))
         endif
         if (lremov) then
            write(6,*) '    Local file removed'
         endif
C
C End of dispose logic
C
      else
C
C No dispose, link and close unit only
C
         if (lln.and..not.lremov) then
            do 300 i = 1, 256
               cmd(i:i) = ' '
300         continue
            cmd = 'rm '//ldn(1:lenchr(ldn))//kfil(1:lenchr(kfil))//
     $            ' ; ln '//kfil(1:lenchr(kfil))
     $            //' '//ldn(1:lenchr(ldn))//kfil(1:lenchr(kfil))
            write(6,*)'SAVDIS:Calling ishell with string:'
            write(6,*)cmd
            ier = ishell(cmd(1:lenchr(cmd)))
            if (ier.ne.0) then
               write(6,*)'SAVDIS:Error in ishell call,ier= ',ier
               call endrun
            endif
         endif
         close(lun)
      endif
      return
      end
