#include "params.h"
      subroutine wsds(lhbuf)
C-----------------------------------------------------------------------
C
C Write start data set for restart
C
C-----------------------------parameters--------------------------------
c inserted by implnone
      implicit none
C------------------------------commons----------------------------------
#include "pmgrid.com"
C-----------------------------------------------------------------------
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comqfl.com"
C-----------------------------------------------------------------------
#include "comtfc.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "crdalb.com"
C-----------------------------------------------------------------------
C
#ifdef PP_PCCM
C-----------------------------------------------------------------------
#include "pspect.com"
C-----------------------------------------------------------------------
#include "comparll.com"
C-----------------------------------------------------------------------
#endif
C------------------------------Argument---------------------------------
C
C Input arguments
C
      integer lhbuf      ! Length of history tape buffer
C
C---------------------------Local variable------------------------------
C
      integer
     $     i,
     $     tmpnnrg3(ptapes),    ! Index and tmp nnrg3 var
     $     tmrg3num,
     $     itape
      character*6
     $     tmpstr,
     $     nhfil_tmp(ptapes)	! temporary storage for history names
C
C-----------------------------------------------------------------------
C
      logical whenwr
      external whenwr     ! Is it time to write the history tape?
C
C-----------------------------------------------------------------------
C

      if (nstep.gt.3) nlres = .true.

#ifdef PP_PCCM
      if ( m_pin .ne. mapmesh(0,0) ) then
	  return
      endif
#endif

#ifdef PP_PCCM

c code to open up a new version of the Master restart data set using the
c same nomenclature as the Primary regeneration data set

#ifdef SIMPLE_OUTPUT
      open( nrg, file='restart/atmos/'//nrfil,
     $    form='unformatted') !, status='new' )
#else
      open( nrg, file=nrfil, form='unformatted') !, status='new' )
#endif
   
#endif

C
C comtim, comimp variables
C
      write(nrg) nstepr,twodt,eps,lhbuf
C
C Write comhst information
C

c Before writing out the history file names, remove the processor id

      do i=2,ptapes
        nhfil_tmp(i) = '      '
      enddo
      tmpstr = nhfil(1)
      nhfil_tmp(1) = tmpstr(1:5)
      do i=2,ptapes
        tmpstr = nhfil(i)
	nhfil_tmp(i) = tmpstr(1:6)
      enddo

      write(nrg) mtapes,nlfilt,nfldsc,nupnt,npnt
      write(nrg)(nhtfrq(i),ndens(i),nflds(i),nfils(i),
     $           hbufpt(i),i=1,mtapes)
      write(nrg)(nrlen(i)   ,nplen(i)  ,mfilt(i) ,i=1,mtapes)
      write(nrg) caseid
      write(nrg)(nfpath(i), cpath(i), ppath(i), nhfil_tmp(i),i=1,mtapes)
      write(nrg)(ndcurf(i),nscurf(i),ncdatf(i),ncsecf(i),i=1,mtapes)
C
C comhed values for branch run
C
      write(nrg) lnhsti  ,ldhsti  ,lthsti  ,lshsti
      write(nrg) nbdate  ,nbsec   ,ndbase  ,nsbase
      write(nrg) mpsig   ,siga    ,sigb
C
C commss values
C
      write(nrg)  nrfil
C
C Write the global integrals of moisture source
C
      write (nrg) tqf     ,dqf    ,fixmas

C
C note: parallel code does not store surface properties in the master
C restart data set.  These quantities are read in from the time-invariant
C boundary dataset, later, in intbnd.F .  JM 95/02/14
C

C
C Regeneration file specs
C
      do itape=1,mtapes
         if (whenwr(nstep,itape)) then
            tmpnnrg3(itape)=0
            rgnht(itape)=.false.
            if (itape.eq.1) tmrg3num=0
         else
            tmpnnrg3(itape)=nnrg3(itape)
            rgnht(itape)=.true.
            if (itape.eq.1) tmrg3num=rg3num
         end if
      end do

      write (nrg)   rg1lat  ,rg1siz  ,rg1buf  ,nnrg1   ,rg2lat,
     $     rg2siz  ,rg2buf  ,nnrg2   ,mxszrg  ,rg1ext  ,rg2ext,
     $     rg3lat  ,rg3siz  ,rg3buf  ,tmpnnrg3,rg3ext  ,rgnht ,
     $     tmrg3num

      write (nrg)   aeres

#ifdef PP_PCCM

      close(nrg)

#else

      rewind nrg

#endif

C
      return
      end

