#include "params.h"
      subroutine wshist(ktape,  lat,  mflds,  hbuf,  lhbuf )
C-----------------------------------------------------------------------
C
C Transfer data record to history tape unit for ktape
C
C-----------------------------------------------------------------------
      implicit none
C---------------------------parameters----------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C----------------------------commons------------------------------------
#include "comhst.com"
C----------------------------arguments----------------------------------
      integer
     $         ktape,     ! History tape number
     $         lat,       !  Record number to write
     $         mflds(3,*),!  Integer header information for ktape
     $         lhbuf	  ! length of history buffer
      real
     $         hbuf(lhbuf) !  Address of ktape portion of history tape buffer
C---------------------------local variables-----------------------------
      integer
     $     i,         !   Index
     $     ip,        !   Pointers to history tape buffer
     $     ibufp,     !
     $     hlev,      !   Indicator for number of levels
     $     ilen,      !   Length of field
     $     ilev,      !   Number of levels
     $     j,         !   Index
     $     ii,
     $     il,
     $     jl,
     $     ndensh,    !   Packing density
     $     kfld       !   Field index for nacs,fnorm
C------------------------ local workspace ------------------------------
      real packsp(plond)
      real fnorm(pflds)
      integer iplen
C--------------------------externals------------------------------------
      external packa, resetr, wrtharr
C-----------------------------------------------------------------------
C
C Normalize fields if requested
C
#ifndef NOOUT
      ibufp = mflds(2,1) - 2
      ip = ibufp
      kfld = 1
      if (ktape.gt.1) then
         do 5 ii=1,ktape-1
            kfld = kfld + nflds(ii)
 5       continue
      endif
      do 20 i=1,nflds(ktape)
C
C Is this an accumulated field?
C

         if (mflds(1,i)/10.gt.0) then
            fnorm(kfld) = 1./amax0(nacs(kfld,lat),1)
            nacs(kfld,lat) = 0
            hlev = mod(mflds(1,i),10)
            ilen = plon
            if (hlev.ge.1)  ilen = ilen*plev
            ilen = ip + ilen - 1
            do 10 j=ip,ilen
               hbuf(j) = hbuf(j)*fnorm(kfld)
   10       continue
         endif
C
C Pack field if requested.
C
         ilev = 1
         if (mod(mflds(1,i),10).gt.0) ilev = plev
         do 18 il=1,ilev
            ndensh = mflds(3,i)
            if (ndensh.gt.1) then
CMIC$ GUARD
c               call packa(hbuf(ip),plon,packsp,ndensh)
#ifdef PP_ERROR
               write(0,*)'Warning: packing not implemented'
#endif
CMIC$ END GUARD
               iplen = (plon+ndensh-1)/ndensh + 2
               do 15 jl=1,iplen
                  hbuf(ibufp+jl-1) = packsp(jl)
   15          continue
               ibufp = ibufp + iplen
            else
               ibufp = ibufp + plon
            endif
            ip = ip + plon
   18    continue
         kfld = kfld + 1
   20 continue
C
C write data out to disk unit
C


cdebug  write(0,*)'wshist: calling wrtharr -- '
c     write(0,*)'       lat     = ', lat
c     write(0,*)'       plon    = ', plon
c     write(0,*)'       ktape   = ', ktape
c     write(0,*)'  nplen(ktape) = ', nplen(ktape)
c     write(0,*)'  nrlen(ktape) = ', nrlen(ktape)
c     write(0,*)'  hunit(ktape) = ', hunit(ktape)
c     write(0,*)'     lhbuf     = ', lhbuf
cdebug

      call wrtharr(hunit(ktape),hbuf,nplen(ktape),lat,plon)
C
C Clear history tape buffer (unpacked length)
c  This cannot work for averaged fields....JD
C
      call resetr (hbuf, nrlen(ktape), 0.)
#endif
      return
      end
