#include "params.h"
      subroutine cmphes(ac      ,nac     ,k       ,l       )
C-----------------------------------------------------------------------
C
C Reduce complex matrix (ac) to upper Hessenburg matrix (ac)
C
C---------------------------Code history--------------------------------
C
C This routine is of unknown lineage. It is only used to provide the
C equivalent depths of the reference atmosphere for a diagnostic print
C in SETTAU and has no effect on the model simulation. Therefore it can 
C be replaced at any time with a functionally equivalent, but more 
C understandable, procedure.  Consequently, the internal commenting has 
C not been brought up to CCM2 standards.                               
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C Reviewed:          D. Williamson, August 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer nac,          ! Dimension of one side of matrix ac
     $        k,l
C
C Input/output arguments
C
      complex ac(nac,nac)   ! On input, complex matrix to be converted
C                           ! On output, upper Hessenburg matrix
C
C---------------------------Local variables-----------------------------
C
      complex x,
     $        y
      integer la,
     $        m1
      integer i,m,j,        ! Indices
     $        j1,i1         ! Loop limits
C
C-----------------------------------------------------------------------
C
      la = l - 1
      m1 = k + 1
      do 100 m=m1,la
         i = m
         x = (0.0,0.0)
         do j=m,l
            if (cabs(ac(j,m-1)).gt.cabs(x)) then
               x = ac(j,m-1)
               i = j
            end if
         end do
         if (i.ne.m) then
            j1 = m - 1
            do j=j1,nac
               y = ac(i,j)
               ac(i,j) = ac(m,j)
               ac(m,j) = y
            end do
            do j=1,l
               y = ac(j,i)
               ac(j,i) = ac(j,m)
               ac(j,m) = y
            end do
         end if
         if (x.ne.(0.0,0.0)) then
            i1 = m + 1
            do 80 i=i1,l
               y = ac(i,m-1)
               if (y.ne.(0.0,0.0)) then
                  y = y/x
                  ac(i,m-1) = y
                  do j=m,nac
                     ac(i,j) = ac(i,j) - y*ac(m,j)
                  end do
                  do j=1,l
                     ac(j,m) = ac(j,m) + y*ac(j,i)
                  end do 
               end if
   80       continue
         end if
  100 continue
      return
      end
