#include "params.h"
      subroutine lcbas( grd, bas1, bas2 )
c
      implicit none
c
c----------------------------------------------------------------------
c
c...Evaluate the partial Lagrangian cubic basis functions (denominator
c   only ) for the grid points and gather grid values
c
c------------------------ input parameters ----------------------------
c
c  ...On input
c
      real grd(4)               ! grid stencil
c
c  ...On output
c
      real
     $      bas1(4)             ! Grid values on stencil
     $     ,bas2(4)             ! Lagrangian basis functions
c
c------------------------  local storage  ------------------------------
      real x0mx1,x0mx2,x0mx3,x1mx2,x1mx3,x2mx3
c-----------------------------------------------------------------------
c
      x0mx1   = grd(1) - grd(2)
      x0mx2   = grd(1) - grd(3)
      x0mx3   = grd(1) - grd(4)
      x1mx2   = grd(2) - grd(3)
      x1mx3   = grd(2) - grd(4)
      x2mx3   = grd(3) - grd(4)
c
      bas1(1) = grd(1)
      bas1(2) = grd(2)
      bas1(3) = grd(3)
      bas1(4) = grd(4)
c
      bas2(1) =  1./ ( x0mx1 * x0mx2 * x0mx3 )
      bas2(2) = -1./ ( x0mx1 * x1mx2 * x1mx3 )
      bas2(3) =  1./ ( x0mx2 * x1mx2 * x2mx3 )
      bas2(4) = -1./ ( x0mx3 * x1mx3 * x2mx3 )
c
      return
      end
