#include "params.h"
      subroutine qreig(a       ,i       ,j       ,k       ,b       ,
     $                 c       )
C-----------------------------------------------------------------------
C
C Create complex matrix P with real part = A and imaginary part = 0
C Find its eigenvalues and return their real parts.
C
C---------------------------Code history--------------------------------
C
C This routine is of unknown lineage. It is only used to provide the
C equivalent depths of the reference atmosphere for a diagnostic print
C in SETTAU and has no effect on the model simulation. Therefore it can 
C be replaced at any time with a functionally equivalent, but more 
C understandable, procedure.  Consequently, the internal commenting has 
C not been brought up to CCM2 standards.                               
C
C Standardized:  L. Bath, June 1992
C Reviewed:      D. Williamson, J. Hack, August 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real a(*),     ! Input real part
     $     b(*),
     $     c(*)
      integer i,
     $        j,
     $        k
C
C---------------------------Local variables-----------------------------
C
      complex p(plev*plev),
     $        q(plev*plev)
      integer l,ij,ik
      external cmphes,cmplr
C
C-----------------------------------------------------------------------
C
      l = 0
      do ij=1,i
         do ik=1,i
            l = l + 1
            p(l) = cmplx(a(l),0.)
         end do
      end do
C
      call cmphes(p       ,i       ,1       ,i       )
      call cmplr(p       ,q       ,i)
C
      do ij=1,i
         b(ij) = AREAL(q(ij))
      end do
      return
      end
