#include "params.h"
      subroutine vdplim(kdim,sig,sigdp)
c
      implicit none
#include "pmgrid.com"
      real eps
#ifdef WORD4 
      parameter( eps = 1.e-06 )
#else
      parameter( eps = 1.e-12 )
#endif
      integer pgls
      parameter( pgls = plon*plev)
c
      integer kdim
      real sig(kdim), sigdp(pgls)
c
c...Restrict vertical departure points to be between the top and bottom
c   sigma levels of the "full-" or "half-" level grid
c
c...On entry.
c
c  kdim    vertical dimension of "sig"
c  sig     Sigma values at the "full" levels or "half" levels
c  sigdp   Sigma value at the trajectory endpoint or midpoint for each
c          gridpoint in a vertical slice from the global grid.
c
c...On return.
c
c  sigdp   Restricted sigma values
c
c...Parameters required.
c
c  plev    Number of vertical levels in global grid.
c  plon    Number of longitudes in global grid.
c
c
      integer i,k
c
c     ...Check that dep. pts. have not extended beyond top and bottom
c        of grid.
c
      do 10  i=1,pgls
         if    ( sigdp(i) .lt. sig(   1) )then
            sigdp(i) = sig(1)
         endif
         if( sigdp(i) .ge. sig(kdim) )then
            sigdp(i) = sig(kdim) - eps
         endif
   10 continue
c
      return
      end
