#include "params.h"
      subroutine pottem(pint    ,pmid    ,t       ,cappa   ,psomc   ,
     $                  th      )
C-----------------------------------------------------------------------
C
C Compute the potential temperature with respect to the local surface
C pressure. This temperature is only used in local column calculations
C in the physics packages. The scale factor for computing theta from T
C is also returned for converting between updated temperatures and
C potential temperatures in the physics packages.
C
C N.B. - the reference pressure is the local surface pressure, not 
C        a constant reference pressure like 1000 mb
C
C---------------------------Code history--------------------------------
C
C Original version:  B. Boville
C Standardized:      J. Rosinski, June 1992
C Reviewed:          B. Boville, J. Hack, August 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real pint(plond,plevp),   ! interface pressures
     $     pmid(plond,plev),    ! midpoint pressures
     $     t(plond,plev),       ! temperature
     $     cappa                ! R / Cp
C
C Output arguments
C
      real psomc(plond,plev),   ! (ps/pmid)**cappa
     $     th(plond,plev)       ! potential temperature
C
C---------------------------Local storage-------------------------------
C
      integer
     $     i,k                  ! longitude and level indexes
C-----------------------------------------------------------------------
C
C Compute potential temperature with respect to
C the surface pressure
C
      do k=1, plev
         do i=1, plon
            psomc(i,k) = (pint(i,plevp)/pmid(i,k))**cappa
            th(i,k) = t(i,k)*psomc(i,k)
         end do
      end do
C
      return
      end
