#include "params.h"
      subroutine qneg1(q,pdel)
C
C     ! Apply longitude-height moisture fixer for negative q values by
C     ! taking moisture from neighboring (above,below,east,west) points.
C     !  Rewritten/tested by J. Rosinski 11/14/89
C
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
C-----------------------------------------------------------------------
C
C     !  Input arguments
C
      real pdel(plond,plev)
C
C     ! Output variables
C
      real q(plond,plev)
C
C     ! Begin executable code.
C
c declarations inserted by implnone
      real dq1,dq2,dq3,dq4,dqz,fac,sdq
c declarations inserted by implnone
      integer i,ill,ilr,k
#ifdef PP_PCCM
c fudge
      real qmin
      integer jl, jk

      qmin = 0.0
      do jk = 1,plev
	 do jl = 1,plon
	    q(jl,jk) = max(qmin,q(jl,jk))
	 enddo
      enddo
#else
C
C     ! Define index for right and left longitudinal points
C
      do 500 i=1,plon
         ilr = mod(i,plon) + 1
         ill = i - 1
         if(i.eq.1) ill = plon
C
C     ! Top level
C
         k = 1
         if (q(i,k).lt.0.0) then
            dqz = -q(i,k)*pdel(i,k)
            dq1 = amax1(q(i,k+1)*pdel(i,k+1),0.0)
            dq2 = amax1(q(ilr,k)*pdel(ilr,k),0.0)
            dq4 = q(ill,k)*pdel(ill,k)
            sdq = dq1 + dq2 + dq4
C
C     ! If not enough moisture available from surrounding point,
C     ! No adjustment is made.
C
            if (sdq.ge.dqz) then
               q(i,k) = 0.0
               fac = 1.0 - dqz/sdq
C
C     ! decrease neighboring points appropriately
C
               q(i,k+1) = amin1(q(i,k+1)*fac,q(i,k+1))
               q(ilr,k) = amin1(q(ilr,k)*fac,q(ilr,k))
               q(ill,k) = q(ill,k)*fac
            endif
         endif
C
C      ! Loop over interior levels
C
         do 200 k=2,plev-1
            if (q(i,k).lt.0.0) then
               dqz = -q(i,k)*pdel(i,k)
               dq1 = amax1(q(i,k+1)*pdel(i,k+1),0.0)
               dq2 = amax1(q(ilr,k)*pdel(ilr,k),0.0)
               dq3 = q(i,k-1)*pdel(i,k-1)
               dq4 = q(ill,k)*pdel(ill,k)
               sdq = dq1 + dq2 + dq3 + dq4
               if (sdq.ge.dqz) then
                  q(i,k) = 0.0
                  fac = 1.0 - dqz/sdq
                  q(i,k+1) = amin1(q(i,k+1)*fac,q(i,k+1))
                  q(ilr,k) = amin1(q(ilr,k)*fac,q(ilr,k))
                  q(ill,k) = q(ill,k)*fac
                  q(i,k-1) = q(i,k-1)*fac
               endif
            endif
  200    continue
C
C      ! Lowest level
C
         k = plev
         if (q(i,k).lt.0.0) then
            dqz = -q(i,k)*pdel(i,k)
            dq2 = amax1(q(ilr,k)*pdel(ilr,k),0.0)
            dq3 = q(i,k-1)*pdel(i,k-1)
            dq4 = q(ill,k)*pdel(ill,k)
            sdq = dq2 + dq3 + dq4
            if (sdq.ge.dqz) then
               q(i,k) = 0.0
               fac = 1.0 - dqz/sdq
               q(ilr,k) = amin1(q(ilr,k)*fac,q(ilr,k))
               q(ill,k) = q(ill,k)*fac
               q(i,k-1) = q(i,k-1)*fac
            endif
         endif
  500 continue
#endif
      return
      end
