#include "params.h"
      subroutine esinti(epslon  ,latvap  ,latice  ,rh2o    ,cpair   )
C-----------------------------------------------------------------------
C
C Initialize es lookup tables 
C
C---------------------------Code history--------------------------------
C
C Original version:  J. Hack
C Standardized:      L. Buja, June 1992
C Reviewed:          J. Hack, G. Taylor, August 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real epslon,         ! Ratio of h2o to dry air molecular weights 
     $     latvap,         ! Latent heat of vaporization
     $     latice,         ! Latent heat of fusion
     $     rh2o,           ! Gas constant for water vapor
     $     cpair           ! Specific heat of dry air
C
C---------------------------Local workspace-----------------------------
C
      real tmn,            ! Minimum temperature entry in table
     $     tmx,            ! Maximum temperature entry in table
     $     trice           ! Trans range from es over h2o to es over ice
      logical ip           ! Ice phase (true or false)
      external gestbl
C
C-----------------------------------------------------------------------
C
C Specify control parameters first
C
      tmn   = 173.16
      tmx   = 375.16
      trice =  20.00
      ip    = .true.
C
C Call gestbl to build saturation vapor pressure table.
C
      call gestbl(tmn     ,tmx     ,trice   ,ip      ,epslon  ,
     $            latvap  ,latice  ,rh2o    ,cpair   )
C
      return
      end
