#include "params.h"
      subroutine plevs0( ps, pint, pmid, pdel )
C-----------------------------------------------------------------------
C
C Define the pressures of the interfaces and midpoints from the
C coordinate definitions and the surface pressure.
C
C---------------------------Code history--------------------------------
C
C Original version:  B. Boville
C Standardized:      J. Rosinski, June 1992
C Reviewed:          B. Boville, P. Rasch, August 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C------------------------------Commons----------------------------------
#include "comhyb.com"
C-----------------------------------------------------------------------
C
C Input arguments
C
      real ps(plond)          ! Surface pressure (pascals)
C
C Output arguments
C
      real pint(plond,plevp), ! Pressure at model interfaces
     $     pmid(plond,plev),  ! Pressure at model levels
     $     pdel(plond,plev)   ! Layer thickness (pint(k+1) - pint(k))
C
C---------------------------Local workspace-----------------------------
C
      integer
     $     i,k                ! Longitude, level indices
C-----------------------------------------------------------------------
C
C Set interface pressures
C
      do k=1,plev+1
         do i=1,plon
            pint(i,k) = hyai(k)*ps0 + hybi(k)*ps(i)
         end do
      end do
C
C Set midpoint pressures and layer thicknesses
C
      do k=1,plev
         do i=1,plon
            pmid(i,k) = hyam(k)*ps0 + hybm(k)*ps(i)
            pdel(i,k) = pint(i,k+1) - pint(i,k)
         end do
      end do
C
      return
      end
