C#######################################################################
C PSTSWM Version 6.2 (12/1/97)                                         #
C  A message-passing benchmark code and parallel algorithm testbed     #
C  that solves the nonlinear shallow water equations using the spectral#
C  transform method.                                                   #
C Written by:                                                          #
C  Patrick Worley of Oak Ridge National Laboratory                     #
C  Ian Foster of Argonne National Laboratory                           #
C Based on the sequential code STSWM 2.0 by James Hack and Ruediger    #
C  Jakob of the National Center for Atmospheric Research.              #
C Research and development funded by the Computer Hardware, Advanced   #
C  Mathematics, and Model Physics (CHAMMP) program of the U.S.         #
C  Department of Energy.                                               # 
C                                                                      #
C Questions and comments should be directed to worley@msr.epm.ornl.gov #
C Please notify and acknowledge the authors in any research or         #
C publications utilizing PSTSWM or any part of the code.               #
C                                                                      #
C NOTICE: Neither the institutions nor the authors make any            #
C representations about the suitability of this software for any       #
C purpose. This software is provided "as is", without express or       #
C implied warranty.                                                    #
C#######################################################################
C***********************************************************************
C* Include file 'picl.i'                                               *
C***********************************************************************
C* Common Block /PICL/ contains the additional information needed to   *
C* map PICL commands to MPI commands.                                  *
C*                                                                     *
C*    COMM     - MPI Communicator to use for swap and sendrecv commands*
C*    MESHCOMM - MPI Communicator to use when defining logical         *
C*               processor mesh                                        *
C*    TRS_COMM(6) - transpose groups communicators                     *
C*    DATALTH  - length in bytes of current datatype                   *
C*    DATATYPE - MPI flag value for current datatype                   *
C*    CARTFLAG - flag indicating whether MESHCOMM has been defined     *
C***********************************************************************
      INTEGER COMM, MESHCOMM, SUM_COMM, TRS_COMM(6), DATALTH, DATATYPE
      INTEGER PSTSWM_COMM
      LOGICAL CARTFLAG
      COMMON  / PICL /
     &        COMM, MESHCOMM, SUM_COMM, TRS_COMM, DATALTH, DATATYPE, 
     &        PSTSWM_COMM, CARTFLAG
C*                                                                     *
C***********************************************************************
C* end include file                                                    *
C***********************************************************************       
