#include "params.h"
      subroutine basdz(kbdm,sig,lbasdz)
c
      implicit none
c
      integer kbdm
      real sig(kbdm),lbasdz(4,2,kbdm)
c
c...Compute coefficients for the calculation of Lagrangian derivative
c   estimates at two center points of the four point stencil for each
c   interval in the unequally spaced vertical grid (as defined by the
c   the array sig).
c
c...On entry.
c
c  kbdm    Number of grid points in vertical grid.
c  sig     Sigma values in the vertical grid.
c
c...On return.
c
c  lbasdz  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced vertical grid.  If grid interval k is
c          surrounded by a 4 point stencil, then the derivative at the
c          "top" of the interval (smaller sigma value) uses the
c          weights lbasdz(1,1,j),lbasdz(2,1,j), lbasdz(3,1,j), and
c          lbasdz(4,1,j).  The derivative at the "bottom" of the interva
c          uses lbasdz(1,2,j), lbasdz(2,2,j), lbasdz(3,2,j),
c          and lbasdz(4,2,j).  (Recall the vertical level indices increa
c          from the top of the atmosphere towards the bottom.)
c
c
      integer kk
      external lcdbas
c
      do 10  kk=2,kbdm-2
         call lcdbas( sig(kk-1), lbasdz(1,1,kk), lbasdz(1,2,kk) )
 10   continue
c
      return
      end
