#include "params.h"
      subroutine extyv(coslam,sinlam,vb)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,kbdm,jxdm,plon2,istart,istop,js,jn
#ifdef PP_PCCM
#include "pspect.com"
#include "comparll.com"
#include "palgor.com"
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= p_lato2 +  2*nxpt + 2*jintmx,
     *           js  = 1    + nxpt + jintmx,
     *           jn  = p_lato2 + nxpt + jintmx,
     *           istart= nxpt+1, istop= nxpt+plon, plon2 = plon/2  )
      integer order
      real coslam(plon),sinlam(plon),vb(ibdm,kbdm*(3+pcnst),jxdm,2)
#else
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= plat +     2*nxpt + 2*jintmx,
     *           js  = 1    + nxpt + jintmx,
     *           jn  = plat + nxpt + jintmx,
     *           istart= nxpt+1, istop= nxpt+plon, plon2 = plon/2  )
      real coslam(plon),sinlam(plon),vb(ibdm,kbdm*(3+pcnst),jxdm)
#endif
c
c
c.... Fill latitude extensions of a vector component extended array.
c     This is done in 2 steps:
c
c   1) interpolate to the pole points;
c     a) Lagrangian cubic interpolation of the coefficients for zonal
c        wave number 1 on the two Gaussian latitudes closest to the
c        pole.   (DISABLED) or,
c     b) use coefficients for zonal wave number 1 on the Gaussian
c        latitude closest to the pole.
c   2) add latitude lines beyond the poles,
c
c...On entry.
c
c  coslam  Cosine of longitude at x-grid points (global grid).
c  sinlam  Sine of longitude at x-grid points (global grid).
c  vb      Extended data array with only the interior filled
c
c...On return.
c
c  vb      As on entry except with the pole latitude and extensions
c          beyond it filled.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  pole    Method for interpolating grid data to the pole.
c  ibdm    Number of longitudes in extended array.
c  kbdm    Number of levels in extended array.
c  jxdm    Number of latitudes in extended array.
c  istart  Longitude index of point corresponding to lambda=0 in extende
c          array.
c  istop   Longitude index of point corresponding to lambda=2*pi-dlam
c          in extended array.
c  plon2   plon/2
c  js      Latitude index pointing into the extended array corresponding
c          to the southern-most latitude in the global grid.
c  jn      Latitude index pointing into the extended array corresponding
c          to the northern-most latitude in the global grid.
c
#ifdef PP_PCCM
      integer i,ig,j,k,lm_type
      real lcpole(4),zavec(4),zaves(4),zpolec,zpoles
      logical first
c   For communication across the pole
      integer jbmx,jbmx1
      parameter (jbmx = nxpt + jintmx, jbmx1=jbmx+1)
      real vbuf1(plon,kbdm,jbmx,2),vbuf2(plon,kbdm,jbmx,2),
     &     zbuf(4,kbdm,2),ztmp(4,kbdm,2)
      real vb_buf(plon,4),repro_tmp(plon)
      real f_locsum
      integer len,ii,jj,node
#else
      integer i,ig,j,k
      real grd(4),lcpole(4),zavec(4),zaves(4),zpolec,zpoles
      logical first
#endif
c
      save first, lcpole
c
      data first/ .true. /
#ifdef PP_PCCM
c
c     ...Compute Lagrangian cubic basis functions evaluated at the
c        poles.
c
      if( first )then
c
         if(pole .eq. 'ave' ) then
            lcpole(1) = 0.0
            lcpole(2) = 0.5
            lcpole(3) = 0.5
            lcpole(4) = 0.0
c
         endif
         first = .false.
      endif
c
c        ...Fill north pole line.
c
         do 50            k = 1,kbdm
c
            zpolec          = 0.0
            zpoles          = 0.0
            do 10         i = 1,4
               zavec(i)     = 0.0
               zaves(i)     = 0.0
   10       continue
c
            
c
c     ... Is this a pole processor?
c
	if(m_pin_lt.ne.0) return
c
c  Add contribution of the pole processors
c
            ig              = 0
            do 20         i = istart,istop
               ig           = ig + 1
               vb_buf(ig,1) =  vb(i,k,jn-1,2)*coslam(ig)
               vb_buf(ig,2) =  vb(i,k,jn  ,2)*coslam(ig)
               vb_buf(ig,3) =  vb(i,k,jn-1,2)*sinlam(ig)
               vb_buf(ig,4) =  vb(i,k,jn  ,2)*sinlam(ig)
   20       continue
            zavec(1) = f_locsum(vb_buf(1,1),plon,repro_tmp)
            zavec(2) = f_locsum(vb_buf(1,2),plon,repro_tmp)
            zaves(1) = f_locsum(vb_buf(1,3),plon,repro_tmp)
            zaves(2) = f_locsum(vb_buf(1,4),plon,repro_tmp)
c
	       zbuf(1,k,2) = zavec(1)
	       zbuf(2,k,2) = zavec(2)
	       zbuf(3,k,2) = zaves(1)
	       zbuf(4,k,2) = zaves(2)
c
   50    continue
c
c     ...Fill south pole line.
c
         do 150           k = 1,kbdm
c
            zpolec          = 0.0
            zpoles          = 0.0
            do 110        i = 1,4
               zavec(i)     = 0.0
               zaves(i)     = 0.0
  110       continue
c
c  Add contribution of the pole processors
c
            ig              = 0
            do 120        i = istart,istop
               ig           = ig + 1
               vb_buf(ig,1) = vb(i,k,js+1,1)*coslam(ig)
               vb_buf(ig,2) = vb(i,k,js  ,1)*coslam(ig)
               vb_buf(ig,3) = vb(i,k,js+1,1)*sinlam(ig)
               vb_buf(ig,4) = vb(i,k,js  ,1)*sinlam(ig)
  120       continue
c
            zavec(1) = f_locsum(vb_buf(1,1),plon,repro_tmp)
            zavec(2) = f_locsum(vb_buf(1,2),plon,repro_tmp)
            zaves(1) = f_locsum(vb_buf(1,3),plon,repro_tmp)
            zaves(2) = f_locsum(vb_buf(1,4),plon,repro_tmp)
c
	       zbuf(1,k,1) = zavec(1)
	       zbuf(2,k,1) = zavec(2)
	       zbuf(3,k,1) = zaves(1)
	       zbuf(4,k,1) = zaves(2)
c
  150    continue
c
c  Add contribution of the pole processors
c
            if(p_nproc_ln.gt.1) then
               lm_type = 330 + 3*p_nproc
               call rowsum0(zbuf,ztmp,8*kbdm,lm_type)
               endif
         do 51            k = 1,kbdm
               zavec(1) = zbuf(1,k,2)
               zavec(2) = zbuf(2,k,2)
               zaves(1) = zbuf(3,k,2)
               zaves(2) = zbuf(4,k,2)
c
            zpolec          = 0.0
            zpoles          = 0.0
            zavec(1)        = zavec(1)/float(p_glon/2)
            zavec(2)        = zavec(2)/float(p_glon/2)
            zavec(3)        = zavec(2)
            zavec(4)        = zavec(1)
            zaves(1)        = zaves(1)/float(p_glon/2)
            zaves(2)        = zaves(2)/float(p_glon/2)
            zaves(3)        = zaves(2)
            zaves(4)        = zaves(1)
c
            do 30         i = 1,4
               zpolec       = zpolec + zavec(i)*lcpole(i)
               zpoles       = zpoles + zaves(i)*lcpole(i)
   30       continue
c
cdebug 
c            write(0,*) 'extyv-north: zpolec,zpoles',zpolec,zpoles
            ig              = 0
            do 40         i = istart,istop
               ig           = ig + 1
               vb(i,k,jn+1,2) = zpolec*coslam(ig) + zpoles*sinlam(ig)
   40       continue
c
   51    continue
c
         do 151           k = 1,kbdm
               zavec(1) = zbuf(1,k,1)
               zavec(2) = zbuf(2,k,1)
               zaves(1) = zbuf(3,k,1)
               zaves(2) = zbuf(4,k,1)
c
            zpolec          = 0.0
            zpoles          = 0.0
            zavec(1)        = zavec(1)/float(p_glon/2)
            zavec(2)        = zavec(2)/float(p_glon/2)
            zavec(3)        = zavec(2)
            zavec(4)        = zavec(1)
            zaves(1)        = zaves(1)/float(p_glon/2)
            zaves(2)        = zaves(2)/float(p_glon/2)
            zaves(3)        = zaves(2)
            zaves(4)        = zaves(1)
c
            do 130        i = 1,4
               zpolec       = zpolec + zavec(i)*lcpole(i)
               zpoles       = zpoles + zaves(i)*lcpole(i)
  130       continue
c
cdebug
c            write(0,*) 'extyv-south: zpolec,zpoles',zpolec,zpoles
            ig              = 0
            do 140        i = istart,istop
               ig           = ig + 1
               vb(i,k,js-1,1) = zpolec*coslam(ig) + zpoles*sinlam(ig)
  140       continue
c
  151    continue
c
c        ...Fill northern lines beyond pole line.
c
         if( jn+2 .le. jxdm )then
           if( p_nproc_ln.eq.1) then
            do 62                  j = jn+2,jxdm
               do 61               k = 1,kbdm
cdir$ ivdep
                  do 60            i = istart,istart+plon2-1
                     vb(      i,k,j,2) = -vb(plon2+i,k,2*jn+2-j,2)
                     vb(plon2+i,k,j,2) = -vb(      i,k,2*jn+2-j,2)
   60             continue
   61          continue
   62       continue
            do 162                 j = 1,js-2
               do 161              k = 1,kbdm
cdir$ ivdep
                  do 160           i = istart,istart+plon2-1
                     vb(      i,k,j,1) = -vb(plon2+i,k,2*js-2-j,1)
                     vb(plon2+i,k,j,1) = -vb(      i,k,2*js-2-j,1)
  160             continue
  161          continue
  162       continue
         else
c
c  Case: more than one pole processor:
c  Send required latitudes across the pole to opposite
c  processor.
c
c  Assume a mesh connect with the zero (m_pin_ln) holding poles
           node = mapmesh(mod(m_pin_ln + p_nproc_ln/2, p_nproc_ln),0)
           lm_type = 323
           if (m_pin .le. node) then
             order = 1
           else
             order = 2
           endif
           len = R_SIZE*plon*kbdm*jbmx *2
           call swap1(p_sltswopt, p_sltswprot, .true., order, m_pin, 
     &                lm_type, node, len, vbuf2)
           jj = 0
           do 67                  j = jn+2,jxdm
             jj = jj + 1
             do 66               k = 1,kbdm
cdir$ ivdep
               do 65            i = 1,plon
		 ii = istart +i -1
                 vbuf1(      i,k,jj,2) = -vb(ii,k,2*jn+2-j,2)
   65          continue
   66        continue
   67      continue
c
	   jj = 0
           do 267                 j = 1,js-2
             jj = jj + 1
             do 266              k = 1,kbdm
cdir$ ivdep
               do 265           i = 1,plon
	         ii = istart +i -1
                 vbuf1(      i,k,jj,1) = -vb(ii,k,2*js-2-j,1)
  265          continue
  266        continue
  267      continue
           call swap2(p_sltswopt, p_sltswprot, .true., order, m_pin, 
     &                lm_type, node, len, vbuf1, len, vbuf2)
           call swap3(p_sltswopt, p_sltswprot, m_pin, 
     &                lm_type, node, len, vbuf2)
            jj = 0
            do 167                  j = jn+2,jxdm
               jj = jj + 1
               do 166               k = 1,kbdm
cdir$ ivdep
                  do 165            i = 1,plon
		     ii = istart +i -1
                     vb(     ii,k,j,2) = vbuf2(i,k,jj,2)
  165             continue
  166          continue
  167       continue
	    jj = 0
            do 367                 j = 1,js-2
               jj = jj + 1
               do 366              k = 1,kbdm
cdir$ ivdep
                  do 365           i = 1,plon
		     ii = istart +i -1
                     vb(     ii,k,j,1) = vbuf2(i,k,jj,1)
  365             continue
  366          continue
  367       continue
          endif
        endif
#else
c
c     ...Compute Lagrangian cubic basis functions evaluated at the
c        poles.
c
      if( first )then
c
         if(pole .eq. 'ave' ) then
            lcpole(1) = 0.0
            lcpole(2) = 0.5
            lcpole(3) = 0.5
            lcpole(4) = 0.0
c
         endif
         first = .false.
      endif
c
c        ...Fill north pole line.
c
         do 50            k = 1,kbdm
c
            zpolec          = 0.0
            zpoles          = 0.0
            do 10         i = 1,4
               zavec(i)     = 0.0
               zaves(i)     = 0.0
   10       continue
c
            ig              = 0
            do 20         i = istart,istop
               ig           = ig + 1
               zavec(1)     = zavec(1) + vb(i,k,jn-1)*coslam(ig)
               zavec(2)     = zavec(2) + vb(i,k,jn  )*coslam(ig)
               zaves(1)     = zaves(1) + vb(i,k,jn-1)*sinlam(ig)
               zaves(2)     = zaves(2) + vb(i,k,jn  )*sinlam(ig)
   20       continue
c
            zavec(1)        = zavec(1)/float(plon2)
            zavec(2)        = zavec(2)/float(plon2)
            zavec(3)        = zavec(2)
            zavec(4)        = zavec(1)
            zaves(1)        = zaves(1)/float(plon2)
            zaves(2)        = zaves(2)/float(plon2)
            zaves(3)        = zaves(2)
            zaves(4)        = zaves(1)
c
            do 30         i = 1,4
               zpolec       = zpolec + zavec(i)*lcpole(i)
               zpoles       = zpoles + zaves(i)*lcpole(i)
   30       continue
c
            ig              = 0
            do 40         i = istart,istop
               ig           = ig + 1
               vb(i,k,jn+1) = zpolec*coslam(ig) + zpoles*sinlam(ig)
   40       continue
c
   50    continue
c
c        ...Fill northern lines beyond pole line.
c
         if( jn+2 .le. jxdm )then
c
            do 62                  j = jn+2,jxdm
               do 61               k = 1,kbdm
cdir$ ivdep
                  do 60            i = istart,istart+plon2-1
                     vb(      i,k,j) = -vb(plon2+i,k,2*jn+2-j)
                     vb(plon2+i,k,j) = -vb(      i,k,2*jn+2-j)
   60             continue
   61          continue
   62       continue
          endif
c
c     ...Fill south pole line.
c
         do 150           k = 1,kbdm
c
            zpolec          = 0.0
            zpoles          = 0.0
            do 110        i = 1,4
               zavec(i)     = 0.0
               zaves(i)     = 0.0
  110       continue
c
            ig              = 0
            do 120        i = istart,istop
               ig           = ig + 1
               zavec(1)     = zavec(1) + vb(i,k,js+1)*coslam(ig)
               zavec(2)     = zavec(2) + vb(i,k,js  )*coslam(ig)
               zaves(1)     = zaves(1) + vb(i,k,js+1)*sinlam(ig)
               zaves(2)     = zaves(2) + vb(i,k,js  )*sinlam(ig)
  120       continue
c
            zavec(1)        = zavec(1)/float(plon2)
            zavec(2)        = zavec(2)/float(plon2)
            zavec(3)        = zavec(2)
            zavec(4)        = zavec(1)
            zaves(1)        = zaves(1)/float(plon2)
            zaves(2)        = zaves(2)/float(plon2)
            zaves(3)        = zaves(2)
            zaves(4)        = zaves(1)
c
            do 130        i = 1,4
               zpolec       = zpolec + zavec(i)*lcpole(i)
               zpoles       = zpoles + zaves(i)*lcpole(i)
  130       continue
c
            ig              = 0
            do 140        i = istart,istop
               ig           = ig + 1
               vb(i,k,js-1) = zpolec*coslam(ig) + zpoles*sinlam(ig)
  140       continue
c
  150    continue
c
c
c         ... Fill southern lines beyond pole line
c
	 if( js-2.ge.1) then
            do 162                 j = 1,js-2
               do 161              k = 1,kbdm
cdir$ ivdep
                  do 160           i = istart,istart+plon2-1
                     vb(      i,k,j) = -vb(plon2+i,k,2*js-2-j)
                     vb(plon2+i,k,j) = -vb(      i,k,2*js-2-j)
  160             continue
  161          continue
  162       continue
c
        endif
#endif
c
      return
      end
