#include "params.h"
      subroutine grdxy(dlam,lam,phi,w,sinlam,coslam,sinphi,cosphi)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,jxdm,istart,istop,jstart,jstop
#ifdef PP_PCCM
      integer jxdmg,jstartg,jstopg
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= p_lato2 + 2*jintmx + 2*nxpt,
     *           istart= nxpt+1, istop= nxpt+plon,
     *           jstart= nxpt+jintmx+1, jstop= jstart-1+p_lato2,
     *           jxdmg= p_glat + 2*jintmx + 2*nxpt,
     *           jstartg= nxpt+jintmx+1, jstopg= jstart-1+p_glat )
      real dlam,lam(ibdm),phi(jxdm,2),w(plat),sinlam(plon),
     *     coslam(plon),sinphi(plat),cosphi(plat)
#else
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= plat + 2*jintmx + 2*nxpt,
     *           istart= nxpt+1, istop= nxpt+plon,
     *           jstart= nxpt+jintmx+1, jstop= jstart-1+plat )
      real dlam,lam(ibdm),phi(jxdm),w(plat),sinlam(plon),
     *     coslam(plon),sinphi(plat),cosphi(plat)
#endif
c
c
c...Define the "extended" grid used in the semi-Lagrangian transport sch
c   interpolate fields.  The longitudes are equally spaced and the latit
c   are Gaussian.  The global grid is extended to include "wraparound" p
c   on all sides.
c
c...On return.
c
c  dlam    Length of increment in longitude grid.
c  lam     Longitude values in the extended grid.
c  phi     Latitude values in the extended grid.
c  w       Gauss weights for latitudes in the global grid.  (These sum
c          to 2.0 like the ones in CCM1.)
c  sinlam  Sine of longitudes in global grid (no extension points).
c  coslam  Cosine of longitudes in global grid (no extension points).
c  sinphi  Sine of latitudes in global grid (no extension points).
c  cosphi  Cosine of latitudes in global grid (no extension points).
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plat    Number of latitudes in global grid.
c  ibdm    Number of longitudes in extended grid (same as in band).
c  jxdm    Number of latitudes in extended grid.
c  istart  Longitude index in extended grid of point corresponding to
c          lambda=0.
c  istop   Longitude index in extended grid of point corresponding to
c          lambda=2*pi-dlam.
c  jstart  Latitude index in extended grid corresponding to the Gaussian
c          latitude just north of the south pole.
c  jstop   Latitude index in extended grid corresponding to the Gaussian
c          latitude just south of the north pole.
c
c
      integer i,j,ig
      real lam0,pi,wrk(jxdm)
#ifndef PP_PCCM
#ifdef WORD4
c
c     ... Double precision calculation of the Gauss points and weights
      double precision zphi(plat),zw(plat)
#endif
      external gauaw,copyac
c
      lam0 = 0.0
      pi = 4.*atan(1.)
c
c     ...Interval length in equally spaced longitude grid.
      dlam = 2.*pi/float(plon)
c
c     ...Longitude values on extended grid.
c
      do 100 i=1,ibdm
         lam(i) = float(i-istart)*dlam + lam0
  100 continue
c
c     ...Compute Gauss latitudes and weights.  On return; phi contains t
c        sine of the latitudes starting closest to the north pole and go
c        toward the south; w contains the corresponding Gauss weights.
c
#ifdef WORD4
      call gauaw(zphi,zw,plat)
c
c  ...Copy from double to single precision arrays
      do 120 j=1,plat
        phi(j) = zphi(j)
        w(j) = zw(j)
120   continue
#else
      call gauaw(phi,w,plat)
#endif
c
c     ...Reorder and compute latitude values.
c
      do 200 j=jstart,jstop
         wrk(j) = asin( phi(jstop-j+1) )
  200 continue
      call copyac(wrk,phi,jxdm)
c
c     ...North and south poles.
c
      phi(jstart-1) = -pi/2.0
      phi(jstop+1) = pi/2.0
c
c     ...Extend Gauss latitudes below south pole so that the spacing abo
c        the pole is symmetric, and phi is decreasing, i.e., phi < -pi/2
c
      if( jstart .gt. 2 )then
         do 300 j=1,jstart-2
            phi(j) = -pi - phi(2*jstart-2-j)
  300    continue
      endif
c
c     ...Extend Gauss latitudes above north pole so that the spacing abo
c        the pole is symmetric, and phi is increasing, i.e., phi > pi/2
c
      if( jxdm .gt. jstop+1 )then
         do 400 j=jstop+2,jxdm
            phi(j) = pi - phi(2*jstop+2-j)
  400    continue
      endif
c
c     ...Sine and cosine of longitude.
c
      ig = 0
      do 500 i=istart,istop
         ig = ig + 1
         sinlam(ig) = sin( lam(i) )
         coslam(ig) = cos( lam(i) )
  500 continue
c
c     ...Sine and cosine of latitude.
c
      ig = 0
      do 600  j=jstart,jstop
         ig = ig + 1
         sinphi(ig) = sin( phi(j) )
         cosphi(ig) = cos( phi(j) )
 600  continue
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#else
#include "pspect.com"
#include "comparll.com"
c
c     ...Declare the global arrays double precision
      double precision phig(jxdmg),wg(p_glat)
      double precision wrkg(jxdmg)
      external gauaw,copyac
      integer jg, jgn, myglat, ih
c
      lam0 = 0.0
      pi = 4.*atan(1.)
c
c     ...Interval length in equally spaced longitude grid.
      dlam = 2.*pi/float(p_glon)
c
c     ...Longitude values on extended grid.
c
      do 100 i=1,ibdm
         lam(i) = float(i-istart + m_pin_ln*plon)*dlam + lam0
  100 continue
c
c     ...Compute Gauss latitudes and weights.  On return; phi contains t
c        sine of the latitudes starting closest to the north pole and go
c        toward the south; w contains the corresponding Gauss weights.
c
      call gauaw(phig,wg,p_glat)
c
c     ...Reorder and compute latitude values.
c
      do 200 j=jstartg,jstopg
         wrkg(j) = asin( phig(jstopg-j+1) )
  200 continue
      do 210 j=1,jxdmg
        phig(j) = wrkg(j)
210   continue
c
c     ...North and south poles.
c
      phig(jstartg-1) = -pi/2.0
      phig(jstopg+1) = pi/2.0
c
c     ...Extend Gauss latitudes below south pole so that the spacing abo
c        the pole is symmetric, and phi is decreasing, i.e., phi < -pi/2
c
      if( jstartg .gt. 2 )then
         do 300 j=1,jstartg-2
            phig(j) = -pi - phig(2*jstartg-2-j)
  300    continue
      endif
c
c     ...Extend Gauss latitudes above north pole so that the spacing abo
c        the pole is symmetric, and phi is increasing, i.e., phi > pi/2
c
      if( jxdmg .gt. jstopg+1 )then
         do 400 j=jstopg+2,jxdmg
            phig(j) = pi - phig(2*jstopg+2-j)
  400    continue
      endif
c
c  Pack into local phi and w arrays
c
      do 410 j=1,jxdm
c
c  Pick off the global phi-s that are assigned to processor me
c
c       Southern hemisphere
           myglat = p_glat/(2*p_nproc_lt)*m_pin_lt + 1
           jg=myglat+j-1
           phi(j,1) =  phig(jg)
c       Northern hemisphere
           jgn=jxdmg-myglat-p_lato2-2*nxpt-2*jintmx +j +1
           phi(j,2) =  phig(jgn)
  410 continue
      do 420 j=1,p_lato2
c
c  Pick off the global gauss weights that are assigned to processor me
c
c       Southern hemisphere
           jg=myglat+j-1
           w(j) =  wg(jg)
c       Northern hemisphere
c
c Fix from J. Drake.  2-23-93
c
c           jgn=p_glat - m_pin_lt - p_lato2 + j +1
           jgn=p_glat - myglat - p_lato2 + j +1
           w(j+p_lato2) =  wg(jgn)
  420 continue
c
c     ...Sine and cosine of longitude.
c
      ig = 0
      do 500 i=istart,istop
         ig = ig + 1
         sinlam(ig) = sin( lam(i) )
         coslam(ig) = cos( lam(i) )
  500 continue
c
c     ...Sine and cosine of latitude.
c
      ig = 0
      do 600  ih=1,2
      do 600  j=jstart,jstop
         ig = ig + 1
         sinphi(ig) = sin( phi(j,ih) )
         cosphi(ig) = cos( phi(j,ih) )
 600  continue
c
      return
      end
#endif

