#include "params.h"
      subroutine herxin(nf,fb,fxl,fxr,x,xdp,idp,jdp,fint,ikcnst)
c
      implicit none
      integer ikcnst
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,kbdm,jxdm
#ifdef PP_PCCM
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= p_lato2 +     2*nxpt + 2*jintmx )
#else
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= plat +     2*nxpt + 2*jintmx )
#endif
c


      integer jgc_foo
      common /debug0804/ jgc_foo




      integer nf,idp(plon,plev),jdp(plon,plev)
      real fb(ibdm,kbdm,ikcnst,jxdm),fxl(ibdm,kbdm,nf,jxdm),
     *     fxr(ibdm,kbdm,nf,jxdm),x(ibdm),xdp(plon,plev),
     *     fint(plon,plev,npdy,nf)
c
c...For each departure point in the latitude slice being forecasted,
c   interpolate (using equally spaced Hermite cubic formulas) to its
c   x value at each latitude required for the interpolation in the y dir
c
c...On entry.
c
c  nf      Number of fields being interpolated.
c  fb      extended array of data to be interpolated.
c  fxl     x derivatives at the left edge of each interval contained in
c  fxr     x derivatives at the right edge of each interval contained in
c  x       Equally spaced x grid values in extended arrays.
c  xdp     xdp(i,k) is the x-coordinate of the departure point that
c          corresponds to global grid point (i,k) in the latitude slice
c          being forecasted in the extended array.
c  idp     idp(i,k) is the index of the x-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted in the extended array.
c          Note that
c                x(idp(i,k)) .le. xdp(i,k) .lt. x(idp(i,k)+1) .
c  jdp     jdp(i,k) is the index of the y-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted in the extended array.
c          Suppose yb contains the y-coordinates of the extended array
c          and ydp(i,k) is the y-coordinate of the departure point
c          corresponding to grid point (i,k).  Then,
c                yb(jdp(i,k)) .le. ydp(i,k) .lt. yb(jdp(i,k)+1) .
c
c...On return.
c
c  fint    (fint(i,k,j,n),j=1,npdy) contains the x interpolants at each
c          latitude needed for the y derivative estimates at the endpoin
c          of the interval that contains the departure point for grid
c          point (i,k).  The last index of fint allows for interpolation
c          of multiple fields.
c
c...Parameters required.
c
c  ibdm    Number of longitudes in extended array.
c  kbdm    Number of levels in extended array.
c  jxdm    Number of latitudes in extended array.
c  npdy    The number of points in the stencil for computing the y
c          derivatives.  (I.e., the number of x interpolations required
c          each departure point.)
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c
c
      integer i,j,jj,k,l,npdy2
      real dx,rdx,xl(plon,plev),xr(plon,plev),hl(plon,plev),
     *     hr(plon,plev),dhl(plon,plev),dhr(plon,plev)
      real pi
      external abortf
c
      if(npdy .ne. 4) then
         write(*,*) '*** error in herxin: npdy must be set to 4'
         call abortf
      endif
c
      npdy2 = npdy/2
#ifdef PP_PCCM
      pi = 4.0*atan(1.0)
      dx = 2.0*pi/float(p_glon)
#else
      dx = x(nxpt+2) - x(nxpt+1)
#endif
      rdx = 1./dx
c
#ifdef CRAY
      do 10 i=1,plon*plev
         xl(i,1) = ( x(idp(i,1)+1) - xdp(i,1) )*rdx
         xr(i,1) = 1. - xl(i,1)
         hl(i,1) = ( 3.0 - 2.0*xl(i,1) )*xl(i,1)**2
         hr(i,1) = ( 3.0 - 2.0*xr(i,1) )*xr(i,1)**2
         dhl(i,1) = -dx*( xl(i,1) - 1. )*xl(i,1)**2
         dhr(i,1) =  dx*( xr(i,1) - 1. )*xr(i,1)**2
   10 continue
#else
      do 10    k = 1,plev
        do 10  i = 1,plon
         xl(i,k) = ( x(idp(i,k)+1) - xdp(i,k) )*rdx
         xr(i,k) = 1. - xl(i,k)
         hl(i,k) = ( 3.0 - 2.0*xl(i,k) )*xl(i,k)**2
         hr(i,k) = ( 3.0 - 2.0*xr(i,k) )*xr(i,k)**2
         dhl(i,k) = -dx*( xl(i,k) - 1. )*xl(i,k)**2
         dhr(i,k) =  dx*( xr(i,k) - 1. )*xr(i,k)**2
   10 continue
#endif
c
c  ...Loop over fields.
c
      do 100  l=1,nf
c
c        ...x interpolation at each latitude needed for y interpolation.
c------- do 90 j=1,npdy
c-------    jj = j - npdy2
c
            do 80  k=1,plev
               do 70  i=1,plon
c---              fint(i,k,j,l) =
c--- *                      fb (idp(i,k)  ,k,l,jdp(i,k)+jj)*hl (i,k)
c--- *                    + fb (idp(i,k)+1,k,l,jdp(i,k)+jj)*hr (i,k)
c--- *                    + fxl(idp(i,k)  ,k,l,jdp(i,k)+jj)*dhl(i,k)
c--- *                    + fxr(idp(i,k)  ,k,l,jdp(i,k)+jj)*dhr(i,k)
                  fint(i,k,1,l) =
     *                      fb (idp(i,k)  ,k,l,jdp(i,k)-1)*hl (i,k)
     *                    + fb (idp(i,k)+1,k,l,jdp(i,k)-1)*hr (i,k)
     *                    + fxl(idp(i,k)  ,k,l,jdp(i,k)-1)*dhl(i,k)
     *                    + fxr(idp(i,k)  ,k,l,jdp(i,k)-1)*dhr(i,k)
                  fint(i,k,2,l) =
     *                      fb (idp(i,k)  ,k,l,jdp(i,k)  )*hl (i,k)
     *                    + fb (idp(i,k)+1,k,l,jdp(i,k)  )*hr (i,k)
     *                    + fxl(idp(i,k)  ,k,l,jdp(i,k)  )*dhl(i,k)
     *                    + fxr(idp(i,k)  ,k,l,jdp(i,k)  )*dhr(i,k)
                  fint(i,k,3,l) =
     *                      fb (idp(i,k)  ,k,l,jdp(i,k)+1)*hl (i,k)
     *                    + fb (idp(i,k)+1,k,l,jdp(i,k)+1)*hr (i,k)
     *                    + fxl(idp(i,k)  ,k,l,jdp(i,k)+1)*dhl(i,k)
     *                    + fxr(idp(i,k)  ,k,l,jdp(i,k)+1)*dhr(i,k)
                  fint(i,k,4,l) =
     *                      fb (idp(i,k)  ,k,l,jdp(i,k)+2)*hl (i,k)
     *                    + fb (idp(i,k)+1,k,l,jdp(i,k)+2)*hr (i,k)
     *                    + fxl(idp(i,k)  ,k,l,jdp(i,k)+2)*dhl(i,k)
     *                    + fxr(idp(i,k)  ,k,l,jdp(i,k)+2)*dhr(i,k)
   70          continue
   80       continue
c--90    continue
  100 continue
c
      return
      end
