#include "params.h"
      subroutine lcdbas(grd,dbas2,dbas3)
c inserted by implnone
      implicit none
      real grd(4), dbas2(4), dbas3(4)
c
c...Evaluate derivatives of the Lagrangian cubic basis functions at the
c   inner grid points of the four point stencil.
c
c...On entry.
c
c  grd    Coordinate values of four points in stencil.
c
c...On return.
c
c  dbas2  Derivatives of the four basis functions at grid point 2.
c  dbas3  Derivatives of the four basis functions at grid point 3.
c
c
      real x1, x2, x3, x4, x1mx2, x1mx3, x1mx4, x2mx3, x2mx4, x3mx4
c
      x1 = grd(1)
      x2 = grd(2)
      x3 = grd(3)
      x4 = grd(4)
      x1mx2 = x1 - x2
      x1mx3 = x1 - x3
      x1mx4 = x1 - x4
      x2mx3 = x2 - x3
      x2mx4 = x2 - x4
      x3mx4 = x3 - x4
c
      dbas2(1) =   x2mx3 * x2mx4 / ( x1mx2 * x1mx3 * x1mx4 )
      dbas2(2) =   -1./x1mx2 + 1./x2mx3 + 1./x2mx4
      dbas2(3) = - x1mx2 * x2mx4 / ( x1mx3 * x2mx3 * x3mx4 )
      dbas2(4) =   x1mx2 * x2mx3 / ( x1mx4 * x2mx4 * x3mx4 )
c
      dbas3(1) = - x2mx3 * x3mx4 / ( x1mx2 * x1mx3 * x1mx4 )
      dbas3(2) =   x1mx3 * x3mx4 / ( x1mx2 * x2mx3 * x2mx4 )
      dbas3(3) =   -1./x1mx3 - 1./x2mx3 + 1./x3mx4
      dbas3(4) = - x1mx3 * x2mx3 / ( x1mx4 * x2mx4 * x3mx4 )
c
      return
      end
