#include "params.h"
      subroutine limdy(nf,fint,dy,jdp,fyb,fyt)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer jxdm
#ifdef PP_PCCM
      parameter( jxdm= 2*jintmx + p_lato2 + 2*nxpt )
#else
      parameter( jxdm= 2*jintmx + plat + 2*nxpt )
#endif
c
      integer nf,jdp(plon,plev)
      real fint(plon,plev,npdy,nf),dy(jxdm),fyb(plon,plev,nf),
     *     fyt(plon,plev,nf)
c
c...Limit the y-derivative estimates for the interpolated data correspon
c   to the departure points of a single latitude slice in the global gri
c
c...On entry.
c
c  nf      Number of fields being interpolated.
c  fint    (fint(i,k,j,n),j=1,npdy) contains the x interpolants at each
c          latitude needed for the y derivative estimates at the endpoin
c          of the interval that contains the departure point for grid
c          point (i,k).  The last index of fint allows for interpolation
c          of multiple fields.  fint is generated by a call to herxin.
c  dy      Increment in the y-coordinate value for each interval in the
c          extended array.
c  jdp     jdp(i,k) is the index of the y-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted.
c          Suppose yb contains the y-coordinates of the extended array
c          and ydp(i,k) is the y-coordinate of the departure point
c          corresponding to grid point (i,k).  Then,
c                yb(jdp(i,k)) .le. ydp(i,k) .lt. yb(jdp(i,k)+1) .
c  fyb     fyb(i,k,.) is the derivative at the bottom of the y interval
c          that contains the departure point of global grid point (i,k).
c  fyt     fyt(i,k,.) is the derivative at the top of the y interval
c          that contains the departure point of global grid point (i,k).
c
c...On return.
c
c  fyb     fyb(i,k,.) is the limited derivative at the bottom of the y i
c          that contains the departure point of global grid point (i,k).
c  fyt     fyt(i,k,.) is the limited derivative at the top of the y inte
c          that contains the departure point of global grid point (i,k).
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c  jxdm    Number of latitudes in extended array.
c
c
      integer i,k,n,jb,jt
      real rdy(plon,plev),deli(plon,plev)
      external scm0
c
      jb = npdy/2
      jt = jb + 1
c
      do 10  k=1,plev
         do 9  i=1,plon
            rdy(i,k) = 1./dy(jdp(i,k))
    9    continue
   10 continue
c
c     ...Loop over fields.
c
      do 100  n=1,nf
c
         do 20  k=1,plev
            do 19  i=1,plon
               deli(i,k) = ( fint(i,k,jt,n) - fint(i,k,jb,n) )*rdy(i,k)
   19       continue
   20    continue
c
c        ...limiter
c
         call scm0( plon*plev, deli, fyb(1,1,n), fyt(1,1,n) )
c
  100 continue
c
      return
      end
