#include "params.h"
      subroutine ovrlap(afld,nxpt_a)
      implicit none
#include "pmgrid.com"
#include "pspect.com"
#include "comparll.com"
#include "palgor.com"
      integer ibdm,jxdm,nbpts,istart,jstart
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= p_lato2     + 2*nxpt + 2*jintmx,
     *           nbpts= ibdm*plev*jxdm,
     *           istart= nxpt+1, jstart= nxpt+jintmx+1 )
c
      real afld(ibdm,plev*(3+pcnst),jxdm,2)
      integer nxpt_a(plev,jxdm,2)
c
c  Update the overlap between processors...
c  the arrays have been extended as if poles were present
c
c  On entry:
c    afld is an extended array with pole extensions
c         filled for processor zero and interior values
c         set of all processors.
c
c  On exit:
c    afld has been filled with the extendend values
c         from neighboring processors.  The interior
c         values are unchanged.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  The algorithm is careful about order for the case when 
c  number of latitude lines, p_lato2, is less than
c     nxpt + jintmx  .
c  For p_lato2 .ge. nxpt+jintmx, the update only
c  involves "interior" latitudes and can be done
c  in any order.  Communication is blocked for efficiency
c  in this case.
c  
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      integer i,j,k,jj,lm_base,lm_type,order
      integer mleni,mleno,node,nwords,ih
      integer jiptr,joptr,ioptr,iiptr
      integer nblks,nblk,ii,iblkbeg,iblkend
      real tmpbuf
      real bufinj(plon,plev,nxpt+jintmx)
      real bufoutj(plon,plev,nxpt+jintmx)
      real bufini(plev*jxdm*2*plon),bufouti(plev*jxdm*2*plon)
      integer info,src,dest
c
c  Initialize local message tag base
c
      lm_base = 330 + 7*p_nproc
c
c  Check to see that there is more than one processor
c  in the latitudinal direction.
c
      if(p_nproc_lt.gt.1) then
        if(p_lato2.lt. nxpt+jintmx) then
c ...Non blocked communication is in order
c
        nwords = ibdm*plev
c
c   Send afld equatorward: (one latitude line at a time)
c
        dest=m_pin_up
        src =m_pin_dwn
        if (m_pin_lt.ne.p_nproc_lt-1) then
          mleno = R_SIZE*nwords
        else
          mleno = R_SIZE
        endif
        if (m_pin_lt.ne.0) then
          mleni = R_SIZE*nwords
        else
          mleni = R_SIZE
        endif
        if (mod(m_pin_lt,2) .eq. 0) then
          order = 1
        else
          order = 2
        endif
c
c   in southern hemisphere:c
c
        do 10 jj = 1, nxpt+jintmx
          joptr = jstart +p_lato2 - jj
          jiptr = nxpt + jintmx - jj + 1
          lm_type = lm_base + jj
c
          if (m_pin_lt.ne.0) then
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,1), src,
     &                    mleni, afld(1,1,jiptr,1))
          else
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,1), src,
     &                    mleni, tmpbuf)
          endif
c
10	continue
c 
c   in northern hemisphere
c
        do 20 jj = 1, nxpt+jintmx
          joptr = jstart + jj -1
          jiptr = jstart + p_lato2 + jj -1
          lm_type = lm_base + 100 + jj
c
          if (m_pin_lt.ne.0) then
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,2), src,
     &                    mleni, afld(1,1,jiptr,2))
          else
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,2), src,
     &                    mleni, tmpbuf)
          endif
c
20	continue
ccccccccccccccccccccccccccccccccccccc
c
c     ....Copy array locations north across the equator on 
c     processor p_nproc_lt-1
c
c
      if (m_pin_lt.eq.p_nproc_lt-1) then
        do 23 jj = 1, nxpt+jintmx
           joptr=jstart +p_lato2 -nxpt -jintmx +jj -1
           jiptr = jj
           do 23 k = 1,plev
               do 23 i=1,ibdm
	         afld(i,k,jiptr,2) = afld(i,k,joptr,1)
23	     continue
c
c  Copy array locations south across the equator on processor p_nproc_lt-1
c
        do 27 jj = 1, nxpt+jintmx
           joptr = jstart + jj -1
           jiptr=jstart +p_lato2 + jj -1
           do 27 k = 1,plev
               do 27 i=1,ibdm
	         afld(i,k,jiptr,1) = afld(i,k,joptr,2)
27	     continue
       endif
c
c  Send afld poleward:
c
        dest=m_pin_dwn
        src =m_pin_up
        if (m_pin_lt.ne.0) then
          mleno = R_SIZE*nwords
        else
          mleno = R_SIZE
        endif
        if (m_pin_lt.ne.p_nproc_lt-1) then
          mleni = R_SIZE*nwords
        else
          mleni = R_SIZE
        endif
        if (mod(m_pin_lt,2) .eq. 0) then
          order = 1
        else
          order = 2
        endif
c
c  in northern hemisphere
c
        do 30 jj = 1, nxpt+jintmx
          joptr = jstart + p_lato2 - jj
          jiptr = jstart - jj
          lm_type = lm_base + 200 + jj
c
          if (m_pin_lt.ne.p_nproc_lt-1) then
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,2), src,
     &                    mleni, afld(1,1,jiptr,2))
          else
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,2), src,
     &                    mleni, tmpbuf)
          endif
c
30	continue
c
c  in southern hemisphere
c
        do 40 jj = 1, nxpt+jintmx
         joptr = jstart + jj -1
         jiptr = jstart +p_lato2 + jj -1
         lm_type = lm_base + 300 + jj
c
          if (m_pin_lt.ne.p_nproc_lt-1) then
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,1), src,
     &                    mleni, afld(1,1,jiptr,1))
          else
            call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                    lm_type, dest, mleno, afld(1,1,joptr,1), src,
     &                    mleni, tmpbuf)
          endif
c
40	continue
c
c
c
       else
c    ....Blocked communication case
c
        nwords = plon*plev*(nxpt + jintmx)
c
c   Send afld equatorward:
c
        dest=m_pin_up
        src =m_pin_dwn
        if (m_pin_lt.ne.p_nproc_lt-1) then
          mleno = R_SIZE*nwords
        else
          mleno = R_SIZE
        endif
        if (m_pin_lt.ne.0) then
          mleni = R_SIZE*nwords
        else
          mleni = R_SIZE
        endif
        if (mod(m_pin_lt,2) .eq. 0) then
          order = 1
        else
          order = 2
        endif
c
c   in southern hemisphere
c
        lm_type = lm_base + 400
        call sr1(p_sltsrprot,.true.,m_pin,lm_type,src,mleni,bufinj)
c
        if (m_pin_lt.ne.p_nproc_lt-1) then
          do 52 jj = 1, nxpt+jintmx
            joptr = jstart +p_lato2 - jj
            do 52 k = 1,plev
               do 52 i=1,plon
                 ii = istart + i -1
	         bufoutj(i,k,jj) = afld(ii,k,joptr,1)
 52	  continue
        endif
c
        call sr2(p_sltsropt, p_sltsrprot, .true., order, m_pin,
     &           lm_type, dest, mleno, bufoutj, src,
     &           mleni, bufinj)
        call sr3(p_sltsropt, p_sltsrprot, m_pin,
     &           lm_type, dest, src, mleni, bufinj)
c
        if (m_pin_lt.ne.0) then
          do 55 jj = 1, nxpt+jintmx
            jiptr = nxpt + jintmx - jj + 1
             do 55 k = 1,plev
               do 55 i=1,plon
                 ii = istart + i -1
	         afld(ii,k,jiptr,1) = bufinj(i,k,jj)
55	  continue
        endif
c 
c  in northern hemisphere
c
        lm_type = lm_base + 500
        call sr1(p_sltsrprot,.true.,m_pin,lm_type,src,mleni,bufinj)
c
        if (m_pin_lt.ne.p_nproc_lt-1) then
          do 62 jj = 1, nxpt+jintmx
            joptr = jstart + jj -1
            do 62 k = 1,plev
               do 62 i=1,plon
                 ii = istart + i -1
	         bufoutj(i,k,jj) = afld(ii,k,joptr,2)
 62       continue
        endif
c
        call sr2(p_sltsropt, p_sltsrprot, .true., order, m_pin,
     &           lm_type, dest, mleno, bufoutj, src,
     &           mleni, bufinj)
        call sr3(p_sltsropt, p_sltsrprot, m_pin,
     &           lm_type, dest, src, mleni, bufinj)
c
        if (m_pin_lt.ne.0) then
          do 65 jj = 1, nxpt+jintmx
           jiptr = jstart + p_lato2 + jj -1
             do 65 k = 1,plev
               do 65 i=1,plon
                 ii = istart + i -1
	         afld(ii,k,jiptr,2) = bufinj(i,k,jj)
65	  continue
        endif
c
c  Send afld poleward:
c
        dest=m_pin_dwn
        src =m_pin_up
        if (m_pin_lt.ne.0) then
          mleno = R_SIZE*nwords
        else
          mleno = R_SIZE
        endif
        if (m_pin_lt.ne.p_nproc_lt-1) then
          mleni = R_SIZE*nwords
        else
          mleni = R_SIZE
        endif
        if (mod(m_pin_lt,2) .eq. 0) then
          order = 1
        else
          order = 2
        endif
c
c  in northern hemisphere
c
        lm_type = lm_base + 600
        call sr1(p_sltsrprot,.true.,m_pin,lm_type,src,mleni,bufinj)
c
        if (m_pin_lt.ne.0) then
          do 72 jj = 1, nxpt+jintmx
            joptr = jstart + p_lato2 - jj
            do 72 k = 1,plev
               do 72 i=1,plon
                 ii = istart + i -1
	         bufoutj(i,k,jj) = afld(ii,k,joptr,2)
 72	     continue
        endif
c
        call sr2(p_sltsropt, p_sltsrprot, .true., order, m_pin,
     &           lm_type, dest, mleno, bufoutj, src,
     &           mleni, bufinj)
        call sr3(p_sltsropt, p_sltsrprot, m_pin,
     &           lm_type, dest, src, mleni, bufinj)
c
        if (m_pin_lt.ne.p_nproc_lt-1) then
          do 75 jj = 1, nxpt+jintmx
           jiptr = jstart - jj
             do 75 k = 1,plev
               do 75 i=1,plon
                 ii = istart + i -1
	         afld(ii,k,jiptr,2) = bufinj(i,k,jj)
75	  continue
        endif
c
c   in southern hemisphere
c
        lm_type = lm_base + 700
        call sr1(p_sltsrprot,.true.,m_pin,lm_type,src,mleni,bufinj)
c
        if (m_pin_lt.ne.0) then
          do 82 jj = 1, nxpt+jintmx
            joptr = jstart + jj -1
            do 82 k = 1,plev
              do 82 i=1,plon
                ii = istart + i -1
	        bufoutj(i,k,jj) = afld(ii,k,joptr,1)
 82	  continue
        endif
c
        call sr2(p_sltsropt, p_sltsrprot, .true., order, m_pin,
     &           lm_type, dest, mleno, bufoutj, src,
     &           mleni, bufinj)
        call sr3(p_sltsropt, p_sltsrprot, m_pin,
     &           lm_type, dest, src, mleni, bufinj)
c
        if (m_pin_lt.ne.p_nproc_lt-1) then
          do 85 jj = 1, nxpt+jintmx
           jiptr = jstart +p_lato2 + jj -1
             do 85 k = 1,plev
               do 85 i=1,plon
                 ii = istart + i -1
	         afld(ii,k,jiptr,1) = bufinj(i,k,jj)
85	  continue
        endif
c
c     ....Copy array locations north across the equator on 
c     processor p_nproc_lt-1
c
      if (m_pin_lt.eq.p_nproc_lt-1) then
        do 123 jj = 1, nxpt+jintmx
           joptr=jstart +p_lato2 -nxpt -jintmx +jj -1
           jiptr = jj
           do 123 k = 1,plev
               do 123 i=1,ibdm
	         afld(i,k,jiptr,2) = afld(i,k,joptr,1)
123	     continue
c
c  Copy array locations south across the equator on processor p_nproc_lt-1
c
        do 127 jj = 1, nxpt+jintmx
           joptr = jstart + jj -1
           jiptr=jstart +p_lato2 + jj -1
           do 127 k = 1,plev
               do 127 i=1,ibdm
	         afld(i,k,jiptr,1) = afld(i,k,joptr,2)
127	     continue
       endif
c
c   ...end of blocked or non-blocked if
      endif
c
      else
c
c     ....There is only one processor for lats so just
c     copy array locations north across the equator on 
c     processor p_nproc_lt-1
c
c
        do 223 jj = 1, nxpt+jintmx
           joptr=jstart +p_lato2 -nxpt -jintmx +jj -1
           jiptr = jj
           do 223 k = 1,plev
               do 223 i=1,ibdm
	         afld(i,k,jiptr,2) = afld(i,k,joptr,1)
223	     continue
c
c  Copy array locations south across the equator on processor p_nproc_lt-1
c
        do 227 jj = 1, nxpt+jintmx
           joptr = jstart + jj -1
           jiptr=jstart +p_lato2 + jj -1
           do 227 k = 1,plev
               do 227 i=1,ibdm
	         afld(i,k,jiptr,1) = afld(i,k,joptr,2)
227	     continue
c
c   ...end of 1 latitude processor if
      endif
ccccccccccccccccccccccccccccccccccccc
c
c  Check to see that there is more than one processor
c  in the longitudinal direction.
c
      if(p_nproc_ln.gt.1) then
c
c   Send afld east
c
        dest=m_pin_rht
        src =m_pin_lft
        if (mod(m_pin_ln,2) .eq. 0) then
          order = 1
        else
          order = 2
        endif
c
        nblks = (nxpt-1)/plon + 1
        do 190 nblk = 1, nblks
          lm_type = lm_base + 800 + nblk 
c
          ii = 0
	  do 105 ih=1,2
	    do 105 j=1,jxdm
	      do 105 k=1,plev
                iblkbeg = (nblk-1)*plon + 1
                iblkend = min(nblk*plon,nxpt_a(k,j,ih))
c no onepass         if(iblkend.lt.iblkbeg) go to 105
                do 105 i = iblkbeg,iblkend
                  ioptr = istart + plon - i 
                  ii = ii + 1
	          bufouti(ii) = afld(ioptr,k,j,ih)
105	  continue
c
          if (ii.eq.0) go to 191
          mleno = ii*R_SIZE
          mleni = ii*R_SIZE
          call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                  lm_type, dest, mleno, bufouti, src,
     &                  mleni, bufini)
c
          ii = 0
	  do 175 ih=1,2
	    do 175 j=1,jxdm
	      do 175 k=1,plev
                iblkbeg = (nblk-1)*plon + 1
                iblkend = min(nblk*plon,nxpt_a(k,j,ih))
                do 175 i = iblkbeg,iblkend
                  iiptr = istart - i
                  ii = ii + 1
	          afld(iiptr,k,j,ih) = bufini(ii)
175       continue
c
190	continue
191	continue
c
c   Send afld west
c   Note extra line in the west of each processor
c
        dest=m_pin_lft
        src =m_pin_rht
        if (mod(m_pin_ln,2) .eq. 0) then
          order = 1
        else
          order = 2
        endif
c
        nblks = nxpt/plon + 1
        do 290 nblk = 1, nblks
          lm_type = lm_base + 900 + nblk 
c
          ii = 0
	  do 205 ih=1,2
	    do 205 j=1,jxdm
	      do 205 k=1,plev
                iblkbeg = (nblk-1)*plon + 1
                iblkend = min(nblk*plon,nxpt_a(k,j,ih)+1)
c no onepass         if(iblkend.lt.iblkbeg) go to 205
                do 205 i = iblkbeg,iblkend
                  ioptr = istart + i - 1
                  ii = ii + 1
	          bufouti(ii) = afld(ioptr,k,j,ih)
205	  continue
c
          if (ii.eq.0) go to 291
          mleno = ii*R_SIZE
          mleni = ii*R_SIZE
          call sendrecv(p_sltsropt, p_sltsrprot, order, m_pin,
     &                  lm_type, dest, mleno, bufouti, src,
     &                  mleni, bufini)
c
          ii = 0
	  do 275 ih=1,2
	    do 275 j=1,jxdm
	      do 275 k=1,plev
                iblkbeg = (nblk-1)*plon + 1
                iblkend = min(nblk*plon,nxpt_a(k,j,ih)+1)
                do 275 i = iblkbeg,iblkend
                  iiptr = istart + plon + i -1
                  ii = ii + 1
	          afld(iiptr,k,j,ih) = bufini(ii)
275       continue
c
290	continue
291	continue
c
c    ..end of the multiple longitudinal processors if
      endif
c
      return
      end

