#include "params.h"
      subroutine s2gphi(lam,cosphi,sinphi,lamsc,phisc,phigc)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
c
      real lam(plon),cosphi,sinphi,lamsc(plon,plev),phisc(plon,plev),
     *     phigc(plon,plev)
c
c...Transform latitude coordinates for a set of points, each of which is
c   associated with a grid point in a global latitude slice, from
c   spherical to local geodesic coordinates.
c
c...On entry.
c
c  lam    Longitude coordinates of the global grid points in spherical
c         system.  The grid points in the global array are the reference
c         points for the local geodesic systems.
c  cosphi cosine of the latitude of the global latitude slice.
c  sinphi sine of the latitude of the global latitude slice.
c  lamsc  Longitude coordinate of points in spherical coordinates.
c  phisc  Latitude coordinate of points in spherical coordinates.
c
c...On return.
c
c  phigc  Latitude coordinate of points in local geodesic coordinates.
c
c...Parameters required.
c
c  plon   Number of longitudes in global array.
c  plev   Number of levels in global array.
c
c
      integer i,k
      real sphisc, cphisc, clamsc
c
      do 100  k=1,plev
         do 10  i=1,plon
            sphisc = sin( phisc(i,k) )
            cphisc = cos( phisc(i,k) )
            clamsc = cos( lam(i) - lamsc(i,k) )
            phigc(i,k) = asin( sphisc*cosphi -
     *                                  cphisc*sinphi*clamsc )
 10      continue
 100  continue
c
      return
      end
