#include "params.h"
      subroutine trajmp(dt,upr,vpr,phipr,lampr)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ngls
      parameter( ngls= plon*plev )
c
      real dt,upr(ngls),vpr(ngls),phipr(ngls),lampr(ngls)
c
c...Estimate of mid-point of parcel trajectory (geodesic coordinates).
c
c...On entry.
c
c  dt      Time interval that corresponds to the parcel trajectory.
c  upr     u-coordinate of velocity corresponding to the most recent
c          estimate of the trajectory mid-point (in geodesic system).
c  vpr     v-coordinate of velocity corresponding to the most recent
c          estimate of the trajectory mid-point (in geodesic system).
c  phipr   Phi value at trajectory mid-point (geodesic coordinates).
c          On entry this is the most recent estimate.
c
c...On return.
c
c  phipr   Phi value at trajectory mid-point (geodesic coordinates).
c  lampr   Lambda value at trajectory mid-point (geodesic coordinates).
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c
c
      integer i
c
      do 10  i=1,ngls
         lampr(i) = -.5*dt* upr(i) / cos( phipr(i) )
         phipr(i) = -.5*dt* vpr(i)
   10 continue
c
      return
      end
