#include "params.h"
      subroutine trjmps(dt,upr,vpr,phimp,phipr,lampr)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ngls
      parameter( ngls= plon*plev )
c
      real dt,upr(ngls),vpr(ngls),phimp(ngls),phipr(ngls),lampr(ngls)
c
c...Estimate of mid-point interval of parcel trajectory
c   (global spherical coordinates).
c
c...On entry.
c
c  dt      Time interval that corresponds to the parcel trajectory.
c  upr     u-coordinate of velocity corresponding to the most recent
c          estimate of the trajectory mid-point.
c  vpr     v-coordinate of velocity corresponding to the most recent
c          estimate of the trajectory mid-point.
c  phimp   Phi value of trajectory midpoint (most recent estimate).
c
c...On return.
c
c  phipr   North-south mid-trajectory interval.
c  lampr   East-west   mid-trajectory interval.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c
      integer i
c
      do 10  i=1,ngls
         lampr(i) = -.5*dt* upr(i) / cos( phimp(i) )
         phipr(i) = -.5*dt* vpr(i)
   10 continue
c
      return
      end
