#include "params.h"
/* error_dup.c SCCS(1.2 92/10/06 10:27:44) */
/* redirect standard error from process into a file */
/* also redirect standard output to a file */

#include <stdio.h>
#ifdef SEQUENT
#include <sys/file.h>
#else
#include <fcntl.h>
#endif

#define STANDARD_ERROR 2

#define STANDARD_OUTPUT 1

#ifdef RS6000
void error_dup(me)
#else
void error_dup_(me)
#endif
int *me;
{
    int newfd ;
    char * flag ;
    char filename[256] ;

    flag = NULL ;
    flag = (char *) getenv( "CCM_PROCESSOR_ERROR_FILES" ) ;

/* redirect standard out*/
    if ( *me == 0 || flag != NULL )
    {
        sprintf(filename,"pccm.out.%04d",*me) ;
    }
    else
    {
        sprintf(filename,"/dev/null") ;
    }
    if ((newfd = open( filename, O_CREAT | O_WRONLY, 0666 )) < 0 )
    {
	perror("error_dup: cannot open pccm.out.nnnn") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	return ;
    }
    if( dup2( newfd, STANDARD_OUTPUT ) < 0 )
    {
	perror("error_dup: dup2 fails to change output descriptor") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	close(newfd) ;
	return ;
    }

/* redirect standard error */
    if ( 1 | *me == 0 || flag != NULL )
    {
        sprintf(filename,"pccm.error.%04d",*me) ;
    }
    else
    {
        sprintf(filename,"/dev/null") ;
    }
    if ((newfd = open( filename, O_CREAT | O_WRONLY, 0666 )) < 0 )
    {
	perror("error_dup: cannot open pccm.error.log") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	return ;
    }
    if( dup2( newfd, STANDARD_ERROR ) < 0 )
    {
	perror("error_dup: dup2 fails to change error descriptor") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	close(newfd) ;
	return ;
    }

}

