#ifdef INTEL
flushpipe_()
{
/* 
  Zero out KI, KR, T without taking a floating-point trap. Code
  courtesy of andyp@ssd.intel.com .
*/
  asm("   ld.c fsr, r16") ;         /* save the current fsr */
  asm("   andnot 0x20, r16, r31") ; /* disable traps (clear FTE) */
  asm("   st.c r31, fsr") ;
  asm("   and 0x20, r16, r16") ;    /* keep just the FTE bit around */

  /* see page 8-15 of the 1991 or 1992 i860 Programmer's Reference */
  /* Manual for a writeup about this. */
  /* The PRM suggests the following sequence to zero KI, KR, and T: */
  asm("   r2apt.ss f0, f0, f0") ;
  asm("   r2apt.ss f0, f0, f0") ;
  asm("   r2apt.ss f0, f0, f0") ;
  asm("   i2apt.ss f0, f0, f0") ;
  asm("   famov.ss f0, f0") ;

  /* re-enable floating-point traps (iff initially enabled). */
  asm("   ld.c fsr, r31");
  asm("   or r16, r31, r31") ; /* restore FTE */

  /* Set the FZ bit of the i860 floating point status register to set */
  /* denormals to zero. Written by J. Michalakes of Argonne National */
  /*  Laboratory. */
/*  asm("   or 1, r31, r16") ; */
/*  asm("   st.c r16, fsr") ; */
}
#else
void flushpipe_dummy()  /* give compiler something so it doesn't see empty file */
{return ;}
#endif

