#include "params.h"
      subroutine decompose( idex )
      implicit none
      integer idex

#ifdef PP_PCCM
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"

      integer   wavdex( (p_glon+2)/2 )
      integer   ilfcs(0:p_nproc_ln-1), fcdex(0:p_nproc_ln-1)
      integer   i, j, m
      integer   ilon, i_nproc_ln
c
      ilon = plon
      i_nproc_ln = p_nproc_ln

      call permute( wavdex, ilfcs, fcdex, i_nproc_ln, ilon )

c following logic works both if 
c  a) untruncated wavenumbers are packed in front of wavdex and 
c     ilfcs only counts the number of untruncated wavenumbers
c     assigned to each processor, or if
c  b) truncated and untruncated wavenumbers are assigned to
c     each processor, in contiguous storage in wavdex, and ilfcs
c     counts all of these.
c
      j = 0
      m_fwavbeg = 1
      l_pwave0 = .false.
      do i = 1, ilfcs(idex)
        m = wavdex(fcdex(idex) - 1 + i)
        if (m .le. ptrm) then
          j = j + 1
          m_mtrue( j ) = m
          m_fwavdex( j ) = i
        endif
        if (m .eq. 0) then
          l_pwave0 = .true.
          m_pwave0_dex = i
        endif
      enddo
      m_fwavend = j

      m_lenalp(1) = min( ptrn+1 , ptrk-m_mtrue(1)+1 )
      m_offalp(1) = 0
      do 20 i = m_fwavbeg+1,m_fwavend
	  m_lenalp(i) = min( ptrn+1, ptrk-m_mtrue(i)+1 )
	  m_offalp(i) = m_lenalp(i-1) + m_offalp( i-1 )
   20 continue 

      m_nspect = m_lenalp(m_fwavend) + m_offalp(m_fwavend)
      m_nspect2 = 2*m_nspect

#ifdef PP_ERROR
      write(0,*)'DECOMPOSE: m_nspect = ',m_nspect
#endif
#endif
      return
      end




