#include "params.h"
ccccccccccccc
c routines added for pccm2
c
C Modified 2/95 by P. Worley, to support not transposing unneeded
C wavenumbers.
C
#ifdef PP_FFTX
      blockdata bdata_xpose_fft
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comxpose.com"
      data xpose_init /.false./
      data debug /.false./
      end
#endif
c
      subroutine xpose_ini
#ifdef PP_FFTX
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"
#include "comxpose.com"
      integer i,j,m
      integer fcbdex(0:p_nproc_ln-1), mtinv(0:p_glon/2)
      integer neworder(p_glon)
      integer mdex
      external mdex

      if ( xpose_init ) return  ! already initialized

      xpose_init = .true.
c
c     call permute to determine load-balanced ordering
#ifndef ESSL_FFT
      call permute( neworder, nlfcs, fcbdex, p_nproc_ln, plon )
c
C Determine ordering coming out of serial FFT
      do i = 0,p_glon/2 - 1
        m = mdex(i, 0, 1, p_glon/2)
        if (m .ge. 0) mtinv(m) = i+1
      enddo
      mtinv(p_glon/2) = (p_glon+2)/2

C Save load balanced reordering of Fourier Coefficients
      do i = 1,(p_glon+2)/2
        ordinv_s(i) = mtinv(neworder(i))
        ordfwd_s(ordinv_s(i)) = i
      enddo
#else
C ordering for ESSL FFT
      call permute( ordinv_s, nlfcs, fcbdex, p_nproc_ln, plon )
      do i = 1,(p_glon+2)/2
        ordinv_s(i) = ordinv_s(i) + 1
        ordfwd_s(ordinv_s(i)) = i
      enddo
#endif
c
#ifdef PP_ERROR
      write(0,*) ' permute: neworder:',neworder
      write(0,*) ' permute: mtinv:',mtinv
      write(0,*) ' permute: ordinv_s:',ordinv_s
      write(0,*) ' permute: ordfwd_s:',ordfwd_s
      write(0,*) ' permute: nlfcs:',nlfcs
      write(0,*) ' permute: fcbdex:',fcbdex
#endif
c
C Compute actual number of longitudes 
      do i=0,p_nproc_ln-1
        nllons(i) = plon
      enddo

C Compute actual number of untruncated Fourier coefficients
      nlmm = nlfcs(m_pin_ln)

#endif
      return
      end

      

