#include "params.h"
#ifdef PP_PCCM
      subroutine mint(irow, lat, q,pspsr,rga,pdel)
C-----------------------------------------------------------------------
C
C     ! Accumulate moisture integral for this latitude.
C     !  Written by J. Rosinski 11/14/89
C
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C---------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "comqfl.com"
C-----------------------------------------------------------------------
C
C     !  Input variables
C
      integer irow
      integer lat
      real q(plond,plev),
     $     pspsr(plond),   ! surface pressure plus reference pressure
     $     rga
      real pdel(plond,plev)
C
C     !  Local workspace
C
      real qminus(plond)  ! negative q values
C-----------------------------------------------------------------------
C
C     !  Begin executable code
C
c declarations inserted by implnone
      real dqlat,sdot,ssum,tqlat
c declarations inserted by implnone
      integer i,k

      real f_locsum
      real lat_tmp(plon)
      real repro_tmp(plon)

      do 20 k=1,plev
         do 10 i=1,plon
	    lat_tmp(i) = q(i,k) * pdel(i,k) * w(irow) * rga
   10    continue
         tq(lat,k) = f_locsum( lat_tmp, plon, repro_tmp )
         do 11 i=1,plon
            lat_tmp(i) = max(0.,-q(i,k)) * pdel(i,k) * w(irow) * rga
   11    continue
         dq(lat,k) = f_locsum( lat_tmp, plon, repro_tmp )
   20 continue

      do i=1,plon
         lat_tmp(i) = pspsr(i) * w(irow)
      enddo
      tmass(lat) = f_locsum( lat_tmp, plon, repro_tmp )

      return
      end

#else
      subroutine mint(irow,q,pspsr,rga,pdel)
C-----------------------------------------------------------------------
C
C     ! Accumulate moisture integral for this latitude.
C     !  Written by J. Rosinski 11/14/89
C
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pagrid.com"
#include "pspect.com"
C---------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "comqfl.com"
C-----------------------------------------------------------------------
C
C     !  Input variables
C
      integer irow
      real q(plond,plev),
     $     pspsr(plond),   ! surface pressure plus reference pressure
     $     rga
      real pdel(plond,plev)
C
C     !  Local workspace
C
      real qminus(plond)  ! negative q values
C-----------------------------------------------------------------------
C
C     !  Begin executable code
C
c declarations inserted by implnone
      real dqlat,sdot,ssum,tqlat
c declarations inserted by implnone
      integer i,k
      do 20 k=1,plev
         do 10 i=1,plon
            qminus(i) = amax1(0.,-q(i,k))
   10    continue
         tqlat = w(irow)*rga*sdot(plon,q(1,k),1,pdel(1,k),1)
         dqlat = w(irow)*rga*sdot(plon,qminus,1,pdel(1,k),1)
         tq(irow,k) = tq(irow,k) + tqlat
         dq(irow,k) = dq(irow,k) + dqlat
   20 continue
      tmass(irow) = tmass(irow) + w(irow)*ssum(plon,pspsr,1)
      return
      end

#endif
