#include "params.h"
      subroutine pdelb0( ps, pdelb )
C-----------------------------------------------------------------------
C
C Compute the pressure intervals between the interfaces for the "B"
C (surface pressure dependent) portion of the hybrid grid only. 
C
C---------------------------Code history--------------------------------
C
C Original version:  J. Olson
C Standardized:      J. Rosinski, June 1992
C Reviewed:          B. Boville, P. Rasch, August 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C------------------------------Commons----------------------------------
#include "comhyb.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real  ps(plond)           ! surface P
C
C Output arguments
C
      real pdelb(plond,plev)    ! pressure difference between interfaces
C                               ! (pressure defined using the "B" part  
C                               ! of the hybrid grid only)
C
C---------------------------Local workspace-----------------------------
C
      integer i,k               ! longitude, level indices
C-----------------------------------------------------------------------
C
C Compute del P(B)
C
      do k = 1,plev
         do i = 1,plon
            pdelb(i,k) = hybd(k)*ps(i)
         end do
      end do
C
      return
      end
