#include "params.h"
      subroutine qmassd(cwava,w,q1,q2,pdel,hwn)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer m
      integer ibdm
      parameter( ibdm= plon + 1 + 2*nxpt)
c
      real cwava, w, q1(ibdm,plev,pcnst),
     *                     q2(ibdm,plev,pcnst),
     $     pdel(plond,plev), hwn(pcnst)
c
c...Compute global integral of q2*|q2 - q1|**(3/2).
c
c...On entry.
c
c  cwava   l/(g*plon) * 1e-3, where l [=] 2.5104e6 J/Kg is the latent
c          heat of vaporization, g [=] 9.80616 m/s**2 is the acceleratio
c          due to gravity, and 1e-3 converts joules to kilo-joules.
c  w       Gauss weights.  (These are assumed to be like those in CCM1
c          which sum to 2.0 over the globe.)
c  q1      Untransported q-field.
c  q2      Transported   q-field.
c  pdel    array of pressure differences between layer interfaces (used
c          for mass weighting ).
c
c...On return.
c
c  hwn     Total moisture in units of kjoule/m**2.
c
c...Parameters.
c
c  plon    Longitudinal dimension of global grid
c  plev    Vertical     dimension of global grid
c  plat    Latitudinal  dimension of global grid
c  ibdm    Longitudinal dimension of extended grid
c
      integer i,k
      real hwava
c
#ifdef PP_PCCM
      real repro_tmp(plon)
      real hw_buf(plon)
      real f_locsum
c
      do 40 m=1,pcnst
      do i = 1,plon
	 hw_buf(i) = 0.0
      enddo
      do 30 k=1,plev
         do 20 i=1,plon
            hw_buf(i) = hw_buf(i) + (q2(i,k,m)*
     $           (sqrt(abs(q1(i,k,m) - q2(i,k,m))))**3)*pdel(i,k)
   20    continue
   30 continue
      do i=1,plon
	 hw_buf(i) = hw_buf(i) * cwava*w*0.5
      enddo
      hwn(m) = f_locsum( hw_buf, plon, repro_tmp )
   40 continue
#else
      do 40 m=1,pcnst
      hwava = 0.0
      do 30 k=1,plev
         do 20 i=1,plon
            hwava = hwava + (q2(i,k,m)*
     $           (sqrt(abs(q1(i,k,m) - q2(i,k,m))))**3)*pdel(i,k)
   20    continue
   30 continue
      hwn(m) = hwn(m) + cwava*w*hwava*0.5
   40 continue
#endif
      return
      end
