#include "params.h"
      subroutine spg_a( irow    ,cwava   ,qfcst   ,
     $                  psm1    ,u3m1    ,v3m1    ,t3m1    ,q3m1    ,
     $                  q3      ,u3      ,v3      ,bpstr            ,
     $                  bz               ,bd               ,bduh    ,
     $                  bdvh             ,bdth             ,bdqh    ,
     $                  bdpsl            ,bdpsm            ,bdps    ,
     $                  pdela   ,hw2al   ,hw2bl   ,hw3al   ,hw3bl,
     $                  fft_buffer, ip )
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C-----------------------------------------------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comfft.com"
C---------------------------------------------------------------------
#include "comhd.com"
C---------------------------------------------------------------------
#include "comhyb.com"
C---------------------------------------------------------------------
#include "comlun.com"
C---------------------------------------------------------------------
#include "commap.com"
C---------------------------------------------------------------------
#include "comspe.com"
C-----------------------------------------------------------------------
#include "comtim.com"

#ifdef INTERVAL_TIMER
#include "timers.com"
#endif

C-----------------------------------------------------------------------
C
C Input arguments
C
      integer irow
#ifdef PP_PCCM
      real cwava,
     $     qfcst(plond,plev,pcnst,platd,2)
      real psm1(plond,plat),
     $     u3m1(plond,plevd,platd,2),
     $     v3m1(plond,plevd,platd,2),
     $     t3m1(plond,plevd,platd,2),
     $     q3m1(plond,plevd,platd,2),
     $     q3(plond,plevd,platd,2)
      real u3(plond,plevd,platd,2),
     $     v3(plond,plevd,platd,2)
#else
      real cwava,
     $     qfcst(plond,plev,pcnst,plat)
      real psm1(plond,plat),
     $     u3m1(plond,plevd,plat),
     $     v3m1(plond,plevd,plat),
     $     t3m1(plond,plevd,plat),
     $     q3m1(plond,plevd,plat),
     $     q3(plond,plevd,plat)
      real u3(plond,plevd,plat),
     $     v3(plond,plevd,plat)
#endif
      real bpstr(plond),     ! ps next to vort. for fft contiguity
     $     bz(plond,plev),
     $     bd(plond,plev),
     $     bduh(plond,plev),
     $     bdvh(plond,plev),
     $     bdth(plond,plev),
     $     bdqh(plond,plev),
     $     bdpsl(plond),
     $     bdpsm(plond),
     $     bdps(plond)
      real pdela(plond,plev),    ! del P(A)
#ifdef PP_PCCM
     $     hw2al (pcnst,plat),
     $     hw2bl (pcnst,plat),
     $     hw3al (pcnst,plat),
     $     hw3bl (pcnst,plat)
#else
     $     hw2al (pcnst,plat/2),
     $     hw2bl (pcnst,plat/2),
     $     hw3al (pcnst,plat/2),
     $     hw3bl (pcnst,plat/2)
#endif
      real fft_buffer( plond, * ) 
      integer ip

C
C Local workspace
C
      real pmid(plond,plev),
     $     pint(plond,plevp),
     $     pdel(plond,plev),
     $     pdelb(plond,plev)    ! del P(B)
      real grdps(plond),
     $     grzs(plond,plev),
     $     grds(plond,plev),
     $     gruhs(plond,plev),
     $     grvhs(plond,plev),
     $     grths(plond,plev),
     $     grqhs(plond,plev),
     $     grpss(plond),
     $     grus(plond,plev),
     $     grvs(plond,plev),
     $     grts(plond,plev),
     $     grqs(plond,plev),
     $     grpls(plond),
     $     grpms(plond)
      real grdpa(plond),
     $     grza(plond,plev),
     $     grda(plond,plev),
     $     gruha(plond,plev),
     $     grvha(plond,plev),
     $     grtha(plond,plev),
     $     grqha(plond,plev),
     $     grpsa(plond),
     $     grua(plond,plev),
     $     grva(plond,plev),
     $     grta(plond,plev),
     $     grqa(plond,plev),
     $     grpla(plond),
     $     grpma(plond)
      real pspsr(plond)
c declarations inserted by implnone
      real factor,sdot,ztodt
c declarations inserted by implnone
      integer i,ihem,inc,isign,k,klev,m,ntr2,ntr3
      integer lat               ! latitude index S->N
#ifdef PP_PCCM
      real repro_tmp(plon)
      real repro2_tmp(plon)
      real f_locsum
#include "comparll.com"
      integer ih                ! hemisphere 1=s, 2=n
      integer j
      integer mm
      real rbuf(2*(pcnst+1))
#endif
C
c
C Initialize slt integrals
C
      ztodt = twodt
      if(nstep.eq.0) ztodt = 0.5*ztodt
      inc = 1
      isign = +1
#ifndef PP_PCCM
      do 9 m=1,pcnst
         hw2al (m,irow) = 0.0
         hw2bl (m,irow) = 0.0
         hw3al (m,irow) = 0.0
         hw3bl (m,irow) = 0.0
    9 continue
#endif
C
C Zero those arrays into which GRCALC will accumulate sums
C
      call resetr(grdps,plond,0.)
      call resetr(grzs,plndlv,0.)
      call resetr(grds,plndlv,0.)
      call resetr(gruhs,plndlv,0.)
      call resetr(grvhs,plndlv,0.)
      call resetr(grths,plndlv,0.)
      call resetr(grqhs,plndlv,0.)
      call resetr(grpss,plond,0.)
      call resetr(grus,plndlv,0.)
      call resetr(grvs,plndlv,0.)
      call resetr(grts,plndlv,0.)
      call resetr(grqs,plndlv,0.)
      call resetr(grpls,plond,0.)
      call resetr(grpms,plond,0.)
c
      call resetr(grdpa,plond,0.)
      call resetr(grza,plndlv,0.)
      call resetr(grda,plndlv,0.)
      call resetr(gruha,plndlv,0.)
      call resetr(grvha,plndlv,0.)
      call resetr(grtha,plndlv,0.)
      call resetr(grqha,plndlv,0.)
      call resetr(grpsa,plond,0.)
      call resetr(grua,plndlv,0.)
      call resetr(grva,plndlv,0.)
      call resetr(grta,plndlv,0.)
      call resetr(grqa,plndlv,0.)
      call resetr(grpla,plond,0.)
      call resetr(grpma,plond,0.)
c
      call grcalc(irow    ,ztodt   ,
     $            grts    ,grths   ,grqs    ,grqhs   ,grds    ,
     $            grzs    ,grus    ,gruhs   ,grvs    ,grvhs   ,
     $            grpss   ,grdps   ,grpms   ,grpls   ,
     $            grta    ,grtha   ,grqa    ,grqha   ,grda    ,
     $            grza    ,grua    ,gruha   ,grva    ,grvha   ,
     $            grpsa   ,grdpa   ,grpma   ,grpla)

C
C Recompute real fields from symetric and antisymetric parts.
C
      do 90 ihem=1,2

#          ifdef INTERVAL_TIMER
         call interval_timer( 1, TIMER_spg_a, 0 )
#          endif

         if(ihem.eq.1) then
C
C Northern hemisphere
C
#ifdef PP_PCCM
            ih = 2
            j = j1 + p_lato2 - irow
#endif
            lat = plat - irow + 1
            do 20 k=1,plev
               do 10 i=1,plonp2
                  bz(i,k) = grzs(i,k) + grza(i,k)
                  bd(i,k) = grds(i,k) + grda(i,k)
                  bduh(i,k) = gruhs(i,k) + gruha(i,k)
                  bdvh(i,k) = grvhs(i,k) + grvha(i,k)
                  bdth(i,k) = grths(i,k) + grtha(i,k)
#ifdef PP_PCCM
                  u3m1(i,k,j,ih) = grus(i,k) + grua(i,k)
                  v3m1(i,k,j,ih) = grvs(i,k) + grva(i,k)
                  t3m1(i,k,j,ih) = grts(i,k) + grta(i,k)
#else
                  u3m1(i,k,lat) = grus(i,k) + grua(i,k)
                  v3m1(i,k,lat) = grvs(i,k) + grva(i,k)
                  t3m1(i,k,lat) = grts(i,k) + grta(i,k)
#endif
   10          continue
   20       continue
            if(.not.doslt) then
               do 24 k=1,plev
                  do 22 i=1,plonp2
#ifdef PP_PCCM
                     q3m1(i,k,j,ih) = grqs(i,k) + grqa(i,k)
#else
                     q3m1(i,k,lat) = grqs(i,k) + grqa(i,k)
#endif
                     bdqh(i,k) = grqhs(i,k) + grqha(i,k)
   22             continue
   24          continue
            end if
            do 30 i=1,plonp2
               bdps(i) = grdps(i) + grdpa(i)
               psm1(i,lat) = grpss(i) + grpsa(i)
               bdpsl(i) = grpls(i) + grpla(i)
               bdpsm(i) = grpms(i) + grpma(i)
   30       continue
         else
C
C Southern hemisphere
C
#ifdef PP_PCCM
            j = j1m + irow
            ih = 1
#endif
            lat = irow
            do 50 k=1,plev
               do 40 i=1,plonp2
                  bz(i,k) = grzs(i,k) - grza(i,k)
                  bd(i,k) = grds(i,k) - grda(i,k)
                  bduh(i,k) = gruhs(i,k) - gruha(i,k)
                  bdvh(i,k) = grvhs(i,k) - grvha(i,k)
                  bdth(i,k) = grths(i,k) - grtha(i,k)
#ifdef PP_PCCM
                  u3m1(i,k,j,ih) = grus(i,k) - grua(i,k)
                  v3m1(i,k,j,ih) = grvs(i,k) - grva(i,k)
                  t3m1(i,k,j,ih) = grts(i,k) - grta(i,k)
#else
                  u3m1(i,k,lat) = grus(i,k) - grua(i,k)
                  v3m1(i,k,lat) = grvs(i,k) - grva(i,k)
                  t3m1(i,k,lat) = grts(i,k) - grta(i,k)
#endif
   40          continue
   50       continue
            if(.not.doslt) then
               do 54 k=1,plev
                  do 52 i=1,plonp2
#ifdef PP_PCCM
                     q3m1(i,k,j,ih) = grqs(i,k) - grqa(i,k)
#else
                     q3m1(i,k,lat) = grqs(i,k) - grqa(i,k)
#endif
                     bdqh(i,k) = grqhs(i,k) - grqha(i,k)
   52             continue
   54          continue
            end if
            do 60 i=1,plonp2
               bdps(i) = grdps(i) - grdpa(i)
               psm1(i,lat) = grpss(i) - grpsa(i)
               bdpsl(i) = grpls(i) - grpla(i)
               bdpsm(i) = grpms(i) - grpma(i)
   60       continue
         end if

#          ifdef INTERVAL_TIMER
         call interval_timer( 0, TIMER_spg_a, 0 )
#          endif


#ifdef INTERVAL_TIMER
         call interval_timer( 1, TIMER_BwdFFT, 0 )
#endif
         call copyac( psm1(1,lat),  fft_buffer( 1, ip ), plond )
	 ip = ip + 1
         call copyac( bdps,         fft_buffer( 1, ip ), plond )
	 ip = ip + 1
         call copyac( bdpsl,        fft_buffer( 1, ip ), plond )
	 ip = ip + 1
         call copyac( bdpsm,        fft_buffer( 1, ip ), plond )
	 ip = ip + 1
         call copyac( bz,           fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( bd,           fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( bduh,         fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( bdvh,         fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( bdth,         fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( bdqh,         fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
c pack 3d prognostic fields
         call copyac( u3m1(1,1,j,ih),  fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( v3m1(1,1,j,ih),  fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
         call copyac( t3m1(1,1,j,ih),  fft_buffer( 1, ip ), plndlv )
	 ip = ip + plev
#ifdef INTERVAL_TIMER
         call interval_timer( 0, TIMER_BwdFFT, 0 )
#endif

   90 continue

      return
      end

