#include "params.h"
      subroutine spg_c( irow    ,cwava   ,qfcst   ,
     $                  psm1    ,u3m1    ,v3m1    ,t3m1    ,q3m1    ,
     $                  q3      ,u3      ,v3      ,bpstr            ,
     $                  bz               ,bd               ,bduh    ,
     $                  bdvh             ,bdth             ,bdqh    ,
     $                  bdpsl            ,bdpsm            ,bdps    ,
     $                  pdela   ,hw2al   ,hw2bl   ,hw3al   ,hw3bl,
     $                  fft_buffer, ip )
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C-----------------------------------------------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comfft.com"
C---------------------------------------------------------------------
#include "comhd.com"
C---------------------------------------------------------------------
#include "comhyb.com"
C---------------------------------------------------------------------
#include "comlun.com"
C---------------------------------------------------------------------
#include "commap.com"
C---------------------------------------------------------------------
#include "comspe.com"
C-----------------------------------------------------------------------
#include "comtim.com"

#ifdef INTERVAL_TIMER
#include "timers.com"
#endif

C-----------------------------------------------------------------------
C
C Input arguments
C
      integer irow
#ifdef PP_PCCM
      real cwava,
     $     qfcst(plond,plev,pcnst,platd,2)
      real psm1(plond,plat),
     $     u3m1(plond,plevd,platd,2),
     $     v3m1(plond,plevd,platd,2),
     $     t3m1(plond,plevd,platd,2),
     $     q3m1(plond,plevd,platd,2),
     $     q3(plond,plevd,platd,2)
      real u3(plond,plevd,platd,2),
     $     v3(plond,plevd,platd,2)
#else
      real cwava,
     $     qfcst(plond,plev,pcnst,plat)
      real psm1(plond,plat),
     $     u3m1(plond,plevd,plat),
     $     v3m1(plond,plevd,plat),
     $     t3m1(plond,plevd,plat),
     $     q3m1(plond,plevd,plat),
     $     q3(plond,plevd,plat)
      real u3(plond,plevd,plat),
     $     v3(plond,plevd,plat)
#endif
      real bpstr(plond),     ! ps next to vort. for fft contiguity
     $     bz(plond,plev),
     $     bd(plond,plev),
     $     bduh(plond,plev),
     $     bdvh(plond,plev),
     $     bdth(plond,plev),
     $     bdqh(plond,plev),
     $     bdpsl(plond),
     $     bdpsm(plond),
     $     bdps(plond)
      real pdela(plond,plev),    ! del P(A)
#ifdef PP_PCCM
     $     hw2al (pcnst,plat),
     $     hw2bl (pcnst,plat),
     $     hw3al (pcnst,plat),
     $     hw3bl (pcnst,plat)
#else
     $     hw2al (pcnst,plat/2),
     $     hw2bl (pcnst,plat/2),
     $     hw3al (pcnst,plat/2),
     $     hw3bl (pcnst,plat/2)
#endif

      real fft_buffer( plond, * ) 
      integer ip
C
C Local workspace
C
      real pmid(plond,plev),
     $     pint(plond,plevp),
     $     pdel(plond,plev),
     $     pdelb(plond,plev)    ! del P(B)
      real grdps(plond),
     $     grzs(plond,plev),
     $     grds(plond,plev),
     $     gruhs(plond,plev),
     $     grvhs(plond,plev),
     $     grths(plond,plev),
     $     grqhs(plond,plev),
     $     grpss(plond),
     $     grus(plond,plev),
     $     grvs(plond,plev),
     $     grts(plond,plev),
     $     grqs(plond,plev),
     $     grpls(plond),
     $     grpms(plond)
      real grdpa(plond),
     $     grza(plond,plev),
     $     grda(plond,plev),
     $     gruha(plond,plev),
     $     grvha(plond,plev),
     $     grtha(plond,plev),
     $     grqha(plond,plev),
     $     grpsa(plond),
     $     grua(plond,plev),
     $     grva(plond,plev),
     $     grta(plond,plev),
     $     grqa(plond,plev),
     $     grpla(plond),
     $     grpma(plond)
      real pspsr(plond)

      real factor,sdot,ztodt,rcoslat
      integer i,ihem,inc,isign,k,klev,m,ntr2,ntr3
      integer lat               ! latitude index S->N
#ifdef PP_PCCM
      real repro_tmp(plon)
      real repro2_tmp(plon)
      real f_locsum
#include "comparll.com"
      integer ih                ! hemisphere 1=s, 2=n
      integer j
      integer mm
      real rbuf(2*(pcnst+1))
#endif

      ztodt = twodt
      if(nstep.eq.0) ztodt = 0.5*ztodt

      do 90 ihem=1,2
         if(ihem.eq.1) then
C
C Northern hemisphere
C
            ih = 2
            j = j1 + p_lato2 - irow
            lat = plat - irow + 1
         else
C
C Southern hemisphere
C
            j = j1m + irow
            ih = 1
            lat = irow
         endif

c unpack pressure and bpstr
#ifdef INTERVAL_TIMER
         call interval_timer( 1, TIMER_BwdFFT, 0 )
#endif
         call copyac( fft_buffer( 1, ip ), bpstr,  plond )
         ip = ip + 1
         call copyac( fft_buffer( 1, ip ), bdps,         plond )
         ip = ip + 1
         call copyac( fft_buffer( 1, ip ), bdpsl,        plond )
         ip = ip + 1
         call copyac( fft_buffer( 1, ip ), bdpsm,        plond )
         ip = ip + 1
         call copyac( fft_buffer( 1, ip ), bz,           plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), bd,           plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), bduh,         plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), bdvh,         plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), bdth,         plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), bdqh,         plndlv )
         ip = ip + plev
c unpack 3d prognostic fields
         call copyac( fft_buffer( 1, ip ), u3m1(1,1,j,ih),  plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), v3m1(1,1,j,ih),  plndlv )
         ip = ip + plev
         call copyac( fft_buffer( 1, ip ), t3m1(1,1,j,ih),  plndlv )
         ip = ip + plev
#ifdef INTERVAL_TIMER
         call interval_timer( 0, TIMER_BwdFFT, 0 )
#endif

#ifdef INTERVAL_TIMER
         call interval_timer( 1, TIMER_spg_c, 0 )
#endif
C
C Remove cosine(latitude) from momentum variables
C
         rcoslat = 1./cos(clat(lat))
         do k=1,plev
            do i=1,plon
#ifdef PP_PCCM
               u3m1(i,k,j,ih) = u3m1(i,k,j,ih)*rcoslat
               v3m1(i,k,j,ih) = v3m1(i,k,j,ih)*rcoslat
#else
               u3m1(i,k,lat) = u3m1(i,k,lat)*rcoslat
               v3m1(i,k,lat) = v3m1(i,k,lat)*rcoslat
#endif
               bduh(i,k) = bduh(i,k)*rcoslat
               bdvh(i,k) = bdvh(i,k)*rcoslat
            end do
         end do
C
C Copy transformed surface pressure back
C
         call copyac(bpstr,psm1(1,lat),plonp2)
c
c Convert from t-prime to temperature
c
c        do k=1,plev
c           do i=1,plon
#ifdef PP_PCCM
c              t3m1(i,k,j,ih) = t3m1(i,k,j,ih) + t0(k)
#else
c              t3m1(i,k,lat) = t3m1(i,k,lat) + t0(k)
#endif
c           end do
c        end do
         do 70 i=1,plon
            psm1(i,lat) = exp(psm1(i,lat)) - psr
            pspsr(i) = psm1(i,lat) + psr
   70    continue

         call plevs0(pspsr,pint,pmid,pdel)
         call pdelb0(pspsr,pdelb)



C
C Finish horizontal diffusion: add correction term to t and q diffusions.
C
         klev = max(kmnhd4,nprlev)
#ifdef PP_PCCM
         call difcor(doslt,klev,ztodt,bdps,u3m1(1,1,j,ih),
     $               v3m1(1,1,j,ih),q3(1,1,j,ih),pdel,
     $               pint,t3m1(1,1,j,ih),
     $               q3m1(1,1,j,ih),bdth,bdqh,bduh,bdvh)

#else
         call difcor(doslt,klev,ztodt,bdps,u3m1(1,1,lat),
     $               v3m1(1,1,lat),q3(1,1,lat),pdel,
     $               pint,t3m1(1,1,lat),
     $               q3m1(1,1,lat),bdth,bdqh,bduh,bdvh)
#endif

         if(doslt) then
c
c calculate SLT moisture integrals
c all the ()-s are for bit for bit results with case 381
c
#ifdef PP_PCCM
            do 80 m=1,pcnst

               do i=1,plon
                     repro_tmp(i) = 0.0
               enddo
               do k=1,plev
                  do i = 1,plon
                     repro_tmp(i) = repro_tmp(i) +
     $                   qfcst(i,k,m,j,ih)*pdela(i,k)
                  enddo
               enddo
               do i = 1,plon
                  repro_tmp(i) = repro_tmp(i) * cwava*w(irow)*0.5
               enddo
               hw2al (m,lat) = f_locsum( repro_tmp, plon, repro2_tmp)

               do i=1,plon
                     repro_tmp(i) = 0.0
               enddo
               do k=1,plev
                  do i = 1,plon
                     repro_tmp(i) = repro_tmp(i) +
     $                    qfcst(i,k,m,j,ih)*pdelb(i,k)
                  enddo
               enddo
               do i = 1,plon
                  repro_tmp(i) = repro_tmp(i) * cwava*w(irow)*0.5
               enddo
               hw2bl (m,lat) = f_locsum( repro_tmp, plon, repro2_tmp)
c
   80       continue
            call qmassd(cwava,w(irow),q3m1(1,1,j,ih),
     $                  qfcst(1,1,1,j,ih),pdela,hw3al (1,lat))
            call qmassd(cwava,w(irow),q3m1(1,1,j,ih),
     $                  qfcst(1,1,1,j,ih),pdelb,hw3bl (1,lat))
c
c
         endif

C
C Fix negative q values
C
         if(.not.doslt) call qneg1(q3m1(1,1,j,ih),pdel)
C
C Accumulate moisture integrals
C
c                               ! give mint access to lat
         call mint(irow,lat,q3m1(1,1,j,ih),pspsr,rga,pdel)
#else
            do 80 m=1,pcnst
               do 79 k=1,plev
               hw2al (m,irow) = hw2al (m,irow) + ((cwava*w(irow))*
     $                sdot(plon,qfcst(1,k,m,lat),1,pdela(1,k),1))*0.5
               hw2bl (m,irow) = hw2bl (m,irow) + ((cwava*w(irow))*
     $                sdot(plon,qfcst(1,k,m,lat),1,pdelb(1,k),1))*0.5
   79          continue
   80       continue
            call qmassd(cwava,w(irow),q3m1(1,1,lat),
     $                  qfcst(1,1,1,lat),pdela,hw3al (1,irow))
            call qmassd(cwava,w(irow),q3m1(1,1,lat),
     $                  qfcst(1,1,1,lat),pdelb,hw3bl (1,irow))
         end if
C
C Fix negative q values
C
         if(.not.doslt) call qneg1(q3m1(1,1,lat),pdel)
C
C Accumulate moisture integrals
C
         call mint(irow,q3m1(1,1,lat),pspsr,rga,pdel)
#endif
C
C Write out this latitude--!!!! NOTE CONTIGUITY ASSUMPTION !!!!
C


         call writeric(nra1,bpstr,pflena,lat)

#ifdef INTERVAL_TIMER
         call interval_timer( 0, TIMER_spg_c, 0 )
#endif
   90 continue
      return
      end
