#include "params.h"
      subroutine trunc
C-----------------------------------------------------------------------
C
c compute truncation parameters.
C
C--------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pspect.com"
C--------------------------------------------------------------------
#include "comspe.com"
C--------------------------------------------------------------------
C
c trunc computes 
c pentagonal truncation
C
c 0.le.!m!.le.ptrm
c !m!.le.n.le.!m!+ptrn for !m!.le.ptrk-ptrn
c !m!.le.n.le.ptrk     for (ptrk-ptrn).le.!m!.le.ptrm
C
c particular cases:
c 1-rhomboidal truncation with  ptrk=ptrm+ptrn
c 2-trapezoidal truncation with ptrk=ptrn
c 3-triangular truncation with  ptrk=ptrm=ptrn
C
c we must have: ptrm.ge.ptrk-ptrn.ge.0
c declarations inserted by implnone
      integer m
C
      if (ptrm.lt.(ptrk-ptrn)) then
         write(6,*)'error in truncation parameters'
         write(6,*)'          ntrm.lt.(ptrk-ptrn)'
         write(6,*)' stop in subroutine trunc'
         call endrun
      else if (ptrk.lt.ptrn) then
         write(6,*)'error in truncation parameters'
         write(6,*)'          ptrk.lt.ptrn'
         write(6,*)' stop in subroutine trunc'
         call endrun
      end if
c
      nstart(1) = 0
      nlen(1) = ptrn + 1
      do m=2,ptrm+1
         nstart(m) = nstart(m-1) + nlen(m-1)
         nlen(m) = min0(ptrn+1,ptrk+2-m)
      end do
      write(6,*)'Starting index  length'
      do m=1,ptrm+1
         write(6,'(1x,i14,i8)')nstart(m),nlen(m)
      end do
c
      return
      end
